Author: Sébastien Helleu

# WeeChat user’s guide

Sébastien Helleu
flashcode@flashtux.org
version 1.7

This manual documents WeeChat chat client, it is part of WeeChat.

Latest version of this document can be found on this page: https://weechat.org/doc

## 1. Introduction

WeeChat (Wee Enhanced Environment for Chat) is a free chat client, fast and light, designed for many operating systems.

### 1.1. Features

Main features are:

- multi-protocols (mainly IRC)

- multi-servers connection (with SSL, IPv6, proxy)

- small, fast and light

- customizable and extensible with plugins and scripts

- compliant with IRC RFCs 1459, 2810, 2811, 2812 and 2813

- IRC proxy and relay for remote interfaces

- multi-platform (GNU/Linux, *BSD, MacOS X, Windows and other)

- 100% GPL, free software

WeeChat homepage is here: https://weechat.org/

### 1.2. Prerequisites

In order to install WeeChat, you need:

- a running GNU/Linux system (with compiler tools for source package), or a compatible OS

- root privileges (to install WeeChat in a system directory)

- some libraries (see dependencies)

## 2. Installation

### 2.1. Binary packages

Binary packages are available for many distributions, including:

- Arch Linux: `pacman -S weechat`

- Cygwin (Windows): select WeeChat packages in setup.exe

- Debian/Ubuntu (or any Debian compatible distribution): `apt-get install weechat-curses weechat-plugins`

- Fedora Core: `dnf install weechat`

- Gentoo: `emerge weechat`

- Mandriva/RedHat (or any RPM compatible distribution): `rpm -i /path/to/weechat-x.y.z-1.i386.rpm`

- openSUSE: `zypper in weechat`

- Sourcemage: `cast weechat`

Some additional packages may be useful, like weechat-plugins.

For other distributions, please look at your manual for installation instructions.

### 2.2. Source package

WeeChat can be compiled with cmake or autotools (cmake is recommended way).

| On OS X, you can use Homebrew: `brew install weechat --with-python --with-perl` (for help: `brew info weechat`).

#### 2.2.1. Dependencies

Following table shows list of packages that are required or optional to compile WeeChat.

Package (1) | Version | Required | Feature
--- | --- | --- | ---
C compiler (gcc, clang, …​) |  | yes | Build.
C++ compiler |  |  | Build and run tests, javascript plugin.
cmake |  | yes | Build (autotools still possible, but cmake is recommended).
pkg-config |  | yes | Detect installed libraries.
libncursesw5-dev (2) |  | yes | Ncurses interface.
libcurl4-gnutls-dev |  | yes | URL transfer.
zlib1g-dev |  | yes | Compression of packets in relay plugin (weechat protocol), script plugin.
libgcrypt20-dev |  | yes | Secured data, IRC SASL authentication (DH-BLOWFISH/DH-AES), script plugin.
libgnutls28-dev | ≥ 2.2.0 (3) |  | SSL connection to IRC server, support of SSL in relay plugin, IRC SASL authentication (ECDSA-NIST256P-CHALLENGE).
gettext |  |  | Internationalization (translation of messages; base language is English).
ca-certificates |  |  | Certificates for SSL connections.
libaspell-dev ∥ libenchant-dev |  |  | Aspell plugin.
python-dev | ≥ 2.5 (4) |  | Python plugin.
libperl-dev |  |  | Perl plugin.
ruby-2.3, ruby2.3-dev | ≥ 1.8 |  | Ruby plugin.
liblua5.3-dev |  |  | Lua plugin.
tcl-dev | ≥ 8.5 |  | Tcl plugin.
guile-2.0-dev | ≥ 2.0 |  | Guile (scheme) plugin.
libv8-dev | ≤ 3.24.3 |  | Javascript plugin.
asciidoctor | ≥ 1.5.4 |  | Build man page and documentation.
libcpputest-dev | ≥ 3.4 |  | Build and run tests.

| (1) Name comes from the Debian GNU/Linux distribution, versions and package names may be different in different distributions and versions. (2) WeeChat can compile with libncurses5-dev, but it is NOT recommended (you will have display bugs with wide chars). (3) Gnutls ≥ 3.0.21 is required for IRC SASL authentication with mechanism ECDSA-NIST256P-CHALLENGE. (4) Recommended Python version is 2.7 (all scripts run fine with version 2.7, but not with versions ≤ 2.6 or ≥ 3.0).

If you are using a Debian/Ubuntu based distribution, and if you have some "deb-src" source entries in your file /etc/apt/sources.list, you can install all dependencies with the command:

    # apt-get build-dep weechat

#### 2.2.2. Compile with cmake

- Installation in system directories (requires root privileges):

    $ mkdir build
    $ cd build
    $ cmake ..
    $ make
    % make install    (as root)

- Installation in custom directory:

    $ mkdir build
    $ cd build
    $ cmake .. -DCMAKE_INSTALL_PREFIX=/path/to/directory
    $ make
    $ make install

Options can be used for cmake, with format: "-DOPTION=VALUE".

List of commonly used options:

Option | Values | Default value | Description
--- | --- | --- | ---
`CMAKE_BUILD_TYPE` | `Debug`, `Release`, `RelWithDebInfo`, `MinSizeRel` |  | The type of build: `Debug` (or `RelWithDebInfo`) is recommended if you are running development version of WeeChat.
`CMAKE_INSTALL_PREFIX` | directory | `/usr/local` | The directory where WeeChat will be installed.
`WEECHAT_HOME` | directory | `~/.weechat` | The default home directory when running WeeChat.
`CA_FILE` | file | `/etc/ssl/certs/ca-certificates.crt` | File containing the certificate authorities. This is the default value of option weechat.network.gnutls_ca_file.
`ENABLE_ALIAS` | `ON`, `OFF` | `ON` | Compile Alias plugin.
`ENABLE_ASPELL` | `ON`, `OFF` | `ON` | Compile Aspell plugin.
`ENABLE_CHARSET` | `ON`, `OFF` | `ON` | Compile Charset plugin.
`ENABLE_MAN` | `ON`, `OFF` | `OFF` | Compile man page.
`ENABLE_DOC` | `ON`, `OFF` | `OFF` | Compile documentation (it takes a long time, recommended only if you build a binary package embedding documentation or if you can’t browse documentation online).
`ENABLE_ENCHANT` | `ON`, `OFF` | `OFF` | Compile Aspell plugin with Enchant.
`ENABLE_EXEC` | `ON`, `OFF` | `ON` | Compile Exec plugin.
`ENABLE_FIFO` | `ON`, `OFF` | `ON` | Compile Fifo plugin.
`ENABLE_GNUTLS` | `ON`, `OFF` | `ON` | Enable Gnutls (for SSL).
`ENABLE_GUILE` | `ON`, `OFF` | `ON` | Compile Guile plugin (Scheme).
`ENABLE_IRC` | `ON`, `OFF` | `ON` | Compile IRC plugin.
`ENABLE_JAVASCRIPT` | `ON`, `OFF` | `ON` | Compile Javascript plugin.
`ENABLE_LARGEFILE` | `ON`, `OFF` | `ON` | Support of large files.
`ENABLE_LOGGER` | `ON`, `OFF` | `ON` | Compile Logger plugin.
`ENABLE_LUA` | `ON`, `OFF` | `ON` | Compile Lua plugin.
`ENABLE_NCURSES` | `ON`, `OFF` | `ON` | Compile Ncurses interface.
`ENABLE_NLS` | `ON`, `OFF` | `ON` | Enable NLS (translations).
`ENABLE_PERL` | `ON`, `OFF` | `ON` | Compile Perl plugin.
`ENABLE_PYTHON` | `ON`, `OFF` | `ON` | Compile Python plugin.
`ENABLE_PYTHON3` | `ON`, `OFF` | `OFF` | Compile Python plugin using Python 3 (NOT recommended because many scripts are not compatible with Python 3).
`ENABLE_RELAY` | `ON`, `OFF` | `ON` | Compile Relay plugin.
`ENABLE_RUBY` | `ON`, `OFF` | `ON` | Compile Ruby plugin.
`ENABLE_SCRIPT` | `ON`, `OFF` | `ON` | Compile Script plugin.
`ENABLE_SCRIPTS` | `ON`, `OFF` | `ON` | Compile script plugins (Python, Perl, Ruby, Lua, Tcl, Guile, Javascript).
`ENABLE_TCL` | `ON`, `OFF` | `ON` | Compile Tcl plugin.
`ENABLE_TRIGGER` | `ON`, `OFF` | `ON` | Compile Trigger plugin.
`ENABLE_XFER` | `ON`, `OFF` | `ON` | Compile Xfer plugin.
`ENABLE_TESTS` | `ON`, `OFF` | `OFF` | Compile tests.

The other options can be displayed with this command:

    $ cmake -LA

Or with Curses interface:

    $ ccmake ..

#### 2.2.3. Compile with autotools

| Only cmake is officially supported to build WeeChat. You should use autotools only if you are not able to use cmake. Build with autotools requires more dependencies and is slower than with cmake.

- Installation in system directories (requires root privileges):

    $ ./autogen.sh
    $ mkdir build
    $ cd build
    $ ../configure
    $ make
    % make install    (as root)

- Installation in custom directory:

    $ ./autogen.sh
    $ mkdir build
    $ cd build
    $ ../configure --prefix=/path/to/directory
    $ make
    $ make install

Options can be used for configure script, they can be displayed with this command:

    $ ./configure --help

### 2.3. Git sources

Warning: git sources are for advanced users: it may not compile or not be stable. You’re warned!

To get git sources, issue this command:

    $ git clone https://github.com/weechat/weechat.git

Then follow instructions for source package (see source package).

### 2.4. Report crashes

If you experienced crashes, or if you want to report any future WeeChat crash, you have to:

- Compile it with debug info (or install binary package with debug info).

- Enable core files on your system.

- Install gdb.

#### 2.4.1. Debug info

If you’re compiling with cmake:

    $ cmake .. -DCMAKE_BUILD_TYPE=Debug

If you’re compiling with autotools, debug is default (`--with-debug=1`).

If you installed a binary package, then install package weechat-dbg.

#### 2.4.2. Core files

To enable core files, you can use option weechat.startup.sys_rlimit:

    /set weechat.startup.sys_rlimit "core:-1"

For WeeChat ≤ 0.3.8 or if you want to enable core files even before WeeChat starts, you can use `ulimit` command.

For example under Linux with bash shell, add this line to your `~/.bashrc`:

    ulimit -c unlimited

Or max size:

    ulimit -c 200000

#### 2.4.3. Get backtrace with gdb

When WeeChat crashes, your system will create a file core or core.12345 (12345 is process id). This file is created in directory where you have run WeeChat (this is not directory where WeeChat is installed!).

For example if weechat is installed in /usr/bin/ and core file is in /home/xxx/, then run gdb with this command:

    gdb /usr/bin/weechat /home/xxx/core

Then under gdb, use command `bt full` to display backtrace. You will see something like that:

    (gdb) set logging file /tmp/crash.txt
    (gdb) set logging on
    Copying output to /tmp/crash.txt.
    (gdb) bt full
    #0  0x00007f9dfb04a465 in raise () from /lib/libc.so.6
    #1  0x00007f9dfb04b8e6 in abort () from /lib/libc.so.6
    #2  0x0000000000437f66 in weechat_shutdown (return_code=1, crash=1)
        at /some_path/src/core/weechat.c:351
    #3  <signal handler called>
    #4  0x000000000044cb24 in hook_process_timer_cb (arg_hook_process=0x254eb90,
        remaining_calls=<value optimized out>) at /some_path/src/core/wee-hook.c:1364
            hook_process = 0x254eb90
            status = <value optimized out>
    #5  0x000000000044cc7d in hook_timer_exec ()
        at /some_path/src/core/wee-hook.c:1025
            tv_time = {tv_sec = 1272693881, tv_usec = 212665}
            ptr_hook = 0x2811f40
            next_hook = 0x0
    #6  0x000000000041b5b0 in gui_main_loop ()
        at /some_path/src/gui/curses/gui-curses-main.c:319
            hook_fd_keyboard = 0x173b600
            tv_timeout = {tv_sec = 0, tv_usec = 0}
            read_fds = {fds_bits = {0 <repeats 16 times>}}
            write_fds = {fds_bits = {0 <repeats 16 times>}}
            except_fds = {fds_bits = {0 <repeats 16 times>}}
            max_fd = <value optimized out>

You must report this trace to developers, and tell them what action caused this crash.

Thank you for your help!

#### 2.4.4. Debug a running WeeChat

To debug a running WeeChat (for example if WeeChat seems blocked), you can use gdb with process id (replace 12345 with PID of weechat process):

    gdb /usr/bin/weechat 12345

Then like for a crash, use command `bt full`:

    (gdb) bt full

## 3. Usage

### 3.1. Running WeeChat

Command line arguments:

-a, --no-connect

  Disable auto-connect to servers when WeeChat is starting.

-c, --colors

  Display default colors in terminal.

-d, --dir <path>

  Set path as home for WeeChat (used for configuration files, logs, user plugins and scripts), default value is "~/.weechat" (note: directory is created if not found by WeeChat). If this option is not given, the environment variable WEECHAT_HOME is used (if not empty).

-h, --help

  Display help.

-l, --license

  Display WeeChat license.

-p, --no-plugin

  Disable plugins auto-load.

-r, --run-command <command>

  Run command(s) after startup (many commands can be separated by semicolons).

-s, --no-script

  Disable scripts auto-load.

--upgrade

  Upgrade WeeChat using session files generated with command `/upgrade -quit`.

-v, --version

  Display WeeChat version.

plugin:option

  Option for a plugin.

To start WeeChat, issue this command:

    $ weechat

When you run WeeChat for the first time, a default configuration file is created, with default options. The default configuration file is: ~/.weechat/weechat.conf.

You can edit this file at your convenience to configure WeeChat or you can set parameters with `/set` command in WeeChat (see WeeChat commands).

### 3.2. Files and directories

WeeChat writes configuration files and other data in directory `~/.weechat` by default.

The directories are:

Path/file | Description
--- | ---
`~/.weechat/` | WeeChat home directory (can be changed, see Running WeeChat).
`logs/` | Log files (one file per buffer).
`python/` | Python scripts.
`autoload/` | Python scripts auto-loaded on startup (1).
`perl/` | Perl scripts.
`autoload/` | Perl scripts auto-loaded on startup (1).
`ruby/` | Ruby scripts.
`autoload/` | Ruby scripts auto-loaded on startup (1).
`lua/` | Lua scripts.
`autoload/` | Lua scripts auto-loaded on startup (1).
`tcl/` | Tcl scripts.
`autoload/` | Tcl scripts auto-loaded on startup (1).
`guile/` | Guile scripts.
`autoload/` | Guile scripts auto-loaded on startup (1).
`javascript/` | Javascript scripts.
`autoload/` | Javascript scripts auto-loaded on startup (1).

| (1) This directory often contains only symbolic links to scripts in parent directory.

The files in home directory are:

File | Description | Sensitive data
--- | --- | ---
`weechat.conf` | Main WeeChat configuration file | Possible (example: list of channels in a saved buffers layout).
`sec.conf` | Configuration file with secured data | Yes, highly sensitive: this file must never be shared with anyone.
`plugins.conf` | Plugins configuration file | Possible, depends on plugins/scripts.
`alias.conf` | Configuration file for alias plugin | Possible, depends on aliases.
`aspell.conf` | Configuration file for aspell plugin | No.
`charset.conf` | Configuration file for charset plugin | No.
`exec.conf` | Configuration file for exec plugin | No.
`irc.conf` | Configuration file for irc plugin | Yes: it can contain passwords for servers, nickserv and channels (if not stored in `sec.conf`).
`logger.conf` | Configuration file for logger plugin | No.
`relay.conf` | Configuration file for relay plugin | No.
`script.conf` | Configuration file for script plugin | No.
`trigger.conf` | Configuration file for trigger plugin | Possible, depends on triggers.
`xfer.conf` | Configuration file for xfer plugin | No.
`weechat.log` | WeeChat log file | No.

| It is not recommended to edit configuration files by hand because WeeChat may write them at any time (for example on /quit) and after any change you must run the command /reload (with the risk of losing other changes that were not yet saved with /save). You can use the command /set, which checks the value and applies immediately the changes.

### 3.3. Screen layout

Example of terminal with WeeChat:

     ▼ bar "title"
    ┌───────────────────────────────────────────────────────────────────────────┐
    │Welcome to #test, this is a test channel                                   │
    │12:52:27   --> | Flashy (flashcode@weechat.org) has joined #test   │@Flashy│
    │12:52:27    -- | Nicks #test: [@Flashy @joe +weebot peter]         │@joe   │
    │12:52:27    -- | Channel #test: 4 nicks (2 ops, 1 voice, 1 normal) │+weebot│
    │12:52:27    -- | Channel created on Tue Jan 27 06:30:17 2009       │peter  │
    │12:54:15 peter | hey!                                              │       │
    │12:55:01  @joe | hello                                             │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │[12:55] [6] [irc/freenode] 3:#test(+n){4}* [H: 4:#abc(2,5), 6]             │
    │[@Flashy(i)] hi peter!█                                                    │
    └───────────────────────────────────────────────────────────────────────────┘
     ▲ bars "status" and "input"                               bar "nicklist" ▲

Screen is composed by following areas:

- chat area (middle of screen) with chat lines, and for each line:

  - time

  - prefix (before "|")

  - message (after "|")

- bars around chat area, default bars are:

  - title bar, above chat area

  - status bar, below chat area

  - input bar, below status bar

  - nicklist bar, on the right

Bar status has following default items:

Item | Example | Description
--- | --- | ---
time | `[12:55]` | Time.
buffer_last_number | `[6]` | Number of last buffer in list.
buffer_plugin | `[irc/freenode]` | Plugin of current buffer (irc plugin can add IRC server name used by buffer).
buffer_number | `3` | Current buffer number.
buffer_name | `#test` | Current buffer name.
buffer_modes | `+n` | IRC channel modes.
buffer_nicklist_count | `{4}` | Number of nicks in nicklist.
buffer_zoom | ! | `!` means the merged buffer is zoomed (only this one is displayed), empty value means all merged buffers are displayed.
buffer_filter | `*` | Filtering indicator: `*` means some lines are filtered (hidden), empty value means all lines are displayed.
scroll | `-MORE(50)-` | Scroll indicator, with number of lines below last line displayed.
lag | `[Lag: 2.5]` | Lag indicator, in seconds (hidden if lag is low).
hotlist | `[H: 4:#abc(2,5), 6]` | List of buffers with activity (unread messages) (in example, 2 highlights and 5 unread messages on #abc, one unread message on buffer #6).
completion | `abc(2) def(5)` | List of words for completion, with number of possible completions for each word.

Bar input has following default items:

Item | Example | Description
--- | --- | ---
input_prompt | `[@Flashy(i)]` | Input prompt, for irc: nick and modes (mode "+i" means invisible on freenode)
away | `(away)` | Away indicator
input_search | `[Search (~ str,msg)]` | Search indicator (“~”: case insensitive, “==”: case sensitive, “str”: search string, “regex”: search regular expression, “msg”: search in messages, “pre”: search in prefixes, “pre|msg”: search in prefixes and messages)
input_paste | `[Paste 7 lines ? [ctrl-Y] Yes [ctrl-N] No]` | Question to user for pasting lines
input_text | `hi peter!` | Input text

Other items available (not used in bars by default):

Item | Example | Description
--- | --- | ---
aspell_dict | `fr,en` | Spelling dictionaries used on current buffer.
aspell_suggest | `print,prone,prune` | Spelling suggestions for word under cursor (if misspelled).
buffer_count | `10` | Total number of buffers opened.
buffer_short_name | `#test` | Current buffer short name.
irc_channel | `#test` | Current IRC channel name.
irc_nick_modes | `@` | IRC modes for self nick.
mouse_status | `M` | Mouse status (empty if mouse is disabled).
window_number | `2` | Current window number.

### 3.4. Command line

WeeChat command line (at the bottom of window) lets you execute commands or send text to buffer.

#### 3.4.1. Syntax

Commands begin with "/" char, followed by name of command. For example, to see list of all options:

    /set

Text sent to a buffer is any text that does not begin with "/" char. For example, to send text hello on current buffer:

    hello

However, it is possible to start with "/" char, by adding another. For example, to send text `/set` on current buffer:

    //set

#### 3.4.2. Color codes

For some plugins like IRC, you can use color codes and attributes, as follow (press `Ctrl`+`c` then following letter, with optional value):

Key | Description
--- | ---
`Ctrl`+`c`, `b` | Bold text.
`Ctrl`+`c`, `c`, `xx` | Text color `xx` (see list of colors below).
`Ctrl`+`c`, `c`, `xx`, `,`, `yy` | Text color `xx` and background `yy` (see list of colors below).
`Ctrl`+`c`, `i` | Italic text.
`Ctrl`+`c`, `o` | Disable color and attributes.
`Ctrl`+`c`, `v` | Reverse video (revert text color with background).
`Ctrl`+`c`, `_` | Underlined text.

| The same code (without number for `Ctrl`+`c`, `c`) can be used to stop the attribute.

Color codes for `Ctrl`+`c`, `c` are:

IRC color | WeeChat color
--- | ---
`00` | white
`01` | black
`02` | blue
`03` | green
`04` | lightred
`05` | red
`06` | magenta
`07` | brown
`08` | yellow
`09` | lightgreen
`10` | cyan
`11` | lightcyan
`12` | lightblue
`13` | lightmagenta
`14` | darkgray
`15` | gray
`16` | 52
`17` | 94
`18` | 100
`19` | 58
`20` | 22
`21` | 29
`22` | 23
`23` | 24
`24` | 17
`25` | 54
`26` | 53
`27` | 89
`28` | 88
`29` | 130
`30` | 142
`31` | 64
`32` | 28
`33` | 35
`34` | 30
`35` | 25
`36` | 18
`37` | 91
`38` | 90
`39` | 125
`40` | 124
`41` | 166
`42` | 184
`43` | 106
`44` | 34
`45` | 49
`46` | 37
`47` | 33
`48` | 19
`49` | 129
`50` | 127
`51` | 161
`52` | 196
`53` | 208
`54` | 226
`55` | 154
`56` | 46
`57` | 86
`58` | 51
`59` | 75
`60` | 21
`61` | 171
`62` | 201
`63` | 198
`64` | 203
`65` | 215
`66` | 227
`67` | 191
`68` | 83
`69` | 122
`70` | 87
`71` | 111
`72` | 63
`73` | 177
`74` | 207
`75` | 205
`76` | 217
`77` | 223
`78` | 229
`79` | 193
`80` | 157
`81` | 158
`82` | 159
`83` | 153
`84` | 147
`85` | 183
`86` | 219
`87` | 212
`88` | 16
`89` | 233
`90` | 235
`91` | 237
`92` | 239
`93` | 241
`94` | 244
`95` | 247
`96` | 250
`97` | 254
`98` | 231
`99` | default

| To show all available colors in your terminal, you can do `/color` then `Alt`+`c` in WeeChat or run this command in terminal: `weechat --colors`.

Example: display of "hello everybody!" with "hello" in light blue bold and "everybody" in light red underlined:

    ^Cc12^Cbhello ^Cb^Cc04^C_everybody^C_^Cc!

| In irc plugin, you can remap these colors using option irc.color.mirc_remap.

### 3.5. Colors

WeeChat can use up to 256 color pairs to display text in bars and chat area (your terminal must support 256 colors to use them in WeeChat).

According to value of TERM environment variable, you may have following limits for colors in WeeChat:

$TERM | Colors | Pairs
--- | --- | ---
"rxvt-unicode", "xterm", …​ | 88 | 256
"rxvt-256color", "xterm-256color", …​ | 256 | 256
"screen" | 8 | 64
"screen-256color" | 256 | 256
"tmux" | 8 | 64
"tmux-256color" | 256 | 256

You can run `weechat --colors` or use command `/color` in WeeChat to display limits for your environment.

Some recommended values for TERM if you want 256 colors:

- under screen: screen-256color

- under tmux: screen-256color or tmux-256color

- outside screen/tmux: xterm-256color, rxvt-256color, putty-256color, …​

| You may have to install package "ncurses-term" to use these values in TERM variable.

If you are using screen, you can add this line to your ~/.screenrc:

    term screen-256color

If your TERM variable has wrong value and that WeeChat is already running, you can change it with these two commands:

    /set env TERM screen-256color
    /upgrade

#### 3.5.1. Basic colors

Basic colors in WeeChat are:

Name | Color
--- | ---
`default` | Default terminal color (transparent for background)
`black` | Black
`darkgray` | Dark gray
`red` | Dark red
`lightred` | Light red
`green` | Dark green
`lightgreen` | Light green
`brown` | Brown
`yellow` | Yellow
`blue` | Dark blue
`lightblue` | Light blue
`magenta` | Dark magenta
`lightmagenta` | Light magenta
`cyan` | Dark cyan
`lightcyan` | Light cyan
`gray` | Gray
`white` | White

#### 3.5.2. Extended colors

WeeChat dynamically allocates color pairs when colors are used on screen (to display buffers and bars).

In addition to basic colors, you can use a color number between 1 and the limit of your terminal.

Use command `/color` to see current colors and limits. With `Alt`+`c` you can temporarily switch to terminal colors to choose a color.

For example if you want to display time in orange in buffer, do:

    /set weechat.color.chat_time 214

Or if you want a very dark green background for status bar:

    /set weechat.bar.status.color_bg 22

#### 3.5.3. Aliases

You can add color aliases with command `/color alias` and then use this alias in any color option.

For example:

    /color alias 214 orange
    /set weechat.color.chat_delimiters orange

#### 3.5.4. Attributes

It is possible to use some attributes for colors. One or more attributes can be added before color name or number:

- `*` : bold text

- `!` : reverse video

- `/` : italic

- `_` : underlined text

- `|` : keep attributes: do not reset bold/reverse/italic/underlined when changing color

For example if you want self nick as white underlined, do:

    /set weechat.color.chat_nick_self _white

Or if you want time in status bar as orange underlined with bold:

    /set weechat.color.status_time *_214

To use an attribute with default terminal color (-1), you must use a number greater than last terminal color, for example max color in WeeChat: 99999.

Example of bold with terminal foreground color:

    /set weechat.color.status_time *99999

### 3.6. Buffers and windows

A buffer is composed by a number, a name, lines displayed (and some other data).

Examples of buffers:

- core buffer (created by WeeChat on startup, can not be closed)

- irc server (displays messages from server)

- irc channel

- irc private messages

A window is a screen area which displays a buffer. It is possible to split your screen into many windows.

Each window displays one buffer. A buffer can be hidden (not displayed by a window) or displayed by one or more windows.

Example of horizontal split (`/window splith`):

                              ▼ window #2 (buffer #4)
    ┌───────────────────────────────────────────────────────────────────────────┐
    │Welcome to #abc                                                            │
    │12:55:12     Max | hi                                              │@Flashy│
    │12:55:20 @Flashy | hi Max!                                         │Max    │
    │12:55:32     Max | how are you?                                    │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │[12:55] [6] [irc/freenode] 4:#abc(+n){2}                                   │
    │[@Flashy]                                                                  │
    │───────────────────────────────────────────────────────────────────────────│
    │Welcome to #test                                                           │
    │12:54:15 peter | hey!                                              │@Flashy│
    │12:55:01  @joe | hello                                             │@joe   │
    │                                                                   │+weebot│
    │                                                                   │peter  │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │[12:55] [6] [irc/freenode] 3:#test(+n){4}                                  │
    │[@Flashy] hi peter!█                                                       │
    └───────────────────────────────────────────────────────────────────────────┘
                              ▲ window #1 (buffer #3)

Example of vertical split (`/window splitv`):

    ┌───────────────────────────────────────────────────────────────────────────┐
    │Welcome to #test                     │Welcome to #abc                      │
    │12:54:15 peter | hey!        │@Flashy│12:55:12     Max | hi        │@Flashy│
    │12:55:01  @joe | hello       │@joe   │12:55:20 @Flashy | hi Max!   │Max    │
    │                             │+weebot│                             │       │
    │                             │peter  │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │[12:55] [irc/oftc] 3:#test(+n){4}    │[12:55] [irc/oftc] 4:#abc(+n){2}     │
    │[@Flashy] hi peter!█                 │[@Flashy]                            │
    └───────────────────────────────────────────────────────────────────────────┘
          ▲ window #1 (buffer #3)               ▲ window #2 (buffer #4)

Example of vertical + horizontal splits:

                                                ▼ window #3 (buffer #5)
    ┌───────────────────────────────────────────────────────────────────────────┐
    │Welcome to #test                     │Welcome to #def                      │
    │12:54:15 peter | hey!        │@Flashy│12:55:42 @Flashy | hi        │@Flashy│
    │12:55:01  @joe | hello       │@joe   │12:55:56    alex | hi Flashy │alex   │
    │                             │+weebot│                             │       │
    │                             │peter  │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │[12:55] [irc/oftc] 5:#def(+n){2}     │
    │                             │       │[@Flashy]                            │
    │                             │       │─────────────────────────────────────│
    │                             │       │Welcome to #abc                      │
    │                             │       │12:55:12     Max | hi        │@Flashy│
    │                             │       │12:55:20 @Flashy | hi Max!   │Max    │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │                             │       │                             │       │
    │[12:55] [irc/oftc] 3:#test(+n){4}    │[12:55] [irc/oftc] 4:#abc(+n){2}     │
    │[@Flashy] hi peter!█                 │[@Flashy]                            │
    └───────────────────────────────────────────────────────────────────────────┘
          ▲ window #1 (buffer #3)               ▲ window #2 (buffer #4)

### 3.7. Buffers lines

#### 3.7.1. Format of lines

Lines displayed in formatted buffers have following fields:

Field | Displayed | Description
--- | --- | ---
date/time (message) | Yes | Date/time of message (may be past).
date/time (print) | No | Date/time when WeeChat prints the message.
prefix | Yes | Prefix of message, commonly a nick.
message | Yes | The message itself.
displayed | No | Boolean: true if line is displayed, false if line is filtered with command /filter.
highlight | No | Boolean: true if line has a highlight, false otherwise.
tags | With `/debug tags` | Tags associated with the line (see lines tags).

The display of lines can be customized with many look options (weechat.look.*) and color options (weechat.color.chat_*).

#### 3.7.2. Lines tags

WeeChat uses tags in lines for different purposes:

- highlight

- notify level

- logging

- use of command /filter

Tags can be displayed with the command `/debug tags` (same command to hide them).

Tags commonly used (non-exhaustive list):

Tag | Description
--- | ---
`no_filter` | Line can not be filtered.
`no_highlight` | No highlight is possible on line.
`no_log` | Line is not written in log file.
`log0 …​ log9` | Level of log for line (see `/help logger`).
`notify_none` | Buffer with line is not added to hotlist.
`notify_message` | Buffer with line is added to hotlist with level "message".
`notify_private` | Buffer with line is added to hotlist with level "private".
`notify_highlight` | Buffer with line is added to hotlist with level "highlight".
`self_msg` | Self message.
`nick_xxx` | Message is from nick "xxx".
`prefix_nick_ccc` | Prefix is a nick with color "ccc".
`host_xxx` | Username and host in message.
`irc_xxx` | IRC message "xxx" (can be a command or a 3-digits number).
`irc_numeric` | IRC numeric message.
`irc_error` | Error from IRC server.
`irc_action` | Action from a nick (command `/me`).
`irc_ctcp` | CTCP message.
`irc_ctcp_reply` | Reply to CTCP message.
`irc_smart_filter` | IRC message that can be filtered with the "smart filter".
`away_info` | Message with away info.

### 3.8. Bars

A bar is an area beside the chat that can contain any type of text.

The bar options can be set with options `weechat.bar.name.option` where `name` is the name of the bar and `option` the option for this bar.

List of bar options:

Option | Values | Description
--- | --- | ---
`type` | `root`, `window` | A bar with type `root` is displayed exactly one time on screen, outside all windows. There is no root bar by default, but an example is the bar buffers created by script buffers.pl (sidebar with list of buffers). A bar with type `window` is displayed in each window, for example if you split one time the screen (with `/window splith` or `/window splitv`), you will have one bar in each window. The four default bars (title, status, input, nicklist) have type `window`.
`position` | `top`, `bottom`, `left`, `right` | Position of the bar: above/below chat, on the left/right.
`priority` | integer ≥ 0 | Priority for display of bar: this is used for ordering the bars on screen when many bars have same type and position. The bars are displayed from the edge of the screen to the center. A higher priority will display bar at the beginning, so closer to the edge. Example: input bar has priority 1000, so it is displayed before the status bar, which has priority 500.
`size` | integer ≥ 0 | The size of the bar: number of columns for position left/right, number of lines for position top/bottom. A size of `0` means automatic, so the size will be computed according to content displayed in bar.
`size_max` | integer ≥ 0 | The maximum size for a bar, `0` = no limit (this option is used only if `size` = `0`).
`color_bg` | color | The default background color for the bar.
`color_fg` | color | The default text color for the bar.
`color_delim` | color | The color for delimiters in bar.
`hidden` | `on`, `off` | When option is `on`, the bar is hidden. Note: instead of changing this option, the command `/bar` is preferred, for example: `/bar toggle nicklist` (see command /bar).
`separator` | `on`, `off` | When option is `on`, a separator (line) is displayed between this bar and other bars (or chat).
`items` | string | A list of items (see items for more info).
`filling_left_right` | `horizontal`, `vertical`, `columns_horizontal`, `columns_vertical` | Type of filling for a bar which has position `left` or `right` (see filling for more info).
`filling_top_bottom` | `horizontal`, `vertical`, `columns_horizontal`, `columns_vertical` | Type of filling for a bar which has position `top` or `bottom` (see filling for more info).
`conditions` | string | The conditions to display the bar (see conditions for more info).

#### 3.8.1. Items

The option items is a string with a list of bar items, separated by a comma (space between items on screen) or "+" (glued items).

The list of bar items is displayed with command `/bar listitems`.

Before or after item name, you can use chars (that are not alphanumeric, "-" or ""). They will be displayed before/after item with the delimiters color defined in bar (option _color_delim).

Example of bar with items "[time],buffer_number+:+buffer_plugin+.+buffer_name":

    ┌───────────────────────────────────────────────────────────────────────────┐
    │[12:55] 3:irc/freenode.#weechat                                            │
    └───────────────────────────────────────────────────────────────────────────┘

A special syntax can be used to force the buffer used when displaying the bar item: "@buffer:item" (where "buffer" is the full name of buffer and "item" is the name of a bar item).

This is useful in root bars, to display item for a specific buffer which is not displayed in the current window (or even not displayed at all).

Example: nicklist of bitlbee in a root bar (if the bar is called bitlist and if bitlbee server is called bitlbee):

    /set weechat.bar.bitlist.items "@irc.bitlbee.&bitlbee:buffer_nicklist"

#### 3.8.2. Filling

There are four types of filling:

- `horizontal`: the items are displayed horizontally, from left to right. If there are new lines in items, a space is used to separate lines.

- `vertical`: the items are displayed from top to bottom. If there are new lines in items, a new line is used to separate lines.

- `columns_horizontal`: items are displayed using columns, where text is aligned on the left. The first item is on top left, the second is on same line, on the right.

- `columns_vertical`: items are displayed using columns, where text is aligned on the left. The first item is on top left, the second is one line below.

Default bars title, status and input have horizontal filling, and default bar nicklist has vertical filling.

Some examples of filling for bar nicklist:

    ┌───────────────────────────────────────────────────────────────────────┐
    │Welcome to #test, this is a test channel                               │
    │12:54:15 peter | hey!                                         │@carl   │
    │12:55:01  +Max | hello                                        │@jessika│
    │                                                              │@maddy  │
    │                                                              │%Diego  │
    │                                                              │%Melody │
    │                                                              │+Max    │
    │                                                              │ celia  │
    │                                                              │ Eva    │
    │                                                              │ freddy │
    │                                                              │ Harold^│
    │                                                              │ henry4 │
    │                                                              │ jimmy17│
    │                                                              │ jodie ▼│
    │[12:55] [6] [irc/freenode] 3:#test(+n){24}                             │
    │[@carl] █                                                              │
    └───────────────────────────────────────────────────────────────────────┘
                                         filling_left_right = vertical ▲

    ┌───────────────────────────────────────────────────────────────────────┐
    │Welcome to #test, this is a test channel                               │
    │12:54:15 peter | hey!                                │@carl     lee    │
    │12:55:01  +Max | hello                               │@jessika  louise │
    │                                                     │@maddy    mario  │
    │                                                     │%Diego    mark   │
    │                                                     │%Melody   peter  │
    │                                                     │+Max      Rachel │
    │                                                     │ celia    richard│
    │                                                     │ Eva      sheryl │
    │                                                     │ freddy   Vince  │
    │                                                     │ Harold^  warren │
    │                                                     │ henry4   zack   │
    │                                                     │ jimmy17         │
    │                                                     │ jodie           │
    │[12:55] [6] [irc/freenode] 3:#test(+n){24}                             │
    │[@carl] █                                                              │
    └───────────────────────────────────────────────────────────────────────┘
                                 filling_left_right = columns_vertical ▲

    ┌───────────────────────────────────────────────────────────────────────┐
    │@carl    %Diego    celia    Harold^  jodie    mario    Rachel   Vince  │
    │@jessika %Melody   Eva      henry4   lee      mark     richard  warren │
    │@maddy   +Max      freddy   jimmy17  louise   peter    sheryl   zack   │
    │───────────────────────────────────────────────────────────────────────│
    │                                                                       │
            filling_top_bottom = columns_vertical ▲

    ┌───────────────────────────────────────────────────────────────────────┐
    │@carl    @jessika @maddy   %Diego   %Melody  +Max      celia    Eva    │
    │ freddy   Harold^  henry4   jimmy17  jodie    lee      louise   mario  │
    │ mark     peter    Rachel   richard  sheryl   Vince    warren   zack   │
    │───────────────────────────────────────────────────────────────────────│
    │                                                                       │
          filling_top_bottom = columns_horizontal ▲

#### 3.8.3. Conditions

The option conditions is a string which is evaluated to know if the bar must be displayed or not.

The string can be:

- active: the window must be active

- inactive: the window must be inactive

- nicklist: the buffer displayed in window must have a nicklist

- an expression: it is evaluated as boolean (see command /eval)

For the expression, following variables are available:

- `${active}`: true if window is active

- `${inactive}`: true if window is inactive

- `${nicklist}`: true if buffer displayed in window has a nicklist

Following pointers are available:

- `${window}`: the window where condition is evaluated

- `${buffer}`: the buffer of window where condition is evaluated

Example to display nicklist bar in all buffers with a nicklist, and only if width of window is > 100 :

    /set weechat.bar.nicklist.conditions "${nicklist} && ${window.win_width} > 100"

Same condition, but always display nicklist on buffer &bitlbee (even if window is small):

    /set weechat.bar.nicklist.conditions "${nicklist} && (${window.win_width} > 100 || ${buffer.full_name} == irc.bitlbee.&bitlbee)"

### 3.9. Bare display

A special display, called "bare display" can be used for easy click on long URLs and selection of text (using the mouse).

The bare display has following features:

- It displays only the content of current buffer: no window split neither bars (no title, nicklist, status, input, …​).

- The WeeChat mouse support is disabled (if it was enabled): you can use your mouse like you do in the terminal to click on URLs and select text.

- Ncurses is not used, therefore URLs are not cut at the end of lines.

The default key to enabled bare display is `Alt`+`l`, and same key to exit (or by default anything changing the input will exit the bare display, see option weechat.look.bare_display_exit_on_input).

The time format can be customized with the option weechat.look.bare_display_time_format.

The bare display can be enabled for a specific delay using the command /window.

If WeeChat looks like that:

    ┌───────────────────────────────────────────────────────────────────────────┐
    │Welcome to #test, this is a test channel                                   │
    │12:52:27   --> | Flashy (flashcode@weechat.org) has joined #test   │@Flashy│
    │12:52:27    -- | Nicks #test: [@Flashy @joe +weebot peter]         │@joe   │
    │12:52:27    -- | Channel #test: 4 nicks (2 ops, 1 voice, 1 normal) │+weebot│
    │12:52:27    -- | Channel created on Tue Jan 27 06:30:17 2009       │peter  │
    │12:54:15 peter | hey!                                              │       │
    │12:55:01  @joe | peter: hook_process: https://weechat.org/files/do │       │
    │               | c/devel/weechat_plugin_api.en.html#_weechat_hook_ │       │
    │               | process                                           │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │                                                                   │       │
    │[12:55] [6] [irc/freenode] 3:#test(+n){4}* [H: 4:#abc(2,5), 6]             │
    │[@Flashy(i)] hi peter!█                                                    │
    └───────────────────────────────────────────────────────────────────────────┘

The screen will look like that in bare display:

    ┌───────────────────────────────────────────────────────────────────────────┐
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │                                                                           │
    │12:52 --> Flashy (flashcode@weechat.org) has joined #test                  │
    │12:52 -- Nicks #test: [@Flashy @joe +weebot peter]                         │
    │12:52 -- Channel #test: 4 nicks (2 ops, 1 voice, 1 normal)                 │
    │12:52 -- Channel created on Tue Jan 27 06:30:17 2009                       │
    │12:54 <peter> hey!                                                         │
    │12:55 <@joe> peter: hook_process: https://weechat.org/files/doc/devel/weech│
    │at_plugin_api.en.html#_weechat_hook_process                                │
    └───────────────────────────────────────────────────────────────────────────┘

So you can click the URL from joe without any problem in your terminal (of course this supposes that your terminal supports click on URLs).

### 3.10. Notify levels

#### 3.10.1. Setup notify levels

Four levels are possible in messages displayed in buffers, from lower to higher:

- low: message with low importance (for example irc join/part/quit)

- message: message from a user

- private: message in a private buffer

- highlight: message with highlight

Each buffer has a notify level, which is used to decide what messages will add buffer in hotlist.

The default notify level can be set using option weechat.look.buffer_notify_default, default is all.

Notify level | Level of messages added to hotlist
--- | ---
`none` | (none)
`highlight` | highlight + private
`message` | highlight + private + message
`all` | highlight + private + message + low

Notify level can be defined for a set of buffers, for example all buffers of irc server "freenode":

    /set weechat.notify.irc.freenode message

Set notify level highlight on channel "#weechat" only:

    /set weechat.notify.irc.freenode.#weechat highlight

The notify level for a buffer can be set with command `/buffer`:

    /buffer notify highlight

#### 3.10.2. Max hotlist level for nicks

It is possible to set max hotlist level for some nicks, per buffer, or per group of buffers (like IRC servers).

The buffer property "hotlist_max_level_nicks" can be set with a list of nicks and for each nick the max hotlist level to trigger, possible levels are:

- -1: no hotlist changes for nick

- 0: low priority (like join/part messages)

- 1: message

- 2: private message

- 3: highlight (in fact useless, since it’s already the default max for all messages)

For example to disable highlights from "joe" and "mike" on current buffer:

    /buffer set hotlist_max_level_nicks_add joe:2,mike:2

| The buffer property "hotlist_max_level_nicks" is not saved in configuration. You can easily save it with the script buffer_autoset.py: you can install it with `/script install buffer_autoset.py` and get help with `/help autosetbuffer`.

### 3.11. Highlights

#### 3.11.1. Add words to highlight

By default, WeeChat highlights messages from other users containing your nick, therefore the highlight depends on the buffer (the nick can be different from one buffer to another).

You can add other words to highlight with the option weechat.look.highlight, for example to highlight your nick and "word1", "word2" and all words beginning with "test":

    /set weechat.look.highlight word1,word2,test*

If you need a more specific rule for the word, you can use regular expressions with the option weechat.look.highlight_regex, for example to highlight words "flashcode", "flashcöde" and "flashy":

    /set weechat.look.highlight_regex flashc[oö]de|flashy

The delimiters around words to highlight can be customized with the option weechat.look.word_chars_highlight.

#### 3.11.2. Add tags to highlight

Lines displayed can contain "tags", which give some info about the origin of message or the message itself.
You can display tags with the command `/debug tags` (same command to hide them).

You can add specific tags to highlight with the option weechat.look.highlight_tags. Tags are separated by commas, and multiple tags can be separated by "+" to do a logical "and" between them.

For example to highlight all messages from nick "FlashCode" and all notices from nicks beginning with "toto":

    /set weechat.look.highlight_tags "nick_flashcode,irc_notice+nick_toto*"

#### 3.11.3. Set extra highlights on buffer

You can force highlight using a regular expression with the buffer property "highlight_regex".

For example to force the highlight on all messages in the current buffer:

    /buffer set highlight_regex .*

| The buffer property "highlight_regex" is not saved in configuration. You can easily save it with the script buffer_autoset.py: you can install it with `/script install buffer_autoset.py` and get help with `/help autosetbuffer`.

### 3.12. Default key bindings

#### 3.12.1. Keys for command line

Key | Description | Command
--- | --- | ---
`←` `Ctrl`+`b` | Go to previous char in command line. | `/input move_previous_char`
`→` `Ctrl`+`f` | Go to next char in command line. | `/input move_next_char`
`Ctrl`+`←` `Alt`+`b` | Go to previous word in command line. | `/input move_previous_word`
`Ctrl`+`→` `Alt`+`f` | Go to next word in command line. | `/input move_next_word`
`Home` `Ctrl`+`a` | Go to the beginning of command line. | `/input move_beginning_of_line`
`End` `Ctrl`+`e` | Go to the end of command line. | `/input move_end_of_line`
`Ctrl`+`c`, `b` | Insert code for bold text. | `/input insert \x02`
`Ctrl`+`c`, `c` | Insert code for colored text. | `/input insert \x03`
`Ctrl`+`c`, `i` | Insert code for italic text. | `/input insert \x1D`
`Ctrl`+`c`, `o` | Insert code for color reset. | `/input insert \x0F`
`Ctrl`+`c`, `v` | Insert code for reverse color. | `/input insert \x16`
`Ctrl`+`c`, `_` | Insert code for underlined text. | `/input insert \x1F`
`Del` `Ctrl`+`d` | Delete next char in command line. | `/input delete_next_char`
`Backsp.` `Ctrl`+`h` | Delete previous char in command line. | `/input delete_previous_char`
`Ctrl`+`k` | Delete from cursor until end of command line (deleted string is copied to the internal clipboard). | `/input delete_end_of_line`
`Ctrl`+`r` | Search for text in buffer history (see keys for search context). | `/input search_text_here`
`Ctrl`+`t` | Transpose chars. | `/input transpose_chars`
`Ctrl`+`u` | Delete from cursor until beginning of command line (deleted string is copied to the internal clipboard). | `/input delete_beginning_of_line`
`Ctrl`+`w` | Delete previous word of command line (deleted string is copied to the internal clipboard). | `/input delete_previous_word`
`Ctrl`+`y` | Paste the internal clipboard content. | `/input clipboard_paste`
`Ctrl`+`_` | Undo last action on command line. | `/input undo`
`Alt`+`_` | Redo last action on command line. | `/input redo`
`Tab` | Complete command or nick (`Tab` again: find next completion). | `/input complete_next`
`Shift`+`Tab` | Without completion: do a partial completion, with pending completion: complete with previous completion. | `/input complete_previous`
`Enter` `Ctrl`+`j` `Ctrl`+`m` | Execute command or send message (in search mode: stop search). | `/input return`
`↑` | Call previous command/message (in search mode: search up). | `/input history_previous`
`↓` | Call next command/message (in search mode: search down). | `/input history_next`
`Ctrl`+`↑` | Call previous command/message in global history (common for all buffers). | `/input history_global_previous`
`Ctrl`+`↓` | Call next command/message in global history (common for all buffers). | `/input history_global_next`
`Alt`+`d` | Delete next word in command line (deleted string is copied to the internal clipboard). | `/input delete_next_word`
`Alt`+`k` | Grab a key and insert its code (and command bound if key exists) in command line. | `/input grab_key_command`
`Alt`+`r` | Delete entire command line. | `/input delete_line`
`Alt`+`s` | Toggle aspell. | `/mute aspell toggle`

#### 3.12.2. Keys for buffers / windows

Key | Description | Command
--- | --- | ---
`Ctrl`+`l` | Redraw whole window. | `/window refresh`
`Ctrl`+`s`, `Ctrl`+`u` | Set unread marker on all buffers. | `/input set_unread`
`Ctrl`+`x` | Switch current buffer if buffers are attached with same number. | `/input switch_active_buffer`
`Alt`+`x` | Zoom on merged buffer (`Alt`+`x` again: display all merged buffers). | `/input zoom_merged_buffer`
`PgUp` | Scroll up one page in buffer history. | `/window page_up`
`PgDn` | Scroll down one page in buffer history. | `/window page_down`
`Alt`+`PgUp` | Scroll up a few lines in buffer history. | `/window scroll_up`
`Alt`+`PgDn` | Scroll down a few lines in buffer history. | `/window scroll_down`
`Alt`+`Home` | Scroll to top of buffer. | `/window scroll_top`
`Alt`+`End` | Scroll to bottom of buffer. | `/window scroll_bottom`
`Alt`+`←` `Alt`+`↑` `Ctrl`+`p` `F5` | Switch to previous buffer. | `/buffer -1`
`Alt`+`→` `Alt`+`↓` `Ctrl`+`n` `F6` | Switch to next buffer. | `/buffer +1`
`F7` | Switch to previous window. | `/window -1`
`F8` | Switch to next window. | `/window +1`
`F9` | Scroll buffer’s title on the left. | `/bar scroll title * -30%`
`F10` | Scroll buffer’s title on the right. | `/bar scroll title * +30%`
`F11` | Scroll up one page in nicklist. | `/bar scroll nicklist * -100%`
`F12` | Scroll down one page in nicklist. | `/bar scroll nicklist * +100%`
`Alt`+`F11` | Go to the beginning of nicklist. | `/bar scroll nicklist * b`
`Alt`+`F12` | Go to the end of nicklist. | `/bar scroll nicklist * e`
`Alt`+`a` | Switch to next buffer with activity (with priority: highlight, message, other). | `/input jump_smart`
`Alt`+`h` | Clear hotlist (activity notification on other buffers). | `/input hotlist_clear`
`Alt`+`j`, `Alt`+`f` | Switch to first buffer. | `/buffer -`
`Alt`+`j`, `Alt`+`l` | Switch to last buffer. | `/buffer +`
`Alt`+`j`, `Alt`+`r` | Switch to IRC raw buffer. | `/server raw`
`Alt`+`j`, `Alt`+`s` | Switch to IRC server buffer. | `/server jump`
`Alt`+`0…​9` | Switch to buffer by number (0 = 10). | `/buffer *N`
`Alt`+`j`, `01…​99` | Switch to buffer by number. | `/buffer *NN`
`Alt`+`l` | Toggle bare display on/off. | `/window bare`
`Alt`+`m` | Toggle mouse. | `/mouse toggle`
`Alt`+`n` | Scroll to next highlight. | `/window scroll_next_highlight`
`Alt`+`p` | Scroll to previous highlight. | `/window scroll_previous_highlight`
`Alt`+`u` | Scroll to first unread line in buffer. | `/window scroll_unread`
`Alt`+`w`, `Alt`+`↑` | Switch to window above. | `/window up`
`Alt`+`w`, `Alt`+`↓` | Switch to window below. | `/window down`
`Alt`+`w`, `Alt`+`←` | Switch to window on the left. | `/window left`
`Alt`+`w`, `Alt`+`→` | Switch to window on the right. | `/window right`
`Alt`+`w`, `Alt`+`b` | Balance the sizes of all windows. | `/window balance`
`Alt`+`w`, `Alt`+`s` | Swap buffers of two windows. | `/window swap`
`Alt`+`z` | Zoom on current window (`Alt`+`z` again: restore initial windows state, before zoom). | `/window zoom`
`Alt`+`<` | Switch to previous buffer in list of visited buffers. | `/input jump_previously_visited_buffer`
`Alt`+`>` | Switch to next buffer in list of visited buffers. | `/input jump_next_visited_buffer`
`Alt`+`/` | Switch to last buffer displayed (before last jump to a buffer). | `/input jump_last_buffer_displayed`
`Alt`+`=` | Toggle filters on/off. | `/filter toggle`
`Alt`+`-` | Toggle filters on/off in current buffer. | `/filter toggle @`

#### 3.12.3. Keys for "search" context

These keys are used in context "search" (when `Ctrl`+`r` is pressed to search text in buffer).

Key | Description | Command
--- | --- | ---
`Ctrl`+`r` | Switch search type: string (default), regular expression. | `/input search_switch_regex`
`Alt`+`c` | Switch exact case for search. | `/input search_switch_case`
`Tab` | Switch search in: messages (default), prefixes, prefixes + messages. | `/input search_switch_where`
`↑` | Search previous line. | `/input search_previous`
`↓` | Search next line. | `/input search_next`
`Enter` `Ctrl`+`j` `Ctrl`+`m` | Stop search at current position. | `/input search_stop_here`
`Ctrl`+`q` | Stop search and scroll to bottom of buffer. | `/input search_stop`

#### 3.12.4. Keys for "cursor" context

These keys are used in context "cursor" (free movement of cursor on screen).

Key | Area | Description | Command
--- | --- | --- | ---
`↑` | - | Move cursor one line up. | `/cursor move up`
`↓` | - | Move cursor one line down. | `/cursor move down`
`←` | - | Move cursor one column left. | `/cursor move left`
`→` | - | Move cursor one column right. | `/cursor move right`
`Alt`+`↑` | - | Move cursor one area up. | `/cursor move area_up`
`Alt`+`↓` | - | Move cursor one area down. | `/cursor move area_down`
`Alt`+`←` | - | Move cursor one area left. | `/cursor move area_left`
`Alt`+`→` | - | Move cursor one area right. | `/cursor move area_right`
`m` | chat | Quote message. | `hsignal:chat_quote_message;/cursor stop`
`q` | chat | Quote prefix + message. | `hsignal:chat_quote_prefix_message;/cursor stop`
`Q` | chat | Quote time + prefix + message. | `hsignal:chat_quote_time_prefix_message;/cursor stop`
`b` | nicklist | Ban nick. | `/window ${_window_number};/ban ${nick}`
`k` | nicklist | Kick nick. | `/window ${_window_number};/kick ${nick}`
`K` | nicklist | Kick and ban nick. | `/window ${_window_number};/kickban ${nick}`
`q` | nicklist | Open query with nick. | `/window ${_window_number};/query ${nick};/cursor stop`
`w` | nicklist | Do a whois on nick. | `/window ${_window_number};/whois ${nick}`
`Enter` `Ctrl`+`j` `Ctrl`+`m` | - | Stop cursor mode | `/cursor stop`

#### 3.12.5. Keys for "mouse" context

These keys are used in context "mouse", namely when a mouse event occurs.

Button (1) | Gesture | Area | Description | Command
--- | --- | --- | --- | ---
◾◽◽ | - | chat | Switch to window. | `/window ${_window_number}`
◾◽◽ | left | chat | Switch to previous buffer. | `/window ${_window_number};/buffer +1`
◾◽◽ | right | chat | Switch to next buffer. | `/window ${_window_number};/buffer +1`
◾◽◽ | left (long) | chat | Switch to first buffer. | `/window ${_window_number};/buffer 1`
◾◽◽ | right (long) | chat | Switch to last buffer. | `/window ${_window_number};/input jump_last_buffer`
◾◽◽ | - | chat (script buffer) | Select line in script buffer. | `/script go ${_chat_line_y}`
◽◽◾ | - | chat (script buffer) | Install/remove script. | `/script go ${_chat_line_y};/script installremove -q ${script_name_with_extension}`
⇑ | - | chat | Scroll up a few lines in buffer history. | `/window scroll_up -window ${_window_number}`
⇓ | - | chat | Scroll down a few lines in buffer history. | `/window scroll_down -window ${_window_number}`
⇑ | - | chat (script buffer) | Move 5 lines up in script buffer. | `/script up 5`
⇓ | - | chat (script buffer) | Move 5 lines down in script buffer. | `/script down 5`
`Ctrl`+`⇑` | - | chat | Scroll horizontally to the left. | `/window scroll_horiz -window ${_window_number} -10%`
`Ctrl`+`⇓` | - | chat | Scroll horizontally to the right. | `/window scroll_horiz -window ${_window_number} +10%`
◾◽◽ | up | nicklist | Scroll up one page in nicklist. | `/bar scroll nicklist ${_window_number} -100%`
◾◽◽ | down | nicklist | Scroll down one page in nicklist. | `/bar scroll nicklist ${_window_number} +100%`
◾◽◽ | up (long) | nicklist | Go to the beginning of nicklist. | `/bar scroll nicklist ${_window_number} b`
◾◽◽ | down (long) | nicklist | Go to the end of nicklist. | `/bar scroll nicklist ${_window_number} e`
◾◽◽ | - | nicklist | Open query with nick. | `/window ${_window_number};/query ${nick}`
◽◽◾ | - | nicklist | Do a whois on nick. | `/window ${_window_number};/whois ${nick}`
◾◽◽ | left | nicklist | Kick nick. | `/window ${_window_number};/kick ${nick}`
◾◽◽ | left (long) | nicklist | Kick and ban nick. | `/window ${_window_number};/kickban ${nick}`
◽◽◾ | left | nicklist | Ban nick. | `/window ${_window_number};/ban ${nick}`
◽◽◾ | - | input | Grab a mouse event and insert its code in command line. | `/input grab_mouse_area`
⇑ | - | any bar | Scroll bar by -20%. | `/bar scroll ${_bar_name} ${_window_number} -20%`
⇓ | - | any bar | Scroll bar by +20%. | `/bar scroll ${_bar_name} ${_window_number} +20%`
◽◾◽ | - | anywhere | Start cursor mode at this point. | `/cursor go ${_x},${_y}`

| (1) "⇑" and "⇓" are wheel up and down.

### 3.13. Mouse support

WeeChat supports mouse clicks and gestures. It is working with local terminal, and remotely via ssh connection with or without screen/tmux.

#### 3.13.1. Enable mouse

To enable mouse at startup:

    /set weechat.look.mouse on

To enable mouse now, press `Alt`+`m` or do following command:

    /mouse enable

It is possible to temporarily disable mouse, and bind that on a key. For example key `Alt`+`%` to disable mouse for 10 seconds:

    /key bind meta-% /mouse toggle 10

| When mouse is enabled in WeeChat, all mouse events are caught by WeeChat, so actions such as copy/paste or clicks on URLs are not sent to the terminal. Using `Shift` key causes the events to be sent directly to the terminal, as if the mouse was disabled (on some terminals like iTerm, you have to use `Alt` instead of `Shift`).

| For any problem with mouse, please look at WeeChat FAQ.

#### 3.13.2. Bind mouse events to commands

Many default mouse events are already defined by WeeChat (see keys for "mouse" context).

You can change or add bindings with the command `/key` using context "mouse" (for syntax, see command /key).

Event name consists of a modifier (optional), a button/wheel name and a gesture (optional). Different elements are separated by "-".

List of modifiers:

Modifier | Description
--- | ---
`ctrl` | Key `Ctrl`
`alt` | Key `Alt`
`ctrl-alt` | Keys `Ctrl` + `Alt`

List of buttons/wheel:

Button/wheel | Description
--- | ---
`button1` | Click on left button
`button2` | Click on right button
`button3` | Click on middle button (often click on wheel)
`button4 …​ button9` | Click on extra buttons
`wheelup` | Wheel (up)
`wheeldown` | Wheel (down)

List of gestures (only for buttons, not wheel):

Gesture | Distance
--- | ---
`gesture-up` | 3 …​ 19
`gesture-up-long` | ≥ 20
`gesture-down` | 3 …​ 19
`gesture-down-long` | ≥ 20
`gesture-left` | 3 …​ 39
`gesture-left-long` | ≥ 40
`gesture-right` | 3 …​ 39
`gesture-right-long` | ≥ 40

List of incomplete events (only for buttons, useful for plugins/scripts):

Event | Description
--- | ---
`event-down` | Button was pressed but not released yet
`event-drag` | Mouse was moved with button pressed down

Example of events:

- `button1`

- `ctrl-button1`

- `button1-gesture-right`

- `button1-event-down`

- `button1-event-drag`

- `alt-button2-gesture-down-long`

- `wheelup`

- `ctrl-alt-wheeldown`

- …​

| When binding a key in context "mouse", it’s possible to match many events using `*` at beginning or end of name, for example `button1-gesture-*` will match any gesture made using left button.

| You can find an event name with command `/input grab_mouse` then doing event with mouse. This will insert event name on command line.

### 3.14. Secured data

#### 3.14.1. Storage

WeeChat can encrypt passwords or private data using secured data, stored in file sec.conf.

This configuration file is read before any other file, and the values stored inside can be used in various WeeChat or plugins/scripts options.

You can set a passphrase to encrypt data in sec.conf. This is not mandatory but highly recommended, otherwise data is stored as plain text in file.

    /secure passphrase this is my passphrase

When a passphrase is set, WeeChat will ask you to enter it on startup (but not on `/upgrade`).

You can change this behavior and use a file with the passphrase (see option sec.crypt.passphrase_file).

##### Encryption

The encryption of data is made in 3 steps:

1. Derive a key from the passphrase (with optional salt).

2. Compute hash of data to encrypt.

3. Encrypt the hash + data (output is: salt + encrypted hash/data).

| The cipher block mode is CFB.

The result is put as hexadecimal string in file sec.conf, for example:

    [data]
    __passphrase__ = on
    freenode = "53B1C86FCDA28FC122A95B0456ABD79B5AB74654F21C3D099A6CCA8173239EEA59533A1D83011251F96778AC3F5166A394"

##### Decryption

The decryption of data is made in 3 steps:

1. Derive a key using salt and passphrase.

2. Decrypt hash + data.

3. Check that decrypted hash == hash of data.

#### 3.14.2. Manage secured data

To add secured data, use `/secure set`, for example a password for freenode IRC server:

    /secure set freenode mypassword

For comfort, secured data can be displayed in a dedicated buffer (`Alt`+`v` on buffer to see values), just do:

    /secure

Secured data can be used in some options that can contain private data like password, using this format: "${sec.data.xxx}" where "xxx" is the name of secured data (used with `/secure set xxx …​`).
For a complete list of supported options, see `/help secure`.

To use the freenode password, for example with SASL authentication:

    /set irc.server.freenode.sasl_password "${sec.data.freenode}"

### 3.15. Options and commands

#### 3.15.1. Secured data options (sec.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`crypt` | `/set sec.crypt.*` | Options for encryption.
`data` | `/secure` | Secured data.

Options:

- sec.crypt.cipher

  - description: cipher used to crypt data (the number after algorithm is the size of the key in bits)

  - type: integer

  - values: aes128, aes192, aes256

  - default value: `aes256`

- sec.crypt.hash_algo

  - description: hash algorithm used to check the decrypted data

  - type: integer

  - values: sha224, sha256, sha384, sha512

  - default value: `sha256`

- sec.crypt.passphrase_file

  - description: path to a file containing the passphrase to encrypt/decrypt secured data; this option is used only when reading file sec.conf; only first line of file is used; this file is used only if the environment variable "WEECHAT_PASSPHRASE" is not set (the environment variable has higher priority); security note: it is recommended to keep this file readable only by you and store it outside WeeChat home (for example in your home); example: "~/.weechat-passphrase"

  - type: string

  - values: any string

  - default value: `""`

- sec.crypt.salt

  - description: use salt when generating key used in encryption (recommended for maximum security); when enabled, the content of crypted data in file sec.conf will be different on each write of the file; if you put the file sec.conf in a version control system, then you can turn off this option to have always same content in file

  - type: boolean

  - values: on, off

  - default value: `on`

#### 3.15.2. WeeChat options (weechat.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`debug` | `/debug set /set weechat.debug.*` | Debug level, for core and plugins (options can be added/removed in section).
`startup` | `/set weechat.startup.*` | Startup options.
`look` | `/set weechat.look.*` | Look and feel.
`palette` | `/color alias /set weechat.palette.*` | Color aliases (options can be added/removed in section).
`color` | `/set weechat.color.*` | Colors.
`completion` | `/set weechat.completion.*` | Completion options.
`history` | `/set weechat.history.*` | History options (commands and buffers).
`proxy` | `/proxy /set weechat.proxy.*` | Proxy options.
`network` | `/set weechat.network.*` | Network/SSL options.
`bar` | `/bar /set weechat.bar.*` | Bar options.
`layout` | `/layout` | Layouts.
`notify` | `/buffer notify` | Notify levels for buffers (options can be added/removed in section).
`filter` | `/filter` | Filters.
`key` | `/key` | Keys in default context.
`key_search` | `/key` | Keys in search context.
`key_cursor` | `/key` | Keys in cursor context.
`key_mouse` | `/key` | Keys in mouse context.

Options:

- weechat.color.bar_more

  - description: text color for "+" when scrolling bars

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- weechat.color.chat

  - description: text color for chat

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_bg

  - description: background color for chat

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_buffer

  - description: text color for buffer names

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- weechat.color.chat_channel

  - description: text color for channel names

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- weechat.color.chat_day_change

  - description: text color for message displayed when the day has changed

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- weechat.color.chat_delimiters

  - description: text color for delimiters

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.chat_highlight

  - description: text color for highlighted prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.chat_highlight_bg

  - description: background color for highlighted prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- weechat.color.chat_host

  - description: text color for hostnames

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- weechat.color.chat_inactive_buffer

  - description: text color for chat when line is inactive (buffer is merged with other buffers and is not selected)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_inactive_window

  - description: text color for chat when window is inactive (not current selected window)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_nick

  - description: text color for nicks in chat window: used in some server messages and as fallback when a nick color is not found; most of times nick color comes from option weechat.color.chat_nick_colors

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- weechat.color.chat_nick_colors

  - description: text color for nicks (comma separated list of colors, background is allowed with format: "fg:bg", for example: "lightred:blue")

  - type: string

  - values: any string

  - default value: `"cyan,magenta,green,brown,lightblue,default,lightcyan,lightmagenta,lightgreen,blue"`

- weechat.color.chat_nick_offline

  - description: text color for offline nick (not in nicklist any more); this color is used only if option weechat.look.color_nick_offline is enabled

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_nick_offline_highlight

  - description: text color for offline nick with highlight; this color is used only if option weechat.look.color_nick_offline is enabled

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_nick_offline_highlight_bg

  - description: background color for offline nick with highlight; this color is used only if option weechat.look.color_nick_offline is enabled

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `blue`

- weechat.color.chat_nick_other

  - description: text color for other nick in private buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- weechat.color.chat_nick_prefix

  - description: color for nick prefix (string displayed before nick in prefix)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.chat_nick_self

  - description: text color for local nick in chat window

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- weechat.color.chat_nick_suffix

  - description: color for nick suffix (string displayed after nick in prefix)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.chat_prefix_action

  - description: text color for action prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- weechat.color.chat_prefix_buffer

  - description: text color for buffer name (before prefix, when many buffers are merged with same number)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- weechat.color.chat_prefix_buffer_inactive_buffer

  - description: text color for inactive buffer name (before prefix, when many buffers are merged with same number and if buffer is not selected)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_prefix_error

  - description: text color for error prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.chat_prefix_join

  - description: text color for join prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- weechat.color.chat_prefix_more

  - description: text color for "+" when prefix is too long

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- weechat.color.chat_prefix_network

  - description: text color for network prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- weechat.color.chat_prefix_quit

  - description: text color for quit prefix

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- weechat.color.chat_prefix_suffix

  - description: text color for suffix (after prefix)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.chat_read_marker

  - description: text color for unread data marker

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- weechat.color.chat_read_marker_bg

  - description: background color for unread data marker

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_server

  - description: text color for server names

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- weechat.color.chat_tags

  - description: text color for tags after messages (displayed with command /debug tags)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `red`

- weechat.color.chat_text_found

  - description: text color for marker on lines where text sought is found

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.chat_text_found_bg

  - description: background color for marker on lines where text sought is found

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- weechat.color.chat_time

  - description: text color for time in chat window

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.chat_time_delimiters

  - description: text color for time delimiters

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- weechat.color.chat_value

  - description: text color for values

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- weechat.color.chat_value_null

  - description: text color for null values (undefined)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `blue`

- weechat.color.emphasized

  - description: text color for emphasized text (for example when searching text); this option is used only if option weechat.look.emphasized_attributes is an empty string (default value)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.emphasized_bg

  - description: background color for emphasized text (for example when searching text); used only if option weechat.look.emphasized_attributes is an empty string (default value)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- weechat.color.input_actions

  - description: text color for actions in input line

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- weechat.color.input_text_not_found

  - description: text color for unsuccessful text search in input line

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `red`

- weechat.color.item_away

  - description: text color for away item

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.nicklist_away

  - description: text color for away nicknames

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- weechat.color.nicklist_group

  - description: text color for groups in nicklist

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.separator

  - description: color for window separators (when split) and separators beside bars (like nicklist)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `blue`

- weechat.color.status_count_highlight

  - description: text color for count of highlight messages in hotlist (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- weechat.color.status_count_msg

  - description: text color for count of messages in hotlist (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- weechat.color.status_count_other

  - description: text color for count of other messages in hotlist (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.status_count_private

  - description: text color for count of private messages in hotlist (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.status_data_highlight

  - description: text color for buffer with highlight (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- weechat.color.status_data_msg

  - description: text color for buffer with new messages (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.status_data_other

  - description: text color for buffer with new data (not messages) (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.status_data_private

  - description: text color for buffer with private message (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- weechat.color.status_filter

  - description: text color for filter indicator in status bar

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.status_more

  - description: text color for buffer with new data (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.status_mouse

  - description: text color for mouse indicator in status bar

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- weechat.color.status_name

  - description: text color for current buffer name in status bar

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- weechat.color.status_name_ssl

  - description: text color for current buffer name in status bar, if data are secured with a protocol like SSL

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- weechat.color.status_nicklist_count

  - description: text color for number of nicks in nicklist (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.color.status_number

  - description: text color for current buffer number in status bar

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- weechat.color.status_time

  - description: text color for time (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- weechat.completion.base_word_until_cursor

  - description: if enabled, the base word to complete ends at char before cursor; otherwise the base word ends at first space after cursor

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.completion.command_inline

  - description: if enabled, the commands inside command line are completed (the command at beginning of line has higher priority and is used first); note: when this option is enabled, there is no more automatic completion of paths beginning with "/" (outside commands arguments)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.completion.default_template

  - description: default completion template (please see documentation for template codes and values: plugin API reference, function "weechat_hook_command")

  - type: string

  - values: any string

  - default value: `"%(nicks)|%(irc_channels)"`

- weechat.completion.nick_add_space

  - description: add space after nick completion (when nick is not first word on command line)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.completion.nick_completer

  - description: string inserted after nick completion (when nick is first word on command line)

  - type: string

  - values: any string

  - default value: `":"`

- weechat.completion.nick_first_only

  - description: complete only with first nick found

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.completion.nick_ignore_chars

  - description: chars ignored for nick completion

  - type: string

  - values: any string

  - default value: `"[]`_-^"`

- weechat.completion.partial_completion_alert

  - description: alert user when a partial completion occurs

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.completion.partial_completion_command

  - description: partially complete command names (stop when many commands found begin with same letters)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.completion.partial_completion_command_arg

  - description: partially complete command arguments (stop when many arguments found begin with same prefix)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.completion.partial_completion_count

  - description: display count for each partial completion in bar item

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.completion.partial_completion_other

  - description: partially complete outside commands (stop when many words found begin with same letters)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.history.display_default

  - description: maximum number of commands to display by default in history listing (0 = unlimited)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `5`

- weechat.history.max_buffer_lines_minutes

  - description: maximum number of minutes in history per buffer (0 = unlimited); examples: 1440 = one day, 10080 = one week, 43200 = one month, 525600 = one year; use 0 ONLY if option weechat.history.max_buffer_lines_number is NOT set to 0

  - type: integer

  - values: 0 .. 2147483647

  - default value: `0`

- weechat.history.max_buffer_lines_number

  - description: maximum number of lines in history per buffer (0 = unlimited); use 0 ONLY if option weechat.history.max_buffer_lines_minutes is NOT set to 0

  - type: integer

  - values: 0 .. 2147483647

  - default value: `4096`

- weechat.history.max_commands

  - description: maximum number of user commands in history (0 = unlimited, NOT RECOMMENDED: no limit in memory usage)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `100`

- weechat.history.max_visited_buffers

  - description: maximum number of visited buffers to keep in memory

  - type: integer

  - values: 0 .. 1000

  - default value: `50`

- weechat.look.align_end_of_lines

  - description: alignment for end of lines (all lines after the first): they are starting under this data (time, buffer, prefix, suffix, message (default))

  - type: integer

  - values: time, buffer, prefix, suffix, message

  - default value: `message`

- weechat.look.align_multiline_words

  - description: alignment for multiline words according to option weechat.look.align_end_of_lines; if disabled, the multiline words will not be aligned, which can be useful to not break long URLs

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.bar_more_down

  - description: string displayed when bar can be scrolled down (for bars with filling different from "horizontal")

  - type: string

  - values: any string

  - default value: `"+"+`

- weechat.look.bar_more_left

  - description: string displayed when bar can be scrolled to the left (for bars with filling "horizontal")

  - type: string

  - values: any string

  - default value: `"<<"`

- weechat.look.bar_more_right

  - description: string displayed when bar can be scrolled to the right (for bars with filling "horizontal")

  - type: string

  - values: any string

  - default value: `">>"`

- weechat.look.bar_more_up

  - description: string displayed when bar can be scrolled up (for bars with filling different from "horizontal")

  - type: string

  - values: any string

  - default value: `"--"`

- weechat.look.bare_display_exit_on_input

  - description: exit the bare display mode on any changes in input

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.bare_display_time_format

  - description: time format in bare display mode (see man strftime for date/time specifiers)

  - type: string

  - values: any string

  - default value: `"%H:%M"`

- weechat.look.buffer_auto_renumber

  - description: automatically renumber buffers to have only consecutive numbers and start with number 1; if disabled, gaps between buffer numbers are allowed and the first buffer can have a number greater than 1

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.buffer_notify_default

  - description: default notify level for buffers (used to tell WeeChat if buffer must be displayed in hotlist or not, according to importance of message): all=all messages (default), message=messages+highlights, highlight=highlights only, none=never display in hotlist

  - type: integer

  - values: none, highlight, message, all

  - default value: `all`

- weechat.look.buffer_position

  - description: position of a new buffer: end = after the end of list (number = last number + 1) (default), first_gap = at first available number in the list (after the end of list if no number is available); this option is used only if the buffer has no layout number

  - type: integer

  - values: end, first_gap

  - default value: `end`

- weechat.look.buffer_search_case_sensitive

  - description: default text search in buffer: case sensitive or not

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.buffer_search_force_default

  - description: force default values for text search in buffer (instead of using values from last search in buffer)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.buffer_search_regex

  - description: default text search in buffer: if enabled, search POSIX extended regular expression, otherwise search simple string

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.buffer_search_where

  - description: default text search in buffer: in message, prefix, prefix and message

  - type: integer

  - values: prefix, message, prefix_message

  - default value: `prefix_message`

- weechat.look.buffer_time_format

  - description: time format for each line displayed in buffers (see man strftime for date/time specifiers) (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval); for example time using grayscale (requires support of 256 colors): "${color:252}%H${color:245}%M${color:240}%S"

  - type: string

  - values: any string

  - default value: `"%H:%M:%S"`

- weechat.look.color_basic_force_bold

  - description: force "bold" attribute for light colors and "darkgray" in basic colors (this option is disabled by default: bold is used only if terminal has less than 16 colors)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.color_inactive_buffer

  - description: use a different color for lines in inactive buffer (when line is from a merged buffer not selected)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.color_inactive_message

  - description: use a different color for inactive message (when window is not current window, or if line is from a merged buffer not selected)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.color_inactive_prefix

  - description: use a different color for inactive prefix (when window is not current window, or if line is from a merged buffer not selected)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.color_inactive_prefix_buffer

  - description: use a different color for inactive buffer name in prefix (when window is not current window, or if line is from a merged buffer not selected)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.color_inactive_time

  - description: use a different color for inactive time (when window is not current window, or if line is from a merged buffer not selected)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.color_inactive_window

  - description: use a different color for lines in inactive window (when window is not current window)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.color_nick_offline

  - description: use a different color for offline nicks (not in nicklist any more)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.color_pairs_auto_reset

  - description: automatically reset table of color pairs when number of available pairs is lower or equal to this number (-1 = disable automatic reset, and then a manual "/color reset" is needed when table is full)

  - type: integer

  - values: -1 .. 256

  - default value: `5`

- weechat.look.color_real_white

  - description: if set, uses real white color, disabled by default for terms with white background (if you never use white background, you should turn on this option to see real white instead of default term foreground color)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.command_chars

  - description: chars used to determine if input string is a command or not: input must start with one of these chars; the slash ("/") is always considered as command prefix (example: ".$")

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.command_incomplete

  - description: if set, incomplete and unambiguous commands are allowed, for example /he for /help

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.confirm_quit

  - description: if set, /quit command must be confirmed with extra argument "-yes" (see /help quit)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.confirm_upgrade

  - description: if set, /upgrade command must be confirmed with extra argument "-yes" (see /help upgrade)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.day_change

  - description: display special message when day changes

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.day_change_message_1date

  - description: message displayed when the day has changed, with one date displayed (for example at beginning of buffer) (see man strftime for date/time specifiers) (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"-- %a, %d %b %Y --"`

- weechat.look.day_change_message_2dates

  - description: message displayed when the day has changed, with two dates displayed (between two messages); the second date specifiers must start with two "%" because strftime is called two times on this string (see man strftime for date/time specifiers) (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"-- %%a, %%d %%b %%Y (%a, %d %b %Y) --"`

- weechat.look.eat_newline_glitch

  - description: if set, the eat_newline_glitch will be set to 0; this is used to not add new line char at end of each line, and then not break text when you copy/paste text from WeeChat to another application (this option is disabled by default because it can cause serious display bugs)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.emphasized_attributes

  - description: attributes for emphasized text: one or more attribute chars ("*" for bold, "!" for reverse, "/" for italic, "_" for underline); if the string is empty, the colors weechat.color.emphasized* are used

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.highlight

  - description: comma separated list of words to highlight; case insensitive comparison (use "(?-i)" at beginning of words to make them case sensitive), words may begin or end with "*" for partial match; example: "test,(?-i)*toto*,flash*"

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.highlight_regex

  - description: POSIX extended regular expression used to check if a message has highlight or not, at least one match in string must be surrounded by delimiters (chars different from: alphanumeric, "-", "_" and "|"), regular expression is case insensitive (use "(?-i)" at beginning to make it case sensitive), examples: "flashcode|flashy", "(?-i)FlashCode|flashy"

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.highlight_tags

  - description: comma separated list of tags to highlight; case insensitive comparison; wildcard "*" is allowed in each tag; many tags can be separated by "+" to make a logical "and" between tags; examples: "nick_flashcode" for messages from nick "FlashCode", "irc_notice+nick_toto*" for notices from a nick starting with "toto"

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.hotlist_add_conditions

  - description: conditions to add a buffer in hotlist (if notify level is OK for the buffer); you can use in these conditions: "window" (current window pointer), "buffer" (buffer pointer to add in hotlist), "priority" (0 = low, 1 = message, 2 = private, 3 = highlight); by default a buffer is added to hotlist if you are away, or if the buffer is not visible on screen (not displayed in any window)

  - type: string

  - values: any string

  - default value: `"${away} || ${buffer.num_displayed} == 0"`

- weechat.look.hotlist_buffer_separator

  - description: string displayed between buffers in hotlist

  - type: string

  - values: any string

  - default value: `", "`

- weechat.look.hotlist_count_max

  - description: max number of messages count to display in hotlist for a buffer (0 = never display messages count)

  - type: integer

  - values: 0 .. 4

  - default value: `2`

- weechat.look.hotlist_count_min_msg

  - description: display messages count if number of messages is greater or equal to this value

  - type: integer

  - values: 1 .. 100

  - default value: `2`

- weechat.look.hotlist_names_count

  - description: max number of names in hotlist (0 = no name displayed, only buffer numbers)

  - type: integer

  - values: 0 .. 10000

  - default value: `3`

- weechat.look.hotlist_names_length

  - description: max length of names in hotlist (0 = no limit)

  - type: integer

  - values: 0 .. 32

  - default value: `0`

- weechat.look.hotlist_names_level

  - description: level for displaying names in hotlist (combination of: 1=join/part, 2=message, 4=private, 8=highlight, for example: 12=private+highlight)

  - type: integer

  - values: 1 .. 15

  - default value: `12`

- weechat.look.hotlist_names_merged_buffers

  - description: if set, force display of names in hotlist for merged buffers

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.hotlist_prefix

  - description: text displayed at the beginning of the hotlist

  - type: string

  - values: any string

  - default value: `"H: "`

- weechat.look.hotlist_remove

  - description: remove buffers in hotlist: buffer = remove buffer by buffer, merged = remove all visible merged buffers at once

  - type: integer

  - values: buffer, merged

  - default value: `merged`

- weechat.look.hotlist_short_names

  - description: if set, uses short names to display buffer names in hotlist (start after first "." in name)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.hotlist_sort

  - description: sort of hotlist: group_time_*: group by notify level (highlights first) then sort by time, group_number_*: group by notify level (highlights first) then sort by number, number_*: sort by number; asc = ascending sort, desc = descending sort

  - type: integer

  - values: group_time_asc, group_time_desc, group_number_asc, group_number_desc, number_asc, number_desc

  - default value: `group_time_asc`

- weechat.look.hotlist_suffix

  - description: text displayed at the end of the hotlist

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.hotlist_unique_numbers

  - description: keep only unique numbers in hotlist (this applies only on hotlist items where name is NOT displayed after number)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.input_cursor_scroll

  - description: number of chars displayed after end of input line when scrolling to display end of line

  - type: integer

  - values: 0 .. 100

  - default value: `20`

- weechat.look.input_share

  - description: share commands, text, or both in input for all buffers (there is still local history for each buffer)

  - type: integer

  - values: none, commands, text, all

  - default value: `none`

- weechat.look.input_share_overwrite

  - description: if set and input is shared, always overwrite input in target buffer

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.input_undo_max

  - description: max number of "undo" for command line, by buffer (0 = undo disabled)

  - type: integer

  - values: 0 .. 65535

  - default value: `32`

- weechat.look.item_away_message

  - description: display server away message in away bar item

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.item_buffer_filter

  - description: string used to show that some lines are filtered in current buffer (bar item "buffer_filter")

  - type: string

  - values: any string

  - default value: `"*"`

- weechat.look.item_buffer_zoom

  - description: string used to show zoom on merged buffer (bar item "buffer_zoom")

  - type: string

  - values: any string

  - default value: `"!"`

- weechat.look.item_mouse_status

  - description: string used to show if mouse is enabled (bar item "mouse_status")

  - type: string

  - values: any string

  - default value: `"M"`

- weechat.look.item_time_format

  - description: time format for "time" bar item (see man strftime for date/time specifiers) (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"%H:%M"`

- weechat.look.jump_current_to_previous_buffer

  - description: jump to previous buffer displayed when jumping to current buffer number with /buffer *N (where N is a buffer number), to easily switch to another buffer, then come back to current buffer

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.jump_previous_buffer_when_closing

  - description: jump to previously visited buffer when closing a buffer (if disabled, then jump to buffer number - 1)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.jump_smart_back_to_buffer

  - description: jump back to initial buffer after reaching end of hotlist

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.key_bind_safe

  - description: allow only binding of "safe" keys (beginning with a ctrl or meta code)

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.key_grab_delay

  - description: default delay (in milliseconds) to grab a key (using default key alt-k); this delay can be overridden in the /input command (see /help input)

  - type: integer

  - values: 1 .. 10000

  - default value: `800`

- weechat.look.mouse

  - description: enable mouse support

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.mouse_timer_delay

  - description: delay (in milliseconds) to grab a mouse event: WeeChat will wait this delay before processing event

  - type: integer

  - values: 1 .. 10000

  - default value: `100`

- weechat.look.nick_color_force

  - description: force color for some nicks: hash computed with nickname to find color will not be used for these nicks (format is: "nick1:color1;nick2:color2"); look up for nicks is with exact case then lower case, so it's possible to use only lower case for nicks in this option

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.nick_color_hash

  - description: hash algorithm used to find the color for a nick: djb2 = variant of djb2 (position of letters matters: anagrams of a nick have different color), sum = sum of letters

  - type: integer

  - values: djb2, sum

  - default value: `djb2`

- weechat.look.nick_color_stop_chars

  - description: chars used to stop in nick when computing color with letters of nick (at least one char outside this list must be in string before stopping) (example: nick "|nick|away" with "|" in chars will return color of nick "|nick")

  - type: string

  - values: any string

  - default value: `"_|["`

- weechat.look.nick_prefix

  - description: text to display before nick in prefix of message, example: "<"

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.nick_suffix

  - description: text to display after nick in prefix of message, example: ">"

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.paste_auto_add_newline

  - description: automatically add a newline at the end of pasted text if there are at least two lines and if a confirmation is asked

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.paste_bracketed

  - description: enable terminal "bracketed paste mode" (not supported in all terminals/multiplexers): in this mode, pasted text is bracketed with control sequences so that WeeChat can differentiate pasted text from typed-in text ("ESC[200~", followed by the pasted text, followed by "ESC[201~")

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.paste_bracketed_timer_delay

  - description: force end of bracketed paste after this delay (in seconds) if the control sequence for end of bracketed paste ("ESC[201~") was not received in time

  - type: integer

  - values: 1 .. 60

  - default value: `10`

- weechat.look.paste_max_lines

  - description: max number of lines for paste without asking user (-1 = disable this feature)

  - type: integer

  - values: -1 .. 2147483647

  - default value: `1`

- weechat.look.prefix_action

  - description: prefix for action messages (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `" *"`

- weechat.look.prefix_align

  - description: prefix alignment (none, left, right (default))

  - type: integer

  - values: none, left, right

  - default value: `right`

- weechat.look.prefix_align_max

  - description: max size for prefix (0 = no max size)

  - type: integer

  - values: 0 .. 128

  - default value: `0`

- weechat.look.prefix_align_min

  - description: min size for prefix

  - type: integer

  - values: 0 .. 128

  - default value: `0`

- weechat.look.prefix_align_more

  - description: char to display if prefix is truncated (must be exactly one char on screen)

  - type: string

  - values: any string

  - default value: `""+`

- weechat.look.prefix_align_more_after

  - description: display the truncature char (by default "+") after the text (by replacing the space that should be displayed here); if disabled, the truncature char replaces last char of text

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.prefix_buffer_align

  - description: prefix alignment for buffer name, when many buffers are merged with same number (none, left, right (default))

  - type: integer

  - values: none, left, right

  - default value: `right`

- weechat.look.prefix_buffer_align_max

  - description: max size for buffer name, when many buffers are merged with same number (0 = no max size)

  - type: integer

  - values: 0 .. 128

  - default value: `0`

- weechat.look.prefix_buffer_align_more

  - description: char to display if buffer name is truncated (when many buffers are merged with same number) (must be exactly one char on screen)

  - type: string

  - values: any string

  - default value: `""+`

- weechat.look.prefix_buffer_align_more_after

  - description: display the truncature char (by default "+") after the text (by replacing the space that should be displayed here); if disabled, the truncature char replaces last char of text

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.prefix_error

  - description: prefix for error messages (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"=!="`

- weechat.look.prefix_join

  - description: prefix for join messages (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"-->"`

- weechat.look.prefix_network

  - description: prefix for network messages (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"--"`

- weechat.look.prefix_quit

  - description: prefix for quit messages (note: content is evaluated, so you can use colors with format "${color:xxx}", see /help eval)

  - type: string

  - values: any string

  - default value: `"<--"`

- weechat.look.prefix_same_nick

  - description: prefix displayed for a message with same nick as previous message: use a space " " to hide prefix, another string to display this string instead of prefix, or an empty string to disable feature (display prefix)

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.prefix_suffix

  - description: string displayed after prefix

  - type: string

  - values: any string

  - default value: `"|"`

- weechat.look.quote_nick_prefix

  - description: text to display before nick when quoting a message (see /help cursor)

  - type: string

  - values: any string

  - default value: `"<"`

- weechat.look.quote_nick_suffix

  - description: text to display after nick when quoting a message (see /help cursor)

  - type: string

  - values: any string

  - default value: `">"`

- weechat.look.quote_time_format

  - description: time format when quoting a message (see /help cursor)

  - type: string

  - values: any string

  - default value: `"%H:%M:%S"`

- weechat.look.read_marker

  - description: use a marker (line or char) on buffers to show first unread line

  - type: integer

  - values: none, line, char

  - default value: `line`

- weechat.look.read_marker_always_show

  - description: always show read marker, even if it is after last buffer line

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.read_marker_string

  - description: string used to draw read marker line (string is repeated until end of line)

  - type: string

  - values: any string

  - default value: `"- "`

- weechat.look.save_config_on_exit

  - description: save configuration file on exit

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.save_layout_on_exit

  - description: save layout on exit (buffers, windows, or both)

  - type: integer

  - values: none, buffers, windows, all

  - default value: `none`

- weechat.look.scroll_amount

  - description: how many lines to scroll by with scroll_up and scroll_down

  - type: integer

  - values: 1 .. 2147483647

  - default value: `3`

- weechat.look.scroll_bottom_after_switch

  - description: scroll to bottom of window after switch to another buffer (do not remember scroll position in windows); the scroll is done only for buffers with formatted content (not free content)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.scroll_page_percent

  - description: percent of screen to scroll when scrolling one page up or down (for example 100 means one page, 50 half-page)

  - type: integer

  - values: 1 .. 100

  - default value: `100`

- weechat.look.search_text_not_found_alert

  - description: alert user when text sought is not found in buffer

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.separator_horizontal

  - description: char used to draw horizontal separators around bars and windows (empty value will draw a real line with ncurses, but may cause bugs with URL selection under some terminals); width on screen must be exactly one char

  - type: string

  - values: any string

  - default value: `"-"`

- weechat.look.separator_vertical

  - description: char used to draw vertical separators around bars and windows (empty value will draw a real line with ncurses); width on screen must be exactly one char

  - type: string

  - values: any string

  - default value: `""`

- weechat.look.tab_width

  - description: number of spaces used to display tabs in messages

  - type: integer

  - values: 1 .. 64

  - default value: `1`

- weechat.look.time_format

  - description: time format for dates converted to strings and displayed in messages (see man strftime for date/time specifiers)

  - type: string

  - values: any string

  - default value: `"%a, %d %b %Y %T"`

- weechat.look.window_auto_zoom

  - description: automatically zoom on current window if the terminal becomes too small to display all windows (use alt-z to unzoom windows when the terminal is big enough)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.look.window_separator_horizontal

  - description: display an horizontal separator between windows

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.window_separator_vertical

  - description: display a vertical separator between windows

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.look.window_title

  - description: title for window (terminal for Curses GUI), set on startup; an empty string will keep title unchanged (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"WeeChat ${info:version}"`

- weechat.look.word_chars_highlight

  - description: comma-separated list of chars (or range of chars) that are considered part or words for highlights; each item can be a single char, a range of chars (format: a-z), a class of wide character (for example "alnum", see man wctype); a "!" before the item makes it negative (ie the char is NOT considered part of words); the value "*" matches any char; unicode chars are allowed with the format \u1234, for example \u00A0 for unbreakable space (see /help print for supported formats)

  - type: string

  - values: any string

  - default value: `"!\u00A0,-,_,|,alnum"`

- weechat.look.word_chars_input

  - description: comma-separated list of chars (or range of chars) that are considered part or words for command line; each item can be a single char, a range of chars (format: a-z), a class of wide character (for example "alnum", see man wctype); a "!" before the item makes it negative (ie the char is NOT considered part of words); the value "*" matches any char; unicode chars are allowed with the format \u1234, for example \u00A0 for unbreakable space (see /help print for supported formats)

  - type: string

  - values: any string

  - default value: `"!\u00A0,-,_,|,alnum"`

- weechat.network.connection_timeout

  - description: timeout (in seconds) for connection to a remote host (made in a child process)

  - type: integer

  - values: 1 .. 2147483647

  - default value: `60`

- weechat.network.gnutls_ca_file

  - description: file containing the certificate authorities ("%h" will be replaced by WeeChat home, "~/.weechat" by default)

  - type: string

  - values: any string

  - default value: `"/etc/ssl/certs/ca-certificates.crt"`

- weechat.network.gnutls_handshake_timeout

  - description: timeout (in seconds) for gnutls handshake

  - type: integer

  - values: 1 .. 2147483647

  - default value: `30`

- weechat.network.proxy_curl

  - description: name of proxy used for download of URLs with Curl (used to download list of scripts and in scripts calling function hook_process); the proxy must be defined with command /proxy

  - type: string

  - values: any string

  - default value: `""`

- weechat.plugin.autoload

  - description: comma separated list of plugins to load automatically at startup, "*" means all plugins found, a name beginning with "!" is a negative value to prevent a plugin from being loaded, wildcard "*" is allowed in names (examples: "*" or "*,!lua,!tcl")

  - type: string

  - values: any string

  - default value: `"*"`

- weechat.plugin.debug

  - description: enable debug messages by default in all plugins (option disabled by default, which is highly recommended)

  - type: boolean

  - values: on, off

  - default value: `off`

- weechat.plugin.extension

  - description: comma separated list of file name extensions for plugins

  - type: string

  - values: any string

  - default value: `".so,.dll"`

- weechat.plugin.path

  - description: path for searching plugins ("%h" will be replaced by WeeChat home, "~/.weechat" by default)

  - type: string

  - values: any string

  - default value: `"%h/plugins"`

- weechat.plugin.save_config_on_unload

  - description: save configuration files when unloading plugins

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.startup.command_after_plugins

  - description: command executed when WeeChat starts, after loading plugins (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- weechat.startup.command_before_plugins

  - description: command executed when WeeChat starts, before loading plugins (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- weechat.startup.display_logo

  - description: display WeeChat logo at startup

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.startup.display_version

  - description: display WeeChat version at startup

  - type: boolean

  - values: on, off

  - default value: `on`

- weechat.startup.sys_rlimit

  - description: set resource limits for WeeChat process, format is: "res1:limit1,res2:limit2"; resource name is the end of constant (RLIMIT_XXX) in lower case (see man setrlimit for values); limit -1 means "unlimited"; example: set unlimited size for core file and max 1GB of virtual memory: "core:-1,as:1000000000"

  - type: string

  - values: any string

  - default value: `""`

#### 3.15.3. WeeChat commands

- `away`: set or remove away status

    /away  [-all] [<message>]

       -all: set or remove away status on all connected servers
    message: message for away (if no message is given, away status is removed)

- `bar`: manage bars

    /bar  list|listfull|listitems
          add <name> <type>[,<conditions>] <position> <size> <separator> <item1>[,<item2>...]
          default [input|title|status|nicklist]
          del <name>|-all
          set <name> <option> <value>
          hide|show|toggle <name>
          scroll <name> <window> <scroll_value>

             list: list all bars
         listfull: list all bars (verbose)
        listitems: list all bar items
              add: add a new bar
             name: name of bar (must be unique)
             type:   root: outside windows,
                   window: inside windows, with optional conditions (see below)
       conditions: the conditions to display the bar:
                     active: on active window
                   inactive: on inactive windows
                   nicklist: on windows with nicklist
                   other condition: see /help weechat.bar.xxx.conditions and /help eval
                   without conditions, the bar is always displayed
         position: bottom, top, left or right
             size: size of bar (in chars)
        separator: 1 for using separator (line), 0 or nothing means no separator
        item1,...: items for this bar (items can be separated by comma (space between items) or "+" (glued items))
          default: create a default bar (all default bars if no bar name is given)
              del: delete a bar (or all bars with -all)
              set: set a value for a bar property
           option: option to change (for options list, look at /set weechat.bar.<barname>.*)
            value: new value for option
             hide: hide a bar
             show: show an hidden bar
           toggle: hide/show a bar
           scroll: scroll bar
           window: window number (use '*' for current window or for root bars)
     scroll_value: value for scroll: 'x' or 'y' (optional), followed by '+', '-', 'b' (beginning) or 'e' (end), value (for +/-), and optional % (to scroll by % of width/height, otherwise value is number of chars)

    Examples:
      create a bar with time, buffer number + name, and completion:
        /bar add mybar root bottom 1 0 [time],buffer_number+:+buffer_name,completion
      hide a bar:
        /bar hide mybar
      scroll nicklist 10 lines down on current buffer:
        /bar scroll nicklist * y+10
      scroll to end of nicklist on current buffer:
        /bar scroll nicklist * ye

- `buffer`: manage buffers

    /buffer  list
             clear [<number>|<name>|-merged|-all [<number>|<name>...]]
             move <number>|-|+
             swap <number1>|<name1> [<number2>|<name2>]
             cycle <number>|<name> [<number>|<name>...]]
             merge <number>
             unmerge [<number>|-all]
             hide [<number>|<name>|-all [<number>|<name>...]]
             unhide [<number>|<name>|-all [<number>|<name>...]]
             renumber [<number1> [<number2> [<start>]]]
             close [<n1>[-<n2>]|<name>]
             notify <level>
             localvar
             set <property> <value>
             get <property>
             <number>|-|+|<name>

        list: list buffers (without argument, this list is displayed)
       clear: clear buffer content (number for a buffer, -merged for merged buffers, -all for all buffers, or nothing for current buffer)
        move: move buffer in the list (may be relative, for example -1); "-" = move to first buffer number, "+" = move to last buffer number + 1
        swap: swap two buffers (swap with current buffer if only one number/name given)
       cycle: jump loop between a list of buffers
       merge: merge current buffer to another buffer (chat area will be mix of both buffers)
              (by default ctrl-x switches between merged buffers)
     unmerge: unmerge buffer from other buffers which have same number
        hide: hide the buffer
      unhide: unhide the buffer
    renumber: renumber buffers (works only if option weechat.look.buffer_auto_renumber is off)
       close: close buffer (number/range or name is optional)
      notify: set notify level for current buffer: this level determines whether buffer will be added to hotlist or not:
                   none: never
              highlight: for highlights only
                message: for messages from users + highlights
                    all: all messages
                  reset: reset to default value (all)
    localvar: display local variables for current buffer
         set: set a property for current buffer
         get: display a property of current buffer
      number: jump to buffer by number, possible prefix:
              '+': relative jump, add number to current
              '-': relative jump, sub number to current
              '*': jump to number, using option "weechat.look.jump_current_to_previous_buffer"
           -: jump to first buffer number
           +: jump to last buffer number
        name: jump to buffer by (partial) name

    Examples:
      clear current buffer:
        /buffer clear
      move buffer to number 5:
        /buffer move 5
      swap buffer 1 with 3:
        /buffer swap 1 3
      swap buffer #weechat with current buffer:
        /buffer swap #weechat
      jump on #chan1, #chan2, #chan3 and loop:
        /buffer cycle #chan1 #chan2 #chan3
      merge with core buffer:
        /buffer merge 1
      unmerge buffer:
        /buffer unmerge
      close current buffer:
        /buffer close
      close buffers 5 to 7:
        /buffer close 5-7
      jump to #weechat:
        /buffer #weechat
      jump to next buffer:
        /buffer +1
      jump to last buffer number:
        /buffer +

- `color`: define color aliases and display palette of colors

    /color  alias <color> <name>
            unalias <color>
            reset
            term2rgb <color>
            rgb2term <rgb> [<limit>]
            -o

       alias: add an alias for a color
     unalias: delete an alias
       color: color number (greater than or equal to 0, max depends on terminal, commonly 63 or 255)
        name: alias name for color (for example: "orange")
       reset: reset all color pairs (required when no more color pairs are available if automatic reset is disabled, see option "weechat.look.color_pairs_auto_reset")
    term2rgb: convert a terminal color (0-255) to RGB color
    rgb2term: convert a RGB color to terminal color (0-255)
       limit: number of colors to use in terminal table (starting from 0); default is 256
          -o: send terminal/colors info to current buffer as input

    Without argument, this command displays colors in a new buffer.

    Examples:
      add alias "orange" for color 214:
        /color alias 214 orange
      delete color 214:
        /color unalias 214

- `command`: launch explicit WeeChat or plugin command

    /command  [-buffer <name>] <plugin> <command>

    -buffer: execute the command on this buffer
     plugin: execute the command from this plugin; 'core' for a WeeChat command, '*' for automatic plugin (it depends on the buffer where the command is executed)
    command: command to execute (a '/' is automatically added if not found at beginning of command)

- `cursor`: free movement of cursor on screen to execute actions on specific areas of screen

    /cursor  go chat|<bar>|<x>,<y>
             move up|down|left|right|area_up|area_down|area_left|area_right
             stop

      go: move cursor to chat area, a bar (using bar name) or coordinates "x,y"
    move: move cursor with direction
    stop: stop cursor mode

    Without argument, this command toggles cursor mode.

    When mouse is enabled (see /help mouse), by default a middle click will start cursor mode at this point.

    Default keys in cursor mode on chat messages:
      m  quote message
      q  quote prefix + message
      Q  quote time + prefix + message

    Default keys in cursor mode on nicklist:
      b  ban nick (/ban)
      k  kick nick (/kick)
      K  kick and ban nick (/kickban)
      q  open query with nick (/query)
      w  query information about user (/whois)

    Examples:
      go to nicklist:
        /cursor go nicklist
      go to coordinates x=10, y=5:
        /cursor go 10,5

- `debug`: debug functions

    /debug  list
            set <plugin> <level>
            dump [<plugin>]
            buffer|color|infolists|memory|tags|term|windows
            mouse|cursor [verbose]
            hdata [free]
            time <command>

         list: list plugins with debug levels
          set: set debug level for plugin
       plugin: name of plugin ("core" for WeeChat core)
        level: debug level for plugin (0 = disable debug)
         dump: save memory dump in WeeChat log file (same dump is written when WeeChat crashes)
       buffer: dump buffer content with hexadecimal values in log file
        color: display infos about current color pairs
       cursor: toggle debug for cursor mode
         dirs: display directories
        hdata: display infos about hdata (with free: remove all hdata in memory)
        hooks: display infos about hooks
    infolists: display infos about infolists
         libs: display infos about external libraries used
       memory: display infos about memory usage
        mouse: toggle debug for mouse
         tags: display tags for lines
         term: display infos about terminal
      windows: display windows tree
         time: measure time to execute a command or to send text to the current buffer

- `eval`: evaluate expression

    /eval  [-n|-s] <expression>
           [-n] -c <expression1> <operator> <expression2>

            -n: display result without sending it to buffer (debug mode)
            -s: split expression before evaluating it (many commands can be separated by semicolons)
            -c: evaluate as condition: use operators and parentheses, return a boolean value ("0" or "1")
    expression: expression to evaluate, variables with format ${variable} are replaced (see below); many commands can be separated by semicolons
      operator: a logical or comparison operator:
                - logical operators:
                    &&  boolean "and"
                    ||  boolean "or"
                - comparison operators:
                    ==  equal
                    !=  not equal
                    <=  less or equal
                    <   less
                    >=  greater or equal
                    >   greater
                    =~  is matching POSIX extended regex
                    !~  is NOT matching POSIX extended regex

    An expression is considered as "true" if it is not NULL, not empty, and different from "0".
    The comparison is made using integers if the two expressions are valid integers.
    To force a string comparison, add double quotes around each expression, for example:
      50 > 100      ==> 0
      "50" > "100"  ==> 1

    Some variables are replaced in expression, using the format ${variable}, variable can be, by order of priority:
      1. an evaluated sub-string (format: "eval:xxx")
      2. a string with escaped chars (format: "esc:xxx" or "\xxx")
      3. a string with chars to hide (format: "hide:char,string")
      4. a color (format: "color:xxx")
      5. an info (format: "info:name,arguments", arguments are optional)
      6. current date/time (format: "date" or "date:format")
      7. an environment variable (format: "env:XXX")
      8. an option (format: "file.section.option")
      9. a local variable in buffer
      10. a hdata name/variable (the value is automatically converted to string), by default "window" and "buffer" point to current window/buffer.
    Format for hdata can be one of following:
      hdata.var1.var2...: start with a hdata (pointer must be known), and ask variables one after one (other hdata can be followed)
      hdata[list].var1.var2...: start with a hdata using a list, for example:
        ${buffer[gui_buffers].full_name}: full name of first buffer in linked list of buffers
        ${plugin[weechat_plugins].name}: name of first plugin in linked list of plugins
      hdata[pointer].var1.var2...: start with a hdata using a pointer, for example:
        ${buffer[0x1234abcd].full_name}: full name of the buffer with this pointer (can be used in triggers)
    For name of hdata and variables, please look at "Plugin API reference", function "weechat_hdata_get".

    Examples (simple strings):
      /eval -n ${info:version}                     ==> 0.4.3
      /eval -n ${env:HOME}                         ==> /home/user
      /eval -n ${weechat.look.scroll_amount}       ==> 3
      /eval -n ${window}                           ==> 0x2549aa0
      /eval -n ${window.buffer}                    ==> 0x2549320
      /eval -n ${window.buffer.full_name}          ==> core.weechat
      /eval -n ${window.buffer.number}             ==> 1
      /eval -n ${\t}                               ==> <tab>
      /eval -n ${hide:-,${relay.network.password}} ==> --------
      /eval -n ${date:%H:%M:%S}                    ==> 07:46:40

    Examples (conditions):
      /eval -n -c ${window.buffer.number} > 2 ==> 0
      /eval -n -c ${window.win_width} > 100   ==> 1
      /eval -n -c (8 > 12) || (5 > 2)         ==> 1
      /eval -n -c (8 > 12) && (5 > 2)         ==> 0
      /eval -n -c abcd =~ ^ABC                ==> 1
      /eval -n -c abcd =~ (?-i)^ABC           ==> 0
      /eval -n -c abcd =~ (?-i)^abc           ==> 1
      /eval -n -c abcd !~ abc                 ==> 0

- `filter`: filter messages in buffers, to hide/show them according to tags or regex

    /filter  list
             enable|disable|toggle [<name>|@]
             add <name> <buffer>[,<buffer>...] <tags> <regex>
             rename <name> <new_name>
             del <name>|-all

       list: list all filters
     enable: enable filters (filters are enabled by default)
    disable: disable filters
     toggle: toggle filters
       name: filter name ("@" = enable/disable all filters in current buffer)
        add: add a filter
     rename: rename a filter
        del: delete a filter
       -all: delete all filters
     buffer: comma separated list of buffers where filter is active:
             - this is full name including plugin (example: "irc.freenode.#weechat" or "irc.server.freenode")
             - "*" means all buffers
             - a name starting with '!' is excluded
             - wildcard "*" is allowed
       tags: comma separated list of tags, for example "irc_join,irc_part,irc_quit"
             - logical "and": use "+" between tags (for example: "nick_toto+irc_action")
             - wildcard "*" is allowed
             - if tag starts with '!', then it is excluded and must NOT be in message
      regex: POSIX extended regular expression to search in line
             - use '\t' to separate prefix from message, special chars like '|' must be escaped: '\|'
             - if regex starts with '!', then matching result is reversed (use '\!' to start with '!')
             - two regular expressions are created: one for prefix and one for message
             - regex are case insensitive, they can start by "(?-i)" to become case sensitive

    The default key alt+'=' toggles filtering on/off.

    Tags most commonly used:
      no_filter, no_highlight, no_log, log0..log9 (log level),
      notify_none, notify_message, notify_private, notify_highlight,
      self_msg, nick_xxx (xxx is nick in message), prefix_nick_ccc (ccc is color of nick),
      host_xxx (xxx is username + host in message),
      irc_xxx (xxx is command name or number, see /server raw or /debug tags),
      irc_numeric, irc_error, irc_action, irc_ctcp, irc_ctcp_reply, irc_smart_filter, away_info.
    To see tags for lines in buffers: /debug tags

    Examples:
      use IRC smart filter on all buffers:
        /filter add irc_smart * irc_smart_filter *
      use IRC smart filter on all buffers except those with "#weechat" in name:
        /filter add irc_smart *,!*#weechat* irc_smart_filter *
      filter all IRC join/part/quit messages:
        /filter add joinquit * irc_join,irc_part,irc_quit *
      filter nicks displayed when joining channels or with /names:
        /filter add nicks * irc_366 *
      filter nick "toto" on IRC channel #weechat:
        /filter add toto irc.freenode.#weechat nick_toto *
      filter IRC join/action messages from nick "toto":
        /filter add toto * nick_toto+irc_join,nick_toto+irc_action *
      filter lines containing "weechat sucks" on IRC channel #weechat:
        /filter add sucks irc.freenode.#weechat * weechat sucks
      filter lines that are strictly equal to "WeeChat sucks" on all buffers:
        /filter add sucks2 * * (?-i)^WeeChat sucks$

- `help`: display help about commands and options

    /help  -list|-listfull [<plugin> [<plugin>...]]
           <command>
           <option>

        -list: list commands, by plugin (without argument, this list is displayed)
    -listfull: list commands with description, by plugin
       plugin: list commands for this plugin
      command: a command name
       option: an option name (use /set to see list)

- `history`: show buffer command history

    /history  clear
              <value>

    clear: clear history
    value: number of history entries to show

- `input`: functions for command line

    /input  <action> [<arguments>]

    list of actions:
      return: simulate key "enter"
      complete_next: complete word with next completion
      complete_previous: complete word with previous completion
      search_text_here: search text in buffer at current position
      search_text: search text in buffer
      search_switch_case: switch exact case for search
      search_switch_regex: switch search type: string/regular expression
      search_switch_where: switch search in messages/prefixes
      search_previous: search previous line
      search_next: search next line
      search_stop_here: stop search at current position
      search_stop: stop search
      delete_previous_char: delete previous char
      delete_next_char: delete next char
      delete_previous_word: delete previous word
      delete_next_word: delete next word
      delete_beginning_of_line: delete from beginning of line until cursor
      delete_end_of_line: delete from cursor until end of line
      delete_line: delete entire line
      clipboard_paste: paste from the internal clipboard
      transpose_chars: transpose two chars
      undo: undo last command line action
      redo: redo last command line action
      move_beginning_of_line: move cursor to beginning of line
      move_end_of_line: move cursor to end of line
      move_previous_char: move cursor to previous char
      move_next_char: move cursor to next char
      move_previous_word: move cursor to previous word
      move_next_word: move cursor to next word
      history_previous: recall previous command in current buffer history
      history_next: recall next command in current buffer history
      history_global_previous: recall previous command in global history
      history_global_next: recall next command in global history
      jump_smart: jump to next buffer with activity
      jump_last_buffer_displayed: jump to last buffer displayed (before last jump to a buffer)
      jump_previously_visited_buffer: jump to previously visited buffer
      jump_next_visited_buffer: jump to next visited buffer
      hotlist_clear: clear hotlist (optional argument: "lowest" to clear only lowest level in hotlist, "highest" to clear only highest level in hotlist, or level mask: integer which is a combination of 1=join/part, 2=message, 4=private, 8=highlight)
      grab_key: grab a key (optional argument: delay for end of grab, default is 500 milliseconds)
      grab_key_command: grab a key with its associated command (optional argument: delay for end of grab, default is 500 milliseconds)
      grab_mouse: grab mouse event code
      grab_mouse_area: grab mouse event code with area
      set_unread: set unread marker for all buffers
      set_unread_current_buffer: set unread marker for current buffer
      switch_active_buffer: switch to next merged buffer
      switch_active_buffer_previous: switch to previous merged buffer
      zoom_merged_buffer: zoom on merged buffer
      insert: insert text in command line (escaped chars are allowed, see /help print)
      send: send text to the buffer
      paste_start: start paste (bracketed paste mode)
      paste_stop: stop paste (bracketed paste mode)

    This command is used by key bindings or plugins.

- `key`: bind/unbind keys

    /key  list|listdefault|listdiff [<context>]
          bind <key> [<command> [<args>]]
          bindctxt <context> <key> [<command> [<args>]]
          unbind <key>
          unbindctxt <context> <key>
          reset <key>
          resetctxt <context> <key>
          resetall -yes [<context>]
          missing [<context>]

           list: list all current keys (without argument, this list is displayed)
    listdefault: list default keys
       listdiff: list differences between current and default keys (keys added, redefined or deleted)
        context: name of context ("default" or "search")
           bind: bind a command to a key or display command bound to key (for context "default")
       bindctxt: bind a command to a key or display command bound to key, for given context
        command: command (many commands can be separated by semicolons)
         unbind: remove a key binding (for context "default")
     unbindctxt: remove a key binding for given context
          reset: reset a key to default binding (for context "default")
      resetctxt: reset a key to default binding, for given context
       resetall: restore bindings to the default values and delete ALL personal bindings (use carefully!)
        missing: add missing keys (using default bindings), useful after installing new WeeChat version

    When binding a command to a key, it is recommended to use key alt+k (or Esc then k), and then press the key to bind: this will insert key code in command line.

    For context "mouse" (possible in context "cursor" too), key has format: "@area:key" or "@area1>area2:key" where area can be:
              *: any area on screen
           chat: chat area (any buffer)
      chat(xxx): char area for buffer with name "xxx" (full name including plugin)
         bar(*): any bar
       bar(xxx): bar "xxx"
        item(*): any bar item
      item(xxx): bar item "xxx"
    Wildcard "*" is allowed in key to match many mouse events.
    A special value for command with format "hsignal:name" can be used for context mouse, this will send the hsignal "name" with the focus hashtable as argument.
    Another special value "-" can be used to disable key (it will be ignored when looking for keys).

    Examples:
      key alt-t to toggle nicklist bar:
        /key bind meta-t /bar toggle nicklist
      key alt-r to jump to #weechat IRC channel:
        /key bind meta-r /buffer #weechat
      restore default binding for key alt-r:
        /key reset meta-r
      key "tab" to stop search in buffer:
        /key bindctxt search ctrl-I /input search_stop
      middle button of mouse on a nick to retrieve info on nick:
        /key bindctxt mouse @item(buffer_nicklist):button3 /msg nickserv info ${nick}

- `layout`: manage buffers/windows layouts

    /layout  store [<name>] [buffers|windows]
             apply [<name>] [buffers|windows]
             leave
             del [<name>] [buffers|windows]
             rename <name> <new_name>

      store: store current buffers/windows in a layout
      apply: apply stored layout
      leave: leave current layout (does not update any layout)
        del: delete buffers and/or windows in a stored layout
             (if neither "buffers" nor "windows" is given after the name, the layout is deleted)
     rename: rename a layout
       name: name for stored layout (default is "default")
    buffers: store/apply only buffers (order of buffers)
    windows: store/apply only windows (buffer displayed by each window)

    Without argument, this command displays stored layouts.

    The current layout can be saved on /quit command with the option "weechat.look.save_layout_on_exit".

- `mouse`: mouse control

    /mouse  enable|disable|toggle [<delay>]

     enable: enable mouse
    disable: disable mouse
     toggle: toggle mouse
      delay: delay (in seconds) after which initial mouse state is restored (useful to temporarily disable mouse)

    The mouse state is saved in option "weechat.look.mouse".

    Examples:
      enable mouse:
        /mouse enable
      toggle mouse for 5 seconds:
        /mouse toggle 5

- `mute`: execute a command silently

    /mute  [-core | -current | -buffer <name>] <command>

       -core: no output on WeeChat core buffer
    -current: no output on current buffer
     -buffer: no output on specified buffer
        name: full buffer name (examples: "irc.server.freenode", "irc.freenode.#weechat")
     command: command to execute silently (a '/' is automatically added if not found at beginning of command)

    If no target is specified (-core, -current or -buffer), then default is to mute all buffers.

    Examples:
      config save:
        /mute save
      message to current IRC channel:
        /mute -current msg * hi!
      message to #weechat channel:
        /mute -buffer irc.freenode.#weechat msg #weechat hi!

- `plugin`: list/load/unload plugins

    /plugin  list|listfull [<name>]
             load <filename> [<arguments>]
             autoload [<arguments>]
             reload [<name>|* [<arguments>]]
             unload [<name>]

         list: list loaded plugins
     listfull: list loaded plugins (verbose)
         load: load a plugin
     autoload: autoload plugins in system or user directory
       reload: reload a plugin (if no name given, unload all plugins, then autoload plugins)
       unload: unload a plugin (if no name given, unload all plugins)
     filename: plugin (file) to load
         name: a plugin name
    arguments: arguments given to plugin on load

    Without argument, this command lists loaded plugins.

- `print`: display text on a buffer

    /print  [-buffer <number>|<name>] [-core] [-escape] [-date <date>] [-tags <tags>] [-action|-error|-join|-network|-quit] [<text>]
            -stdout|-stderr [<text>]
            -beep

     -buffer: display text in this buffer (default: buffer where command is executed)
       -core: alias of "-buffer core.weechat"
    -current: display text on current buffer
     -escape: interpret escaped chars (for example \a, \07, \x07)
       -date: message date, format can be:
                -n: 'n' seconds before now
                +n: 'n' seconds in the future
                 n: 'n' seconds since the Epoch (see man time)
                date/time (ISO 8601): yyyy-mm-ddThh:mm:ss, example: 2014-01-19T04:32:55
                time: hh:mm:ss (example: 04:32:55)
       -tags: comma-separated list of tags (see /help filter for a list of tags most commonly used)
        text: text to display (prefix and message must be separated by "\t", if text starts with "-", then add a "\" before)
     -stdout: display text on stdout (escaped chars are interpreted)
     -stderr: display text on stderr (escaped chars are interpreted)
       -beep: alias of "-stderr \a"

    The options -action ... -quit use the prefix defined in options "weechat.look.prefix_*".

    Following escaped chars are supported:
      \" \\ \a \b \e \f \n \r \t \v \0ooo \xhh \uhhhh \Uhhhhhhhh

    Examples:
      display a reminder on core buffer with a highlight:
        /print -core -tags notify_highlight Reminder: buy milk
      display an error on core buffer:
        /print -core -error Some error here
      display message on core buffer with prefix "abc":
        /print -core abc\tThe message
      display a message on channel #weechat:
        /print -buffer irc.freenode.#weechat Message on #weechat
      display a snowman (U+2603):
        /print -escape \u2603
      send alert (BEL):
        /print -beep

- `proxy`: manage proxies

    /proxy  list
            add <name> <type> <address> <port> [<username> [<password>]]
            del <name>|-all
            set <name> <option> <value>

        list: list all proxies
         add: add a new proxy
        name: name of proxy (must be unique)
        type: http, socks4 or socks5
     address: IP or hostname
        port: port
    username: username (optional)
    password: password (optional)
         del: delete a proxy (or all proxies with -all)
         set: set a value for a proxy property
      option: option to change (for options list, look at /set weechat.proxy.<proxyname>.*)
       value: new value for option

    Examples:
      add a http proxy, running on local host, port 8888:
        /proxy add local http 127.0.0.1 8888
      add a http proxy using IPv6 protocol:
        /proxy add local http ::1 8888
        /proxy set local ipv6 on
      add a socks5 proxy with username/password:
        /proxy add myproxy socks5 sample.host.org 3128 myuser mypass
      delete a proxy:
        /proxy del myproxy

- `quit`: quit WeeChat

    /quit  [-yes] [<arguments>]

         -yes: required if option "weechat.look.confirm_quit" is enabled
    arguments: text sent with signal "quit"
               (for example irc plugin uses this text to send quit message to server)

    By default when quitting the configuration files are saved (see option "weechat.look.save_config_on_exit") and the current layout can be saved (see option "weechat.look.save_layout_on_exit").

- `reload`: reload configuration files from disk

    /reload  [<file> [<file>...]]

    file: configuration file to reload (without extension ".conf")

    Without argument, all files (WeeChat and plugins) are reloaded.

- `repeat`: execute a command several times

    /repeat  [-interval <delay>] <count> <command>

      delay: delay between execution of commands (in milliseconds)
      count: number of times to execute command
    command: command to execute (a '/' is automatically added if not found at beginning of command)

    All commands are executed on buffer where this command was issued.

    Example:
      scroll 2 pages up:
        /repeat 2 /window page_up

- `save`: save configuration files to disk

    /save  [<file> [<file>...]]

    file: configuration file to save (without extension ".conf")

    Without argument, all files (WeeChat and plugins) are saved.

    By default all configuration files are saved to disk on /quit command (see option "weechat.look.save_config_on_exit").

- `secure`: manage secured data (passwords or private data encrypted in file sec.conf)

    /secure  passphrase <passphrase>|-delete
             decrypt <passphrase>|-discard
             set <name> <value>
             del <name>

    passphrase: change the passphrase (without passphrase, data is stored as plain text in file sec.conf)
       -delete: delete passphrase
       decrypt: decrypt data still encrypted (it happens only if passphrase was not given on startup)
      -discard: discard all data still encrypted
           set: add or change secured data
           del: delete secured data

    Without argument, this command displays secured data in a new buffer.

    Keys on secure buffer:
      alt+v  toggle values

    When a passphrase is used (data encrypted), it is asked by WeeChat on startup.
    It is possible to set environment variable "WEECHAT_PASSPHRASE" to prevent the prompt (this same variable is used by WeeChat on /upgrade).

    Secured data with format ${sec.data.xxx} can be used in:
      - command /eval
      - command line argument "--run-command"
      - options weechat.startup.command_{before|after}_plugins
      - other options that may contain a password or sensitive data (for example proxy, irc server and relay); see /help on the options to check if they are evaluated.

    Examples:
      set a passphrase:
        /secure passphrase this is my passphrase
      encrypt freenode SASL password:
        /secure set freenode mypassword
        /set irc.server.freenode.sasl_password "${sec.data.freenode}"
      encrypt oftc password for nickserv:
        /secure set oftc mypassword
        /set irc.server.oftc.command "/msg nickserv identify ${sec.data.oftc}"
      alias to ghost the nick "mynick":
        /alias add ghost /eval /msg -server freenode nickserv ghost mynick ${sec.data.freenode}

- `set`: set config options and environment variables

    /set  [<option> [<value>]]
          diff [<option> [<option>...]]
          env [<variable> [<value>]]

    option: name of an option (wildcard "*" is allowed)
     value: new value for option, according to type:
              boolean: on, off or toggle
              integer: number, ++number or --number
               string: any string ("" for empty string)
                color: color name, ++number or --number
            Note: for all types, you can use null to remove option value (undefined value). This works only for some special plugin variables.
      diff: display only changed options
       env: display or set an environment variable (use value "" to unset a variable)

    Examples:
      display options about highlight:
        /set *highlight*
      add a word to highlight:
        /set weechat.look.highlight "word"
      display changed options:
        /set diff
      display changed options in irc plugin:
        /set diff irc.*
      display value of environment variable LANG:
        /set env LANG
      set environment variable LANG and use it:
        /set env LANG fr_FR.UTF-8
        /upgrade
      unset environment variable ABC:
        /set env ABC ""

- `unset`: unset/reset config options

    /unset  <option>
            -mask <option>

    option: name of an option
     -mask: use a mask in option (wildcard "*" is allowed to mass-reset options, use carefully!)

    According to option, it's reset (for standard options) or removed (for optional settings, like server values).

    Examples:
      reset one option:
        /unset weechat.look.item_time_format
      reset all color options:
        /unset -mask weechat.color.*

- `upgrade`: upgrade WeeChat without disconnecting from servers

    /upgrade  [-yes] [<path_to_binary>|-quit]

              -yes: required if option "weechat.look.confirm_upgrade" is enabled
    path_to_binary: path to WeeChat binary (default is current binary)
            -dummy: do nothing (option used to prevent accidental completion with "-quit")
             -quit: close *ALL* connections, save session and quit WeeChat, which makes possible a delayed restoration (see below)

    This command upgrades and reloads a running WeeChat session. The new WeeChat binary must have been compiled or installed with a package manager before running this command.

    Note: SSL connections are lost during upgrade, because reload of SSL sessions is currently not possible with GnuTLS. There is automatic reconnection after upgrade.

    Upgrade process has 4 steps:
      1. save session into files for core and plugins (buffers, history, ..)
      2. unload all plugins (configuration files (*.conf) are written on disk)
      3. save WeeChat configuration (weechat.conf)
      4. execute new WeeChat binary and reload session.

    With option "-quit", the process is slightly different:
      1. close *ALL* connections (irc, xfer, relay, ...)
      2. save session into files (*.upgrade)
      3. unload all plugins
      4. save WeeChat configuration
      5. quit WeeChat
    Then later you can restore session with command: weechat --upgrade
    IMPORTANT: you must restore the session with exactly same configuration (files *.conf).
    It is possible to restore WeeChat session on another machine if you copy the content of directory "~/.weechat".

- `uptime`: show WeeChat uptime

    /uptime  [-o | -ol]

     -o: send uptime to current buffer as input (English string)
    -ol: send uptime to current buffer as input (translated string)

- `version`: show WeeChat version and compilation date

    /version  [-o | -ol]

     -o: send version to current buffer as input (English string)
    -ol: send version to current buffer as input (translated string)

    The default alias /v can be used to execute this command on all buffers (otherwise the irc command /version is used on irc buffers).

- `wait`: schedule a command execution in future

    /wait  <number>[<unit>] <command>

     number: amount of time to wait (integer number)
       unit: optional, values are:
               ms: milliseconds
                s: seconds (default)
                m: minutes
                h: hours
    command: command to execute (or text to send to buffer if command does not start with '/')

    Note: command is executed on buffer where /wait was executed (if buffer is not found (for example if it has been closed before execution of command), then command is executed on WeeChat core buffer).

    Examples:
      join channel in 10 seconds:
        /wait 10 /join #test
      set away in 15 minutes:
        /wait 15m /away -all I'm away
      say 'hello' in 2 minutes:
        /wait 2m hello

- `window`: manage windows

    /window  list
             -1|+1|b#|up|down|left|right [-window <number>]
             <number>
             splith|splitv [-window <number>] [<pct>]
             resize [-window <number>] [+/-]<pct>
             balance
             merge [-window <number>] [all]
             page_up|page_down [-window <number>]
             refresh
             scroll [-window <number>] [+/-]<value>[s|m|h|d|M|y]
             scroll_horiz [-window <number>] [+/-]<value>[%]
             scroll_up|scroll_down|scroll_top|scroll_bottom|scroll_beyond_end|scroll_previous_highlight|scroll_next_highlight|scroll_unread [-window <number>]
             swap [-window <number>] [up|down|left|right]
             zoom [-window <number>]
             bare [<delay>]

             list: list opened windows (without argument, this list is displayed)
               -1: jump to previous window
               +1: jump to next window
               b#: jump to next window displaying buffer number #
               up: switch to window above current one
             down: switch to window below current one
             left: switch to window on the left
            right: switch to window on the right
           number: window number (see /window list)
           splith: split current window horizontally (to undo: /window merge)
           splitv: split current window vertically (to undo: /window merge)
           resize: resize window size, new size is <pct> percentage of parent window
          balance: balance the sizes of all windows
            merge: merge window with another (all = keep only one window)
          page_up: scroll one page up
        page_down: scroll one page down
          refresh: refresh screen
           scroll: scroll a number of lines (+/-N) or with time: s=seconds, m=minutes, h=hours, d=days, M=months, y=years
     scroll_horiz: scroll horizontally a number of columns (+/-N) or percentage of window size (this scrolling is possible only on buffers with free content)
        scroll_up: scroll a few lines up
      scroll_down: scroll a few lines down
       scroll_top: scroll to top of buffer
    scroll_bottom: scroll to bottom of buffer
    scroll_beyond_end: scroll beyond the end of buffer
    scroll_previous_highlight: scroll to previous highlight
    scroll_next_highlight: scroll to next highlight
    scroll_unread: scroll to unread marker
             swap: swap buffers of two windows (with optional direction for target window)
             zoom: zoom on window
             bare: toggle bare display (with optional delay in seconds for automatic return to standard display mode)

    For splith and splitv, pct is a percentage which represents size of new window, computed with current window as size reference. For example 25 means create a new window with size = current_size / 4

    Examples:
      jump to window displaying buffer #1:
        /window b1
      scroll 2 lines up:
        /window scroll -2
      scroll 2 days up:
        /window scroll -2d
      scroll to beginning of current day:
        /window scroll -d
      zoom on window #2:
        /window zoom -window 2
      split window horizontally using 30%% of space for the window on top:
        /window splith 30
      remove the split:
        /window merge
      enable bare display for 2 seconds:
        /window bare 2

## 4. Plugins

A plugin is a dynamic library, written in C and compiled, which is loaded by WeeChat. Under GNU/Linux, the file has ".so" extension, ".dll" under Windows.

Plugins found are automatically loaded when WeeChat is starting, and it is possible to load or unload plugins while WeeChat is running.

It’s important to make difference between a plugin and a script: a plugin is a binary file compiled and loaded with command `/plugin`, whereas a script is a text file loaded with a plugin like python with command `/python`.

You can use command `/plugin` to load/unload a plugin, or list all loaded plugins. When a plugin is unloaded, all buffers created by this plugin are automatically closed.

Examples to load, unload or list plugins:

    /plugin load irc
    /plugin unload irc
    /plugin list

Default plugins are:

Plugin | Description
--- | ---
alias | Define alias for commands.
aspell | Spell checking for command line.
charset | Charset decoding/encoding for buffers.
exec | Execution of external commands in WeeChat.
fifo | FIFO pipe used to remotely send commands to WeeChat.
irc | IRC chat protocol.
logger | Log buffers to files.
relay | Relay data via network.
script | Scripts manager.
python | Python scripting API.
perl | Perl scripting API.
ruby | Ruby scripting API.
lua | Lua scripting API.
tcl | Tcl scripting API.
guile | Guile (scheme) scripting API.
javascript | Javascript scripting API.
trigger | Text replacement and command execution on events triggered by WeeChat/plugins.
xfer | File transfer and direct chat.

To learn more about plugin or script development (through API), please read WeeChat Plugin API Reference or WeeChat Scripting Guide.

### 4.1. Alias plugin

Alias plugin lets you create alias for commands (from WeeChat or other plugins).

#### 4.1.1. Commands

- `alias`: list, add or remove command aliases

    /alias  list [<alias>]
            add <alias> [<command>[;<command>...]]
            addcompletion <completion> <alias> [<command>[;<command>...]]
            del <alias> [<alias>...]

             list: list aliases (without argument, this list is displayed)
              add: add an alias
    addcompletion: add an alias with a custom completion
              del: delete an alias
       completion: completion for alias: by default completion is done with target command
                   note: you can use %%command to use completion of an existing command
            alias: name of alias
          command: command name with arguments (many commands can be separated by semicolons)

    Note: in command, special variables are replaced:
            $n: argument 'n' (between 1 and 9)
           $-m: arguments from 1 to 'm'
           $n-: arguments from 'n' to last
          $n-m: arguments from 'n' to 'm'
            $*: all arguments
            $~: last argument
          $var: where "var" is a local variable of buffer (see /buffer localvar)
                examples: $nick, $channel, $server, $plugin, $name

    Examples:
      alias /split to split window horizontally:
        /alias add split /window splith
      alias /hello to say "hello" on all channels but not on #weechat:
        /alias add hello /allchan -exclude=#weechat msg * hello
      alias /forcejoin to send IRC command "forcejoin" with completion of /sajoin:
        /alias addcompletion %%sajoin forcejoin /quote forcejoin

### 4.2. Aspell plugin

Aspell plugin lets you check spelling in command line. It is possible to use many languages by buffer.

#### 4.2.1. Options (aspell.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`color` | `/set aspell.color.*` | Colors.
`check` | `/set aspell.check.*` | Options to control spell checking.
`dict` | `/aspell setdict /set aspell.dict.*` | Dictionaries used by buffer (options can be added/removed in section).
`option` | `/set aspell.option.*` | Speller options (options can be added/removed in section).

Options:

- aspell.check.commands

  - description: comma separated list of commands for which spell checking is enabled (spell checking is disabled for all other commands)

  - type: string

  - values: any string

  - default value: `"ame,amsg,away,command,cycle,kick,kickban,me,msg,notice,part,query,quit,topic"`

- aspell.check.default_dict

  - description: default dictionary (or comma separated list of dictionaries) to use when buffer has no dictionary defined (leave blank to disable aspell on buffers for which you didn't explicitly enabled it)

  - type: string

  - values: any string

  - default value: `""`

- aspell.check.during_search

  - description: check words during text search in buffer

  - type: boolean

  - values: on, off

  - default value: `off`

- aspell.check.enabled

  - description: enable aspell check for command line

  - type: boolean

  - values: on, off

  - default value: `off`

- aspell.check.real_time

  - description: real-time spell checking of words (slower, disabled by default: words are checked only if there's delimiter after)

  - type: boolean

  - values: on, off

  - default value: `off`

- aspell.check.suggestions

  - description: number of suggestions to display in bar item "aspell_suggest" for each dictionary set in buffer (-1 = disable suggestions, 0 = display all possible suggestions in all languages)

  - type: integer

  - values: -1 .. 2147483647

  - default value: `-1`

- aspell.check.word_min_length

  - description: minimum length for a word to be spell checked (use 0 to check all words)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `2`

- aspell.color.misspelled

  - description: text color for misspelled words (input bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- aspell.color.suggestions

  - description: text color for suggestions on a misspelled word (status bar)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

#### 4.2.2. Commands

- `aspell`: aspell plugin configuration

    /aspell  enable|disable|toggle
             listdict
             setdict <dict>[,<dict>...]
             deldict
             addword [<dict>] <word>

      enable: enable aspell
     disable: disable aspell
      toggle: toggle aspell
    listdict: show installed dictionaries
     setdict: set dictionary for current buffer (multiple dictionaries can be separated by a comma)
     deldict: delete dictionary used on current buffer
     addword: add a word in personal aspell dictionary

    Input line beginning with a '/' is not checked, except for some commands (see /set aspell.check.commands).

    To enable aspell on all buffers, use option "default_dict", then enable aspell, for example:
      /set aspell.check.default_dict "en"
      /aspell enable

    To display a list of suggestions in a bar, use item "aspell_suggest".

    Default key to toggle aspell is alt-s.

#### 4.2.3. Speller options

Speller options can be defined by adding options in section "option" of aspell configuration.

The option name is an aspell configuration option. List of options can be found in a shell with following command:

    $ aspell config

For example, to enable option "ignore-case":

    /set aspell.option.ignore-case "true"

#### 4.2.4. Suggestions

Suggestions are displayed in a bar item called "aspell_suggest". The number of suggestions is set in option aspell.check.suggestions.

To enable suggestions you must set option aspell.check.suggestions to an integer ≥ 0 and add the bar item "aspell_suggest" to a bar, like status.

Example of suggestions with English dictionary (`en`):

    │[12:55] [6] [irc/freenode] 3:#test(+n){4} [print,prone,prune]                    │
    │[@Flashy] prinr █                                                                │
    └─────────────────────────────────────────────────────────────────────────────────┘

Example of suggestions with English and French dictionaries (`en,fr`):

    │[12:55] [6] [irc/freenode] 3:#test(+n){4} [print,prone,prune/prime,primer,primé] │
    │[@Flashy] prinr █                                                                │
    └─────────────────────────────────────────────────────────────────────────────────┘

### 4.3. Charset plugin

Charset plugin lets you decode or encode data using charsets.

There is default charset for decode/encode, and specific charsets for buffers (or group of buffers).

This plugin is optional, but recommended: if it’s not loaded, WeeChat can only read/write UTF-8 data.

Charset plugin should be autoloaded by WeeChat. To be sure plugin is loaded, try:

    /charset

If command is not found, then load plugin with command:

    /plugin load charset

If plugin is not found, then you should compile again WeeChat with plugins and Charset support.

When Charset plugin starts, it displays terminal and internal charsets. Terminal charset depends on your locale, and internal is UTF-8.

For example:

    charset: terminal: ISO-8859-15, internal: UTF-8

#### 4.3.1. Options (charset.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`default` | `/set charset.default.*` | Default decoding/encoding charset.
`decode` | `/charset decode /set charset.decode.*` | Decoding charset by buffer (options can be added/removed in section).
`encode` | `/charset encode /set charset.encode.*` | Encoding charset by buffer (options can be added/removed in section).

Options:

- charset.default.decode

  - description: global decoding charset: charset used to decode incoming messages when they are not UTF-8 valid

  - type: string

  - values: any string

  - default value: `"iso-8859-1"`

- charset.default.encode

  - description: global encoding charset: charset used to encode outgoing messages (if empty, default is UTF-8 because it is the WeeChat internal charset)

  - type: string

  - values: any string

  - default value: `""`

#### 4.3.2. Commands

- `charset`: change charset for current buffer

    /charset  decode|encode <charset>
              reset

     decode: change decoding charset
     encode: change encoding charset
    charset: new charset for current buffer
      reset: reset charsets for current buffer

#### 4.3.3. Set charset

To set global decode and encode charsets, use command `/set`.

For example:

    /set charset.default.decode ISO-8859-15
    /set charset.default.encode ISO-8859-15

If global decode charset is not set (for example during first load of Charset plugin), it will be automatically set to terminal charset (if it’s different from UTF-8), or by default to ISO-8859-1.

Default encode value is empty, so it sends by default with internal charset (UTF-8).

To set IRC server charset, use command `/charset` on server buffer. If you give only charset, then it will set decoding and encoding values.

For example:

    /charset ISO-8859-15

It’s equivalent to:

    /charset decode ISO-8859-15
    /charset encode ISO-8859-15

To set IRC channel (or private) charset, use same commands as server, but on channel (or private) buffer.

To set charset for all channels/privates of an IRC server:

    /set charset.encode.irc.freenode ISO-8859-15

To see all charsets used, use following command:

    /set charset.*

#### 4.3.4. Troubleshooting

For any problem with charsets, please look at WeeChat FAQ.

### 4.4. Exec plugin

The `/exec` command lets you execute external commands inside WeeChat and display the output locally, or send it to a buffer.

#### 4.4.1. Options (exec.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`command` | `/set exec.command.*` | Options for commands.
`color` | `/set exec.color.*` | Colors.

Options:

- exec.color.flag_finished

  - description: text color for a finished command flag in list of commands

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- exec.color.flag_running

  - description: text color for a running command flag in list of commands

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- exec.command.default_options

  - description: default options for command /exec (see /help exec); example: "-nosh -bg" to run all commands in background (no output), and without using the shell

  - type: string

  - values: any string

  - default value: `""`

- exec.command.purge_delay

  - description: delay for purging finished commands (in seconds, 0 = purge commands immediately, -1 = never purge)

  - type: integer

  - values: -1 .. 25920000

  - default value: `0`

#### 4.4.2. Commands

- `exec`: execute external commands

    /exec  -list
           [-sh|-nosh] [-bg|-nobg] [-stdin|-nostdin] [-buffer <name>] [-l|-o|-n|-nf] [-cl|-nocl] [-sw|-nosw] [-ln|-noln] [-flush|-noflush] [-color ansi|auto|irc|weechat|strip] [-rc|-norc] [-timeout <timeout>] [-name <name>] [-pipe <command>] [-hsignal <name>] <command>
           -in <id> <text>
           -inclose <id> [<text>]
           -signal <id> <signal>
           -kill <id>
           -killall
           -set <id> <property> <value>
           -del <id>|-all [<id>...]

       -list: list commands
         -sh: use the shell to execute the command (WARNING: use this option ONLY if all arguments are safe, see option -nosh)
       -nosh: do not use the shell to execute the command (required if the command has some unsafe data, for example the content of a message from another user) (default)
         -bg: run process in background: do not display process output neither return code (not compatible with options -o/-oc/-n/-nf/-pipe/-hsignal)
       -nobg: catch process output and display return code (default)
      -stdin: create a pipe for sending data to the process (with /exec -in/-inclose)
    -nostdin: do not create a pipe for stdin (default)
     -buffer: display/send output of command on this buffer (if the buffer is not found, a new buffer with name "exec.exec.xxx" is created)
          -l: display locally output of command on buffer (default)
          -o: send output of command to the buffer without executing commands (not compatible with options -bg/-pipe/-hsignal)
         -oc: send output of command to the buffer and execute commands (lines starting with "/" or another custom command char) (not compatible with options -bg/-pipe/-hsignal)
          -n: display output of command in a new buffer (not compatible with options -bg/-pipe/-hsignal)
         -nf: display output of command in a new buffer with free content (no word-wrap, no limit on number of lines) (not compatible with options -bg/-pipe/-hsignal)
         -cl: clear the new buffer before displaying output
       -nocl: append to the new buffer without clear (default)
         -sw: switch to the output buffer (default)
       -nosw: don't switch to the output buffer
         -ln: display line numbers (default in new buffer only)
       -noln: don't display line numbers
      -flush: display output of command in real time (default)
    -noflush: display output of command after its end
      -color: action on ANSI colors in output:
                 ansi: keep ANSI codes as-is
                 auto: convert ANSI colors to WeeChat/IRC (default)
                  irc: convert ANSI colors to IRC colors
              weechat: convert ANSI colors to WeeChat colors
                strip: remove ANSI colors
         -rc: display return code (default)
       -norc: don't display return code
    -timeout: set a timeout for the command (in seconds)
       -name: set a name for the command (to name it later with /exec)
       -pipe: send the output to a WeeChat/plugin command (line by line); if there are spaces in command/arguments, enclose them with double quotes; variable $line is replaced by the line (by default the line is added after the command, separated by a space) (not compatible with options -bg/-o/-oc/-n/-nf)
    -hsignal: send the output as a hsignal (to be used for example in a trigger) (not compatible with options -bg/-o/-oc/-n/-nf)
     command: the command to execute; if beginning with "url:", the shell is disabled and the content of URL is downloaded and sent as output
          id: command identifier: either its number or name (if set with "-name xxx")
         -in: send text on standard input of process
    -inclose: same as -in, but stdin is closed after (and text is optional: without text, the stdin is just closed)
     -signal: send a signal to the process; the signal can be an integer or one of these names: hup, int, quit, kill, term, usr1, usr2
       -kill: alias of "-signal <id> kill"
    -killall: kill all running processes
        -set: set a hook property (see function hook_set in plugin API reference)
    property: hook property
       value: new value for hook property
        -del: delete a terminated command
        -all: delete all terminated commands

    Default options can be set in the option exec.command.default_options.

    Examples:
      /exec -n ls -l /tmp
      /exec -sh -n ps xu | grep weechat
      /exec -n -norc url:http://pastebin.com/raw.php?i=xxxxxxxx
      /exec -nf -noln links -dump https://weechat.org/files/doc/devel/weechat_user.en.html
      /exec -o uptime
      /exec -pipe "/print Machine uptime:" uptime
      /exec -n tail -f /var/log/messages
      /exec -kill 0

### 4.5. Fifo plugin

You can remote control WeeChat, by sending commands or text to a FIFO pipe (if option "fifo.file.enabled" is enabled, it is by default).

The FIFO pipe is located in ~/.weechat/ and is called weechat_fifo by default.

Syntax for the FIFO pipe commands/text is one of following:

      plugin.buffer *text or command here
      *text or command here

Some examples:

- Change nick on IRC server freenode to "newnick":

    $ echo 'irc.server.freenode */nick newnick' >~/.weechat/weechat_fifo

- Send a message on IRC #weechat channel:

    $ echo 'irc.freenode.#weechat *hello!' >~/.weechat/weechat_fifo

- Send a message on current buffer:

    $ echo '*hello!' >~/.weechat/weechat_fifo

- Send two commands to unload/reload Python scripts (you have to separate them with "\n"):

    $ printf '%b' '*/python unload\n*/python autoload\n' >~/.weechat/weechat_fifo

#### 4.5.1. Options (fifo.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`file` | `/set fifo.file.*` | FIFO pipe control.

Options:

- fifo.file.enabled

  - description: enable FIFO pipe

  - type: boolean

  - values: on, off

  - default value: `on`

- fifo.file.path

  - description: path for FIFO file; "%h" at beginning of string is replaced by WeeChat home ("~/.weechat" by default); WeeChat PID can be used in path with ${info:pid} (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"%h/weechat_fifo"`

#### 4.5.2. Commands

- `fifo`: fifo plugin configuration

    /fifo  enable|disable|toggle

     enable: enable FIFO pipe
    disable: disable FIFO pipe
     toggle: toggle FIFO pipe

    FIFO pipe is used as remote control of WeeChat: you can send commands or text to the FIFO pipe from your shell.
    By default the FIFO pipe is in ~/.weechat/weechat_fifo

    The expected format is one of:
      plugin.buffer *text or command here
      *text or command here

    For example to change your freenode nick:
      echo 'irc.server.freenode */nick newnick' >~/.weechat/weechat_fifo

    Please read the user's guide for more info and examples.

    Examples:
      /fifo toggle

### 4.6. IRC plugin

The IRC plugin is designed to chat through IRC protocol with other people.

It is multi-servers, and offers all supported IRC commands including DCC chat and file transfer (via xfer plugin, see Xfer plugin).

#### 4.6.1. Command line options

It is possible to give URL for one or many IRC servers, as follow:

    irc[6][s]://[nick[:password]@]irc.example.org[:port][/channel][,channel[...]]

Example to join #weechat and #toto on server chat.freenode.net server, default port (6667), with nick nono:

    $ weechat irc://nono@chat.freenode.net/#weechat,#toto

#### 4.6.2. Options (irc.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set irc.look.*` | Look and feel.
`color` | `/set irc.color.*` | Colors.
`network` | `/set irc.network.*` | Network options.
`msgbuffer` | `/set irc.msgbuffer.*` | Target buffer for IRC messages (options can be added/removed in section).
`ctcp` | `/set irc.ctcp.*` | CTCP replies (options can be added/removed in section).
`ignore` | `/ignore` | Ignore people.
`server_default` | `/set irc.server_default.*` | Default values for servers (used when options in server are not defined).
`server` | `/server /set irc.server.*` | Servers.

Options:

- irc.color.input_nick

  - description: color for nick in input bar

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- irc.color.item_channel_modes

  - description: color for channel modes, near channel name

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.color.item_lag_counting

  - description: color for lag indicator, when counting (pong not received from server, lag is increasing)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.color.item_lag_finished

  - description: color for lag indicator, when pong has been received from server

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- irc.color.item_nick_modes

  - description: color for nick modes in bar item "input_prompt"

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.color.message_join

  - description: color for text in join messages

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- irc.color.message_quit

  - description: color for text in part/quit messages

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `red`

- irc.color.mirc_remap

  - description: remap mirc colors in messages using a hashtable: keys are "fg,bg" as integers between -1 (not specified) and 15, values are WeeChat color names or numbers (format is: "1,-1:color1;2,7:color2"), example: "1,-1:darkgray;1,2:white,blue" to remap black to "darkgray" and black on blue to "white,blue"; default WeeChat colors for IRC codes: 0=white, 1=black, 2=blue, 3=green, 4=lightred, 5=red, 6=magenta, 7=brown, 8=yellow, 9=lightgreen, 10=cyan, 11=lightcyan, 12=lightblue, 13=lightmagenta, 14=gray, 15=white

  - type: string

  - values: any string

  - default value: `"1,-1:darkgray"`

- irc.color.nick_prefixes

  - description: color for nick prefixes using mode char (o=op, h=halfop, v=voice, ..), format is: "o:color1;h:color2;v:color3" (if a mode is not found, WeeChat will try with next modes received from server ("PREFIX"); a special mode "*" can be used as default color if no mode has been found in list)

  - type: string

  - values: any string

  - default value: `"y:lightred;q:lightred;a:lightcyan;o:lightgreen;h:lightmagenta;v:yellow;*:lightblue"`

- irc.color.notice

  - description: color for text "Notice" in notices

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- irc.color.reason_quit

  - description: color for reason in part/quit messages

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.color.topic_current

  - description: color for current channel topic (when joining a channel or using /topic)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.color.topic_new

  - description: color for new channel topic (when topic is changed)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- irc.color.topic_old

  - description: color for old channel topic (when topic is changed)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- irc.look.buffer_open_before_autojoin

  - description: open channel buffer before the JOIN is received from server when it is auto joined (with server option "autojoin"); this is useful to open channels with always the same buffer numbers on startup

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.buffer_open_before_join

  - description: open channel buffer before the JOIN is received from server when it is manually joined (with /join command)

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.buffer_switch_autojoin

  - description: auto switch to channel buffer when it is auto joined (with server option "autojoin")

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.buffer_switch_join

  - description: auto switch to channel buffer when it is manually joined (with /join command)

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.color_nicks_in_names

  - description: use nick color in output of /names (or list of nicks displayed when joining a channel)

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.color_nicks_in_nicklist

  - description: use nick color in nicklist

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.color_nicks_in_server_messages

  - description: use nick color in messages from server

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.color_pv_nick_like_channel

  - description: use same nick color for channel and private

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.ctcp_time_format

  - description: time format used in answer to message CTCP TIME (see man strftime for date/time specifiers)

  - type: string

  - values: any string

  - default value: `"%a, %d %b %Y %T %z"`

- irc.look.display_away

  - description: display message when (un)marking as away (off: do not display/send anything, local: display locally, channel: send action to channels)

  - type: integer

  - values: off, local, channel

  - default value: `local`

- irc.look.display_ctcp_blocked

  - description: display CTCP message even if it is blocked

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_ctcp_reply

  - description: display CTCP reply sent by WeeChat

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_ctcp_unknown

  - description: display CTCP message even if it is unknown CTCP

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_host_join

  - description: display host in join messages

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_host_join_local

  - description: display host in join messages from local client

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_host_quit

  - description: display host in part/quit messages

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_join_message

  - description: comma-separated list of messages to display after joining a channel: 324 = channel modes, 329 = channel creation date, 332 = topic, 333 = nick/date for topic, 353 = names on channel, 366 = names count

  - type: string

  - values: any string

  - default value: `"329,332,333,366"`

- irc.look.display_old_topic

  - description: display old topic when channel topic is changed

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_pv_away_once

  - description: display remote away message only once in private

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.display_pv_back

  - description: display a message in private when user is back (after quit on server)

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.highlight_channel

  - description: comma separated list of words to highlight in channel buffers (case insensitive, use "(?-i)" at beginning of words to make them case sensitive; special variables $nick, $channel and $server are replaced by their value), these words are added to buffer property "highlight_words" only when buffer is created (it does not affect current buffers), an empty string disables default highlight on nick, examples: "$nick", "(?-i)$nick"

  - type: string

  - values: any string

  - default value: `"$nick"`

- irc.look.highlight_pv

  - description: comma separated list of words to highlight in private buffers (case insensitive, use "(?-i)" at beginning of words to make them case sensitive; special variables $nick, $channel and $server are replaced by their value), these words are added to buffer property "highlight_words" only when buffer is created (it does not affect current buffers), an empty string disables default highlight on nick, examples: "$nick", "(?-i)$nick"

  - type: string

  - values: any string

  - default value: `"$nick"`

- irc.look.highlight_server

  - description: comma separated list of words to highlight in server buffers (case insensitive, use "(?-i)" at beginning of words to make them case sensitive; special variables $nick, $channel and $server are replaced by their value), these words are added to buffer property "highlight_words" only when buffer is created (it does not affect current buffers), an empty string disables default highlight on nick, examples: "$nick", "(?-i)$nick"

  - type: string

  - values: any string

  - default value: `"$nick"`

- irc.look.highlight_tags_restrict

  - description: restrict highlights to these tags on irc buffers (to have highlight on user messages but not server messages); tags must be separated by a comma and "+" can be used to make a logical "and" between tags; wildcard "*" is allowed in tags; an empty value allows highlight on any tag

  - type: string

  - values: any string

  - default value: `"irc_privmsg,irc_notice"`

- irc.look.item_channel_modes_hide_args

  - description: hide channel modes arguments if at least one of these modes is in channel modes ("*" to always hide all arguments, empty value to never hide arguments); example: "kf" to hide arguments if "k" or "f" are in channel modes

  - type: string

  - values: any string

  - default value: `"k"`

- irc.look.item_display_server

  - description: name of bar item where IRC server is displayed (for status bar)

  - type: integer

  - values: buffer_plugin, buffer_name

  - default value: `buffer_plugin`

- irc.look.item_nick_modes

  - description: display nick modes in bar item "input_prompt"

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.item_nick_prefix

  - description: display nick prefix in bar item "input_prompt"

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.join_auto_add_chantype

  - description: automatically add channel type in front of channel name on command /join if the channel name does not start with a valid channel type for the server; for example: "/join weechat" will in fact send: "/join #weechat"

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.msgbuffer_fallback

  - description: default target buffer for msgbuffer options when target is private and that private buffer is not found

  - type: integer

  - values: current, server

  - default value: `current`

- irc.look.new_channel_position

  - description: force position of new channel in list of buffers (none = default position (should be last buffer), next = current buffer + 1, near_server = after last channel/pv of server)

  - type: integer

  - values: none, next, near_server

  - default value: `none`

- irc.look.new_pv_position

  - description: force position of new private in list of buffers (none = default position (should be last buffer), next = current buffer + 1, near_server = after last channel/pv of server)

  - type: integer

  - values: none, next, near_server

  - default value: `none`

- irc.look.nick_completion_smart

  - description: smart completion for nicks (completes first with last speakers): speakers = all speakers (including highlights), speakers_highlights = only speakers with highlight

  - type: integer

  - values: off, speakers, speakers_highlights

  - default value: `speakers`

- irc.look.nick_mode

  - description: display nick mode (op, voice, ...) before nick (none = never, prefix = in prefix only (default), action = in action messages only, both = prefix + action messages)

  - type: integer

  - values: none, prefix, action, both

  - default value: `prefix`

- irc.look.nick_mode_empty

  - description: display a space if nick mode is enabled but nick has no mode (not op, voice, ...)

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.nicks_hide_password

  - description: comma separated list of nicks for which passwords will be hidden when a message is sent, for example to hide password in message displayed by "/msg nickserv identify password", example: "nickserv,nickbot"

  - type: string

  - values: any string

  - default value: `"nickserv"`

- irc.look.notice_as_pv

  - description: display notices as private messages (if auto, use private buffer if found)

  - type: integer

  - values: auto, never, always

  - default value: `auto`

- irc.look.notice_welcome_redirect

  - description: automatically redirect channel welcome notices to the channel buffer; such notices have the nick as target but a channel name in beginning of notice message, for example notices sent by freenode server which look like: "[#channel] Welcome to this channel..."

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.notice_welcome_tags

  - description: comma separated list of tags used in a welcome notices redirected to a channel, for example: "notify_private"

  - type: string

  - values: any string

  - default value: `""`

- irc.look.notify_tags_ison

  - description: comma separated list of tags used in messages displayed by notify when a nick joins or quits server (result of command ison or monitor), for example: "notify_message", "notify_private" or "notify_highlight"

  - type: string

  - values: any string

  - default value: `"notify_message"`

- irc.look.notify_tags_whois

  - description: comma separated list of tags used in messages displayed by notify when a nick away status changes (result of command whois), for example: "notify_message", "notify_private" or "notify_highlight"

  - type: string

  - values: any string

  - default value: `"notify_message"`

- irc.look.part_closes_buffer

  - description: close buffer when /part is issued on a channel

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.pv_buffer

  - description: merge private buffers

  - type: integer

  - values: independent, merge_by_server, merge_all

  - default value: `independent`

- irc.look.pv_tags

  - description: comma separated list of tags used in private messages, for example: "notify_message", "notify_private" or "notify_highlight"

  - type: string

  - values: any string

  - default value: `"notify_private"`

- irc.look.raw_messages

  - description: number of raw messages to save in memory when raw data buffer is closed (messages will be displayed when opening raw data buffer)

  - type: integer

  - values: 0 .. 65535

  - default value: `256`

- irc.look.server_buffer

  - description: merge server buffers

  - type: integer

  - values: merge_with_core, merge_without_core, independent

  - default value: `merge_with_core`

- irc.look.smart_filter

  - description: filter join/part/quit/nick messages for a nick if not speaking for some minutes on channel (you must create a filter on tag "irc_smart_filter")

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.smart_filter_delay

  - description: delay for filtering join/part/quit messages (in minutes): if the nick did not speak during the last N minutes, the join/part/quit is filtered

  - type: integer

  - values: 1 .. 10080

  - default value: `5`

- irc.look.smart_filter_join

  - description: enable smart filter for "join" messages

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.smart_filter_join_unmask

  - description: delay for unmasking a join message that was filtered with tag "irc_smart_filter" (in minutes): if a nick has joined max N minutes ago and then says something on channel (message, notice or update on topic), the join is unmasked, as well as nick changes after this join (0 = disable: never unmask a join)

  - type: integer

  - values: 0 .. 10080

  - default value: `30`

- irc.look.smart_filter_mode

  - description: enable smart filter for "mode" messages: "*" to filter all modes, "+" to filter all modes in server prefixes (for example "ovh"), "xyz" to filter only modes x/y/z, "-xyz" to filter all modes but not x/y/z; examples: "ovh": filter modes o/v/h, "-bkl": filter all modes but not b/k/l

  - type: string

  - values: any string

  - default value: `""+`

- irc.look.smart_filter_nick

  - description: enable smart filter for "nick" messages (nick changes)

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.smart_filter_quit

  - description: enable smart filter for "part" and "quit" messages

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.look.temporary_servers

  - description: enable automatic addition of temporary servers with command /connect

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.look.topic_strip_colors

  - description: strip colors in topic (used only when displaying buffer title)

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.network.autoreconnect_delay_growing

  - description: growing factor for autoreconnect delay to server (1 = always same delay, 2 = delay*2 for each retry, ..)

  - type: integer

  - values: 1 .. 100

  - default value: `2`

- irc.network.autoreconnect_delay_max

  - description: maximum autoreconnect delay to server (in seconds, 0 = no maximum)

  - type: integer

  - values: 0 .. 604800

  - default value: `600`

- irc.network.ban_mask_default

  - description: default ban mask for commands /ban, /unban and /kickban; variables $nick, $user, $ident and $host are replaced by their values (extracted from "nick!user@host"); $ident is the same as $user if $user does not start with "~", otherwise it is set to "*"; this default mask is used only if WeeChat knows the host for the nick

  - type: string

  - values: any string

  - default value: `"*!$ident@$host"`

- irc.network.channel_encode

  - description: decode/encode channel name inside messages using charset options; it is recommended to keep that off if you use only UTF-8 in channel names; you can enable this option if you are using an exotic charset like ISO in channel names

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.network.colors_receive

  - description: when off, colors codes are ignored in incoming messages

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.network.colors_send

  - description: allow user to send colors with special codes (ctrl-c + a code and optional color: b=bold, cxx=color, cxx,yy=color+background, i=italic, o=disable color/attributes, r=reverse, u=underline)

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.network.lag_check

  - description: interval between two checks for lag (in seconds, 0 = never check)

  - type: integer

  - values: 0 .. 604800

  - default value: `60`

- irc.network.lag_max

  - description: maximum lag (in seconds): if this lag is reached, WeeChat will consider that the answer from server (pong) will never be received and will give up counting the lag (0 = never give up)

  - type: integer

  - values: 0 .. 604800

  - default value: `1800`

- irc.network.lag_min_show

  - description: minimum lag to show (in milliseconds)

  - type: integer

  - values: 0 .. 86400000

  - default value: `500`

- irc.network.lag_reconnect

  - description: reconnect to server if lag is greater than or equal to this value (in seconds, 0 = never reconnect); this value must be less than or equal to irc.network.lag_max

  - type: integer

  - values: 0 .. 604800

  - default value: `300`

- irc.network.lag_refresh_interval

  - description: interval between two refreshs of lag item, when lag is increasing (in seconds)

  - type: integer

  - values: 1 .. 3600

  - default value: `1`

- irc.network.notify_check_ison

  - description: interval between two checks for notify with IRC command "ison" (in minutes)

  - type: integer

  - values: 1 .. 10080

  - default value: `1`

- irc.network.notify_check_whois

  - description: interval between two checks for notify with IRC command "whois" (in minutes)

  - type: integer

  - values: 1 .. 10080

  - default value: `5`

- irc.network.sasl_fail_unavailable

  - description: cause SASL authentication failure when SASL is requested but unavailable on the server; when this option is enabled, it has effect only if option "sasl_fail" is set to "reconnect" or "disconnect" in the server

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.network.send_unknown_commands

  - description: send unknown commands to server

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.network.whois_double_nick

  - description: double the nick in /whois command (if only one nick is given), to get idle time in answer; for example: "/whois nick" will send "whois nick nick"

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.server_default.addresses

  - description: list of hostname/port or IP/port for server (separated by comma) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.anti_flood_prio_high

  - description: anti-flood for high priority queue: number of seconds between two user messages or commands sent to IRC server (0 = no anti-flood)

  - type: integer

  - values: 0 .. 60

  - default value: `2`

- irc.server_default.anti_flood_prio_low

  - description: anti-flood for low priority queue: number of seconds between two messages sent to IRC server (messages like automatic CTCP replies) (0 = no anti-flood)

  - type: integer

  - values: 0 .. 60

  - default value: `2`

- irc.server_default.autoconnect

  - description: automatically connect to server when WeeChat is starting

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.server_default.autojoin

  - description: comma separated list of channels to join after connection to server (and after executing command + delay if they are set); the channels that require a key must be at beginning of the list, and all the keys must be given after the channels (separated by a space) (example: "#channel1,#channel2,#channel3 key1,key2" where #channel1 and #channel2 are protected by key1 and key2) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.autoreconnect

  - description: automatically reconnect to server when disconnected

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.server_default.autoreconnect_delay

  - description: delay (in seconds) before trying again to reconnect to server

  - type: integer

  - values: 1 .. 65535

  - default value: `10`

- irc.server_default.autorejoin

  - description: automatically rejoin channels after kick; you can define a buffer local variable on a channel to override this value (name of variable: "autorejoin", value: "on" or "off")

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.server_default.autorejoin_delay

  - description: delay (in seconds) before autorejoin (after kick)

  - type: integer

  - values: 0 .. 86400

  - default value: `30`

- irc.server_default.away_check

  - description: interval between two checks for away (in minutes, 0 = never check)

  - type: integer

  - values: 0 .. 10080

  - default value: `0`

- irc.server_default.away_check_max_nicks

  - description: do not check away nicks on channels with high number of nicks (0 = unlimited)

  - type: integer

  - values: 0 .. 1000000

  - default value: `25`

- irc.server_default.capabilities

  - description: comma-separated list of client capabilities to enable for server if they are available (see /help cap for a list of capabilities supported by WeeChat) (example: "away-notify,multi-prefix")

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.command

  - description: command(s) to run after connection to server and before auto-join of channels (many commands can be separated by ";", use "\;" for a semicolon, special variables $nick, $channel and $server are replaced by their value) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.command_delay

  - description: delay (in seconds) after execution of command and before auto-join of channels (example: give some time for authentication before joining channels)

  - type: integer

  - values: 0 .. 3600

  - default value: `0`

- irc.server_default.connection_timeout

  - description: timeout (in seconds) between TCP connection to server and message 001 received, if this timeout is reached before 001 message is received, WeeChat will disconnect from server

  - type: integer

  - values: 1 .. 3600

  - default value: `60`

- irc.server_default.ipv6

  - description: use IPv6 protocol for server communication (try IPv6 then fallback to IPv4); if disabled, only IPv4 is used

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.server_default.local_hostname

  - description: custom local hostname/IP for server (optional, if empty local hostname is used)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.msg_kick

  - description: default kick message used by commands "/kick" and "/kickban" (note: content is evaluated, see /help eval; special variables ${nick}, ${channel} and ${server} are replaced by their value)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.msg_part

  - description: default part message (leaving channel) (note: content is evaluated, see /help eval; special variables ${nick}, ${channel} and ${server} are replaced by their value; "%v" is replaced by WeeChat version if there is no ${...} in string)

  - type: string

  - values: any string

  - default value: `"WeeChat ${info:version}"`

- irc.server_default.msg_quit

  - description: default quit message (disconnecting from server) (note: content is evaluated, see /help eval; special variables ${nick}, ${channel} and ${server} are replaced by their value; "%v" is replaced by WeeChat version if there is no ${...} in string)

  - type: string

  - values: any string

  - default value: `"WeeChat ${info:version}"`

- irc.server_default.nicks

  - description: nicknames to use on server (separated by comma) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.nicks_alternate

  - description: get an alternate nick when all the declared nicks are already used on server: add some "_" until the nick has a length of 9, and then replace last char (or the two last chars) by a number from 1 to 99, until we find a nick not used on server

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.server_default.notify

  - description: notify list for server (you should not change this option but use /notify command instead)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.password

  - description: password for server (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.proxy

  - description: name of proxy used for this server (optional, proxy must be defined with command /proxy)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.realname

  - description: real name to use on server (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.sasl_fail

  - description: action to perform if SASL authentication fails: "continue" to ignore the authentication problem, "reconnect" to schedule a reconnection to the server, "disconnect" to disconnect from server (see also option irc.network.sasl_fail_unavailable)

  - type: integer

  - values: continue, reconnect, disconnect

  - default value: `continue`

- irc.server_default.sasl_key

  - description: file with ECC private key for mechanism "ecdsa-nist256p-challenge" ("%h" will be replaced by WeeChat home, "~/.weechat" by default)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.sasl_mechanism

  - description: mechanism for SASL authentication: "plain" for plain text password, "ecdsa-nist256p-challenge" for key-based challenge authentication, "external" for authentication using client side SSL cert, "dh-blowfish" for blowfish crypted password (insecure, not recommended), "dh-aes" for AES crypted password (insecure, not recommended)

  - type: integer

  - values: plain, ecdsa-nist256p-challenge, external, dh-blowfish, dh-aes

  - default value: `plain`

- irc.server_default.sasl_password

  - description: password for SASL authentication; this option is not used for mechanisms "ecdsa-nist256p-challenge" and "external" (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.sasl_timeout

  - description: timeout (in seconds) before giving up SASL authentication

  - type: integer

  - values: 1 .. 3600

  - default value: `15`

- irc.server_default.sasl_username

  - description: username for SASL authentication; this option is not used for mechanism "external" (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.ssl

  - description: use SSL for server communication

  - type: boolean

  - values: on, off

  - default value: `off`

- irc.server_default.ssl_cert

  - description: SSL certificate file used to automatically identify your nick ("%h" will be replaced by WeeChat home, "~/.weechat" by default)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.ssl_dhkey_size

  - description: size of the key used during the Diffie-Hellman Key Exchange

  - type: integer

  - values: 0 .. 2147483647

  - default value: `2048`

- irc.server_default.ssl_fingerprint

  - description: fingerprint of certificate which is trusted and accepted for the server; only hexadecimal digits are allowed (0-9, a-f): 64 chars for SHA-512, 32 chars for SHA-256, 20 chars for SHA-1 (insecure, not recommended); many fingerprints can be separated by commas; if this option is set, the other checks on certificates are NOT performed (option "ssl_verify") (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.ssl_priorities

  - description: string with priorities for gnutls (for syntax, see documentation of function gnutls_priority_init in gnutls manual, common strings are: "PERFORMANCE", "NORMAL", "SECURE128", "SECURE256", "EXPORT", "NONE")

  - type: string

  - values: any string

  - default value: `"NORMAL:-VERS-SSL3.0"`

- irc.server_default.ssl_verify

  - description: check that the SSL connection is fully trusted

  - type: boolean

  - values: on, off

  - default value: `on`

- irc.server_default.usermode

  - description: user mode(s) to set after connection to server and before executing command and the auto-join of channels; examples: "+R" (to set mode "R"), "+R-i" (to set mode "R" and remove "i"); see /help mode for the complete mode syntax (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- irc.server_default.username

  - description: user name to use on server (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

#### 4.6.3. Commands

- `admin`: find information about the administrator of the server

    /admin  [<target>]

    target: server name

- `allchan`: execute a command on all channels of all connected servers

    /allchan  [-current] [-exclude=<channel>[,<channel>...]] <command> [<arguments>]

     -current: execute command for channels of current server only
     -exclude: exclude some channels (wildcard "*" is allowed)
      command: command to execute
    arguments: arguments for command (special variables $nick, $channel and $server are replaced by their value)

    Examples:
      execute '/me is testing' on all channels:
        /allchan me is testing
      say 'hello' everywhere but not on #weechat:
        /allchan -exclude=#weechat msg * hello
      say 'hello' everywhere but not on #weechat and channels beginning with #linux:
        /allchan -exclude=#weechat,#linux* msg * hello

- `allpv`: execute a command on all private buffers of all connected servers

    /allpv  [-current] [-exclude=<nick>[,<nick>...]] <command> [<arguments>]

     -current: execute command for private buffers of current server only
     -exclude: exclude some nicks (wildcard "*" is allowed)
      command: command to execute
    arguments: arguments for command (special variables $nick, $channel and $server are replaced by their value)

    Examples:
      execute '/me is testing' on all private buffers:
        /allpv me is testing
      say 'hello' everywhere but not for nick foo:
        /allpv -exclude=foo msg * hello
      say 'hello' everywhere but not for nick foo and nicks beginning with bar:
        /allpv -exclude=foo,bar* msg * hello
      close all private buffers:
        /allpv close

- `allserv`: execute a command on all connected servers

    /allserv  [-exclude=<server>[,<server>...]] <command> [<arguments>]

     -exclude: exclude some servers (wildcard "*" is allowed)
      command: command to execute
    arguments: arguments for command (special variables $nick, $channel and $server are replaced by their value)

    Examples:
      change nick on all servers:
        /allserv nick newnick
      set away on all servers:
        /allserv away I'm away
      do a whois on my nick on all servers:
        /allserv whois $nick

- `ban`: ban nicks or hosts

    /ban  [<channel>] [<nick> [<nick>...]]

    channel: channel name
       nick: nick or host

    Without argument, this command displays the ban list for current channel.

- `cap`: client capability negotiation

    /cap  ls
          list
          req|ack [<capability> [<capability>...]]
          end

       ls: list the capabilities supported by the server
     list: list the capabilities currently enabled
      req: request a capability
      ack: acknowledge capabilities which require client-side acknowledgement
      end: end the capability negotiation

    Without argument, "ls" and "list" are sent.

    Capabilities supported by WeeChat are: account-notify, away-notify, cap-notify, extended-join, multi-prefix, server-time, userhost-in-names.

    The capabilities to automatically enable on servers can be set in option irc.server_default.capabilities (or by server in option irc.server.xxx.capabilities).

    Examples:
       /cap
       /cap req multi-prefix away-notify

- `connect`: connect to IRC server(s)

    /connect  <server> [<server>...] [-<option>[=<value>]] [-no<option>] [-nojoin] [-switch]
              -all|-auto|-open [-nojoin] [-switch]

        server: server name, which can be:
                - internal server name (added by /server add, recommended usage)
                - hostname/port or IP/port, port is 6667 by default
                - URL with format: irc[6][s]://[nickname[:password]@]irc.example.org[:port][/#channel1][,#channel2[...]]
                Note: for an address/IP/URL, a temporary server is added (NOT SAVED), see /help irc.look.temporary_servers
        option: set option for server (for boolean option, value can be omitted)
      nooption: set boolean option to 'off' (for example: -nossl)
          -all: connect to all servers defined in configuration
         -auto: connect to servers with autoconnect enabled
         -open: connect to all opened servers that are not currently connected
       -nojoin: do not join any channel (even if autojoin is enabled on server)
       -switch: switch to next server address

    To disconnect from a server or stop any connection attempt, use command /disconnect.

    Examples:
      /connect freenode
      /connect irc.oftc.net/6667
      /connect irc6.oftc.net/6667 -ipv6
      /connect irc6.oftc.net/6697 -ipv6 -ssl
      /connect my.server.org/6697 -ssl -password=test
      /connect irc://nick@irc.oftc.net/#channel
      /connect -switch

- `ctcp`: send a CTCP message (Client-To-Client Protocol)

    /ctcp  [-server <server>] <target>[,<target>...] <type> [<arguments>]

       server: send to this server (internal name)
       target: nick or channel ('*' = current channel)
         type: CTCP type (examples: "version", "ping", ..)
    arguments: arguments for CTCP

    Examples:
      /ctcp toto time
      /ctcp toto version
      /ctcp * version

- `cycle`: leave and rejoin a channel

    /cycle  [<channel>[,<channel>...]] [<message>]

    channel: channel name
    message: part message (displayed to other users)

- `dcc`: start a DCC (file transfer or direct chat)

    /dcc  chat <nick>
          send <nick> <file>

    nick: nick
    file: filename (on local host)

    Examples:
      chat with nick "toto":
        /dcc chat toto
      send file "/home/foo/bar.txt" to nick "toto":
        /dcc send toto /home/foo/bar.txt

- `dehalfop`: remove channel half-operator status from nick(s)

    /dehalfop  <nick> [<nick>...]

    nick: nick or mask (wildcard "*" is allowed)
       *: remove channel half-operator status from everybody on channel except yourself

- `deop`: remove channel operator status from nick(s)

    /deop  <nick> [<nick>...]
           * -yes

    nick: nick or mask (wildcard "*" is allowed)
       *: remove channel operator status from everybody on channel except yourself

- `devoice`: remove voice from nick(s)

    /devoice  <nick> [<nick>...]
              * -yes

    nick: nick or mask (wildcard "*" is allowed)
       *: remove voice from everybody on channel

- `die`: shutdown the server

    /die  [<target>]

    target: server name

- `disconnect`: disconnect from one or all IRC servers

    /disconnect  [<server>|-all|-pending [<reason>]]

      server: internal server name
        -all: disconnect from all servers
    -pending: cancel auto-reconnection on servers currently reconnecting
      reason: reason for the "quit"

- `halfop`: give channel half-operator status to nick(s)

    /halfop  <nick> [<nick>...]
             * -yes

    nick: nick or mask (wildcard "*" is allowed)
       *: give channel half-operator status to everybody on channel

- `ignore`: ignore nicks/hosts from servers or channels

    /ignore  list
             add [re:]<nick> [<server> [<channel>]]
             del <number>|-all

         list: list all ignores
          add: add an ignore
         nick: nick or hostname (can be a POSIX extended regular expression if "re:" is given or a mask using "*" to replace zero or more chars)
          del: delete an ignore
       number: number of ignore to delete (look at list to find it)
         -all: delete all ignores
       server: internal server name where ignore is working
      channel: channel name where ignore is working

    Note: the regular expression can start with "(?-i)" to become case sensitive.

    Examples:
      ignore nick "toto" everywhere:
        /ignore add toto
      ignore host "toto@domain.com" on freenode server:
        /ignore add toto@domain.com freenode
      ignore host "toto*@*.domain.com" on freenode/#weechat:
        /ignore add toto*@*.domain.com freenode #weechat

- `info`: get information describing the server

    /info  [<target>]

    target: server name

- `invite`: invite a nick on a channel

    /invite  <nick> [<nick>...] [<channel>]

       nick: nick
    channel: channel name

- `ison`: check if a nick is currently on IRC

    /ison  <nick> [<nick>...]

    nick: nick

- `join`: join a channel

    /join  [-noswitch] [-server <server>] [<channel1>[,<channel2>...]] [<key1>[,<key2>...]]

    -noswitch: do not switch to new buffer
       server: send to this server (internal name)
      channel: channel name to join
          key: key to join the channel (channels with a key must be the first in list)

    Examples:
      /join #weechat
      /join #protectedchan,#weechat key
      /join -server freenode #weechat
      /join -noswitch #weechat

- `kick`: kick a user out of a channel

    /kick  [<channel>] <nick> [<reason>]

    channel: channel name
       nick: nick
     reason: reason (special variables $nick, $channel and $server are replaced by their value)

- `kickban`: kick a user out of a channel and ban the host

    /kickban  [<channel>] <nick> [<reason>]

    channel: channel name
       nick: nick
     reason: reason (special variables $nick, $channel and $server are replaced by their value)

    It is possible to kick/ban with a mask, nick will be extracted from mask and replaced by "*".

    Example:
      ban "*!*@host.com" and then kick "toto":
        /kickban toto!*@host.com

- `kill`: close client-server connection

    /kill  <nick> [<reason>]

      nick: nick
    reason: reason

- `links`: list all servernames which are known by the server answering the query

    /links  [[<server>] <server_mask>]

         server: this server should answer the query
    server_mask: list of servers must match this mask

- `list`: list channels and their topic

    /list  [<channel>[,<channel>...]] [<server>] [-re <regex>]

    channel: channel to list
     server: server name
      regex: POSIX extended regular expression used to filter results (case insensitive, can start by "(?-i)" to become case sensitive)

    Examples:
      list all channels on server (can be very slow on large networks):
        /list
      list channel #weechat:
        /list #weechat
      list all channels beginning with "#weechat" (can be very slow on large networks):
        /list -re #weechat.*

- `lusers`: get statistics about the size of the IRC network

    /lusers  [<mask> [<target>]]

      mask: servers matching the mask only
    target: server for forwarding request

- `map`: show a graphical map of the IRC network

- `me`: send a CTCP action to the current channel

    /me  <message>

    message: message to send

- `mode`: change channel or user mode

    /mode  [<channel>] [+|-]o|p|s|i|t|n|m|l|b|e|v|k [<arguments>]
           <nick> [+|-]i|s|w|o

    channel modes:
      channel: channel name to modify (default is current one)
      o: give/take channel operator privileges
      p: private channel flag
      s: secret channel flag
      i: invite-only channel flag
      t: topic settable by channel operator only flag
      n: no messages to channel from clients on the outside
      m: moderated channel
      l: set the user limit to channel
      b: set a ban mask to keep users out
      e: set exception mask
      v: give/take the ability to speak on a moderated channel
      k: set a channel key (password)
    user modes:
      nick: nick to modify
      i: mark a user as invisible
      s: mark a user for receive server notices
      w: user receives wallops
      o: operator flag

    List of modes is not comprehensive, you should read documentation about your server to see all possible modes.

    Examples:
      protect topic on channel #weechat:
        /mode #weechat +t
      become invisible on server:
        /mode nick +i

- `motd`: get the "Message Of The Day"

    /motd  [<target>]

    target: server name

- `msg`: send message to a nick or channel

    /msg  [-server <server>] <target>[,<target>...] <text>

    server: send to this server (internal name)
    target: nick or channel (may be mask, '*' = current channel)
      text: text to send

- `names`: list nicks on channels

    /names  [<channel>[,<channel>...]]

    channel: channel name

- `nick`: change current nick

    /nick  [-all] <nick>

    -all: set new nick for all connected servers
    nick: new nick

- `notice`: send notice message to user

    /notice  [-server <server>] <target> <text>

    server: send to this server (internal name)
    target: nick or channel name
      text: text to send

- `notify`: add a notification for presence or away status of nicks on servers

    /notify  add <nick> [<server> [-away]]
             del <nick>|-all [<server>]

       add: add a notification
      nick: nick
    server: internal server name (by default current server)
     -away: notify when away message is changed (by doing whois on nick)
       del: delete a notification
      -all: delete all notifications

    Without argument, this command displays notifications for current server (or all servers if command is issued on core buffer).

    Examples:
      notify when "toto" joins/quits current server:
        /notify add toto
      notify when "toto" joins/quits freenode server:
        /notify add toto freenode
      notify when "toto" is away or back on freenode server:
        /notify add toto freenode -away

- `op`: give channel operator status to nick(s)

    /op  <nick> [<nick>...]
         * -yes

    nick: nick or mask (wildcard "*" is allowed)
       *: give channel operator status to everybody on channel

- `oper`: get operator privileges

    /oper  <user> <password>

        user: user
    password: password

- `part`: leave a channel

    /part  [<channel>[,<channel>...]] [<message>]

    channel: channel name to leave
    message: part message (displayed to other users)

- `ping`: send a ping to server

    /ping  <server1> [<server2>]

    server1: server
    server2: forward ping to this server

- `pong`: answer to a ping message

    /pong  <daemon> [<daemon2>]

     daemon: daemon who has responded to Ping message
    daemon2: forward message to this daemon

- `query`: send a private message to a nick

    /query  [-noswitch] [-server <server>] <nick>[,<nick>...] [<text>]

    -noswitch: do not switch to new buffer
       server: send to this server (internal name)
         nick: nick
         text: text to send

- `quiet`: quiet nicks or hosts

    /quiet  [<channel>] [<nick> [<nick>...]]

    channel: channel name
       nick: nick or host

    Without argument, this command displays the quiet list for current channel.

- `quote`: send raw data to server without parsing

    /quote  [-server <server>] <data>

    server: send to this server (internal name)
      data: raw data to send

- `reconnect`: reconnect to server(s)

    /reconnect  <server> [<server>...] [-nojoin] [-switch]
                -all [-nojoin] [-switch]

     server: server to reconnect (internal name)
       -all: reconnect to all servers
    -nojoin: do not join any channel (even if autojoin is enabled on server)
    -switch: switch to next server address

- `rehash`: tell the server to reload its config file

    /rehash  [<option>]

    option: extra option, for some servers

- `remove`: force a user to leave a channel

    /remove  [<channel>] <nick> [<reason>]

    channel: channel name
       nick: nick
     reason: reason (special variables $nick, $channel and $server are replaced by their value)

- `restart`: tell the server to restart itself

    /restart  [<target>]

    target: server name

- `sajoin`: force a user to join channel(s)

    /sajoin  <nick> <channel>[,<channel>...]

       nick: nick
    channel: channel name

- `samode`: change mode on channel, without having operator status

    /samode  [<channel>] <mode>

    channel: channel name
       mode: mode for channel

- `sanick`: force a user to use another nick

    /sanick  <nick> <new_nick>

        nick: nick
    new_nick: new nick

- `sapart`: force a user to leave channel(s)

    /sapart  <nick> <channel>[,<channel>...]

       nick: nick
    channel: channel name

- `saquit`: force a user to quit server with a reason

    /saquit  <nick> <reason>

      nick: nick
    reason: reason

- `server`: list, add or remove IRC servers

    /server  list|listfull [<server>]
             add <server> <hostname>[/<port>] [-temp] [-<option>[=<value>]] [-no<option>]
             copy|rename <server> <new_name>
             reorder <server> [<server>...]
             del|keep <server>
             deloutq|jump|raw

        list: list servers (without argument, this list is displayed)
    listfull: list servers with detailed info for each server
         add: add a new server
      server: server name, for internal and display use
    hostname: name or IP address of server, with optional port (default: 6667), many addresses can be separated by a comma
       -temp: add a temporary server (not saved)
      option: set option for server (for boolean option, value can be omitted)
    nooption: set boolean option to 'off' (for example: -nossl)
        copy: duplicate a server
      rename: rename a server
     reorder: reorder list of servers
        keep: keep server in config file (for temporary servers only)
         del: delete a server
     deloutq: delete messages out queue for all servers (all messages WeeChat is currently sending)
        jump: jump to server buffer
         raw: open buffer with raw IRC data

    Examples:
      /server listfull
      /server add freenode chat.freenode.net
      /server add freenode chat.freenode.net/6697 -ssl -autoconnect
      /server add chatspike irc.chatspike.net/6667,irc.duckspike.net/6667
      /server copy freenode freenode-test
      /server rename freenode-test freenode2
      /server reorder freenode2 freenode
      /server del freenode
      /server deloutq

- `service`: register a new service

    /service  <nick> <reserved> <distribution> <type> <reserved> <info>

    distribution: visibility of service
            type: reserved for future usage

- `servlist`: list services currently connected to the network

    /servlist  [<mask> [<type>]]

    mask: list only services matching this mask
    type: list only services of this type

- `squery`: deliver a message to a service

    /squery  <service> <text>

    service: name of service
       text: text to send

- `squit`: disconnect server links

    /squit  <server> <comment>

     server: server name
    comment: comment

- `stats`: query statistics about server

    /stats  [<query> [<server>]]

     query: c/h/i/k/l/m/o/y/u (see RFC1459)
    server: server name

- `summon`: give users who are on a host running an IRC server a message asking them to please join IRC

    /summon  <user> [<target> [<channel>]]

       user: username
     target: server name
    channel: channel name

- `time`: query local time from server

    /time  [<target>]

    target: query time from specified server

- `topic`: get/set channel topic

    /topic  [<channel>] [<topic>|-delete]

    channel: channel name
      topic: new topic
    -delete: delete channel topic

- `trace`: find the route to specific server

    /trace  [<target>]

    target: server name

- `unban`: unban nicks or hosts

    /unban  [<channel>] <nick> [<nick>...]

    channel: channel name
       nick: nick or host

- `unquiet`: unquiet nicks or hosts

    /unquiet  [<channel>] <nick> [<nick>...]

    channel: channel name
       nick: nick or host

- `userhost`: return a list of information about nicks

    /userhost  <nick> [<nick>...]

    nick: nick

- `users`: list of users logged into the server

    /users  [<target>]

    target: server name

- `version`: give the version info of nick or server (current or specified)

    /version  [<server>|<nick>]

    server: server name
      nick: nick

- `voice`: give voice to nick(s)

    /voice  <nick> [<nick>...]

    nick: nick or mask (wildcard "*" is allowed)
       *: give voice to everybody on channel

- `wallchops`: send a notice to channel ops

    /wallchops  [<channel>] <text>

    channel: channel name
       text: text to send

- `wallops`: send a message to all currently connected users who have set the 'w' user mode for themselves

    /wallops  <text>

    text: text to send

- `who`: generate a query which returns a list of information

    /who  [<mask> [o]]

    mask: only information which match this mask
       o: only operators are returned according to the mask supplied

- `whois`: query information about user(s)

    /whois  [<server>] [<nick>[,<nick>...]]

    server: server name
      nick: nick (may be a mask)

    Without argument, this command will do a whois on:
    - your own nick if buffer is a server/channel
    - remote nick if buffer is a private.

    If option irc.network.whois_double_nick is enabled, two nicks are sent (if only one nick is given), to get idle time in answer.

- `whowas`: ask for information about a nick which no longer exists

    /whowas  <nick>[,<nick>...] [<count> [<target>]]

      nick: nick
     count: number of replies to return (full search if negative number)
    target: reply should match this mask

#### 4.6.4. SSL certificates

When connecting to IRC server with SSL, WeeChat checks by default that the connection is fully trusted.

Some options are used to control SSL connection:

weechat.network.gnutls_ca_file

  path to file with certificate authorities (by default: "%h/ssl/CAs.pem")

irc.server.xxx.ssl_cert

  SSL certificate file used to automatically identify your nick (for example CertFP on oftc, see below)

irc.server.xxx.ssl_dhkey_size

  size of the key used during the Diffie-Hellman Key Exchange (by default: 2048)

irc.server.xxx.ssl_verify

  check that the SSL connection is fully trusted (on by default)

| Option "ssl_verify" is on by default, so verification is strict and may fail, even if it was OK with versions prior to 0.3.1.

##### First example: connect to oftc and check certificate

- Import certificate in shell:

    $ mkdir -p ~/.weechat/ssl
    $ wget -O ~/.weechat/ssl/CAs.pem http://www.spi-inc.org/ca/spi-cacert.crt

| It is possible to concatenate many certificates in file CAs.pem.

- In WeeChat, with "oftc" server already added:

    /connect oftc

##### Second example: connect to oftc using CertFP

- Create certificate in shell:

    $ mkdir -p ~/.weechat/ssl
    $ cd ~/.weechat/ssl
    $ openssl req -nodes -newkey rsa:2048 -keyout nick.pem -x509 -days 365 -out nick.pem

- In WeeChat, with "oftc" server already added:

    /set irc.server.oftc.ssl_cert "%h/ssl/nick.pem"
    /connect oftc
    /msg nickserv cert add

For more information, look at http://www.oftc.net/oftc/NickServ/CertFP

#### 4.6.5. SASL authentication

WeeChat supports SASL authentication, using different mechanisms:

- plain: plain text password (default)

- ecdsa-nist256p-challenge: challenge with public/private key

- external: client side SSL cert

- dh-blowfish: blowfish encrypted password (insecure, not recommended)

- dh-aes: AES encrypted password (insecure, not recommended)

| The "gcrypt" library is required when compiling WeeChat in order to use "dh-blowfish" and "dh-aes" mechanisms (see dependencies).

Options in servers are:

- sasl_mechanism: mechanism to use (see above)

- sasl_timeout: timeout (in seconds) for authentication

- sasl_fail: action to perform if authentication fails

- sasl_username: username (nick)

- sasl_password: password

- sasl_key: file with ECC private key (for mechanism ecdsa-nist256p-challenge)

##### SASL ECDSA-NIST256P-CHALLENGE

You must generate a private key in order to authentify with the ECDSA-NIST256P-CHALLENGE mechanism (no password is required on connection).

You can generate the key with this command:

    $ openssl ecparam -genkey -name prime256v1 >~/.weechat/ecdsa.pem

Get the public key (encoded as base64) with this command:

    $ openssl ec -noout -text -conv_form compressed -in ~/.weechat/ecdsa.pem | grep '^pub:' -A 3 | tail -n 3 | tr -d ' \n:' | xxd -r -p | base64

Connect to the server, identify (for example with "nickserv identify") and set your public key in your account, using nickserv (replace the base64 value with your public key):

    /connect freenode
    /msg nickserv identify your_password
    /msg nickserv set pubkey Av8k1FOGetUDq7sPMBfufSIZ5c2I/QYWgiwHtNXkVe/q

Configure the SASL options in the server:

    /set irc.server.freenode.sasl_mechanism ecdsa-nist256p-challenge
    /set irc.server.freenode.sasl_username "your_nickname"
    /set irc.server.freenode.sasl_key "%h/ecdsa.pem"

Reconnect to the server:

    /reconnect freenode

#### 4.6.6. Connect to Freenode with TOR/SASL

In addition to SSL, Freenode servers support connections with TOR (https://www.torproject.org/), a network of virtual tunnels that allows people and groups to improve their privacy and security on the Internet.

In first place, install TOR. For Debian (and derived):

    $ sudo apt-get install tor

In WeeChat you need to add a socks5 proxy for TOR service (hostname/IP and port depend on your TOR configuration):

    /proxy add tor socks5 127.0.0.1 9050

Now, add a new server, for example:

    /server add freenode-tor p4fsi4ockecnea7l.onion

Set proxy for TOR:

    /set irc.server.freenode-tor.proxy "tor"

Set SASL authentication:

    /set irc.server.freenode-tor.sasl_username "your_nickname"
    /set irc.server.freenode-tor.sasl_password "your_password"

And finally, connection to server:

    /connect freenode-tor

For more info about Freenode and TOR: http://freenode.net/irc_servers.shtml#tor

#### 4.6.7. Smart filter for join/part/quit messages

A smart filter is available to filter join/part/quit messages when nick did not say something during past X minutes on channel.

Smart filter is enabled by default, but you must add a filter to hide lines on buffers, for example:

    /filter add irc_smart * irc_smart_filter *

It is possible to create filter for one channel only or channels beginning with same name (see `/help filter`):

    /filter add irc_smart_weechat irc.freenode.#weechat irc_smart_filter *
    /filter add irc_smart_weechats irc.freenode.#weechat* irc_smart_filter *

You can hide only join or part/quit with following options:

    /set irc.look.smart_filter_join on
    /set irc.look.smart_filter_quit on

You can setup delay (in minutes):

    /set irc.look.smart_filter_delay 5

If a nick did not speak during last 5 minutes, its join and/or part/quit will be hidden on channel.

#### 4.6.8. CTCP replies

It is possible to customize CTCP replies, or block some CTCP queries (do not reply).

For example, to customize reply to CTCP "VERSION", use following command:

    /set irc.ctcp.version "I'm running WeeChat $version, it rocks!"

If you want to block CTCP "VERSION" (do not reply to a query), then set empty string:

    /set irc.ctcp.version ""

Even unknown CTCP can be customized, for example you can reply to CTCP "BLABLA":

    /set irc.ctcp.blabla "This is my answer to CTCP BLABLA"

It is possible to customize CTCP for one server only, using its internal name before CTCP name:

    /set irc.ctcp.freenode.version "WeeChat $version (for freenode)"

If you want to restore standard CTCP reply, then remove option:

    /unset irc.ctcp.version

Following codes can be used in strings and are automatically expanded by WeeChat when replying to CTCP:

Code | Description | Value/example
--- | --- | ---
    $clientinfo
| List of supported CTCP | `ACTION DCC CLIENTINFO FINGER PING SOURCE TIME USERINFO VERSION`
    $version
| WeeChat version | `0.4.0-dev`
    $versiongit
| WeeChat version + git version (1) | `0.4.0-dev (git: v0.3.9-104-g7eb5cc4)`
    $git
| Git version (1) | `v0.3.9-104-g7eb5cc4`
    $compilation
| WeeChat compilation date | `Dec 16 2012`
    $osinfo
| Info about OS | `Linux 2.6.32-5-amd64 / x86_64`
    $site
| WeeChat site | `https://weechat.org/`
    $download
| WeeChat site, download page | `https://weechat.org/download`
    $time
| Current date/time | `Sun, 16 Dec 2012 10:40:48 +0100`
    $username
| User name on IRC server | `name`
    $realname
| Real name on IRC server | `John Doe`

| (1) The git version is the output of command `git describe`. It is known only if WeeChat has been compiled inside the git repository and if git was installed.

If CTCP options are not defined (by default), CTCP replies are:

CTCP | Reply format | Example
--- | --- | ---
CLIENTINFO | `$clientinfo` | `ACTION DCC CLIENTINFO FINGER PING SOURCE TIME USERINFO VERSION`
FINGER | `WeeChat $versiongit` | `WeeChat 0.4.0-dev (git: v0.3.9-104-g7eb5cc4)`
SOURCE | `$download` | `https://weechat.org/download`
TIME | `$time` | `Sun, 16 Dec 2012 10:40:48 +0100`
USERINFO | `$username ($realname)` | `name (John Doe)`
VERSION | `WeeChat $versiongit ($compilation)` | `WeeChat 0.4.0-dev (git: v0.3.9-104-g7eb5cc4) (Dec 16 2012)`

#### 4.6.9. Target buffer for IRC messages

It is possible to customize target buffer for IRC messages (buffer used to display message) with options `irc.msgbuffer.*`.

For some IRC messages (see list below), you can use value:

current

  current buffer (if it’s IRC buffer, or on server buffer by default)

private

  private buffer for nick, or current/server buffer if not found (according to option irc.look.msgbuffer_fallback)

server

  server buffer

weechat

  WeeChat "core" buffer

When option is not set (default), WeeChat chooses appropriate buffer, commonly server or channel buffer.

Non-comprehensive list of IRC messages or alias that you can customize:

message | alias | description
--- | --- | ---
`error` |  | error
`invite` |  | invited on a channel
`join` |  | join
`kick` |  | kick
`kill` |  | kill
`mode` |  | mode
`notice` |  | notice
`part` |  | part
`quit` |  | quit
`topic` |  | topic
`wallops` |  | wallops
| `ctcp` | ctcp (sent or received, in a privmsg or notice message)
`221` |  | user mode string
`275` | `whois` | whois (secure connection)
`301` | `whois` | whois (away)
`303` |  | ison
`305` | `unaway` | unaway
`306` | `away` | away
`307` | `whois` | whois (registered nick)
`310` | `whois` | whois (help mode)
`311` | `whois` | whois (user)
`312` | `whois` | whois (server)
`313` | `whois` | whois (operator)
`314` | `whowas` | whowas
`315` | `who` | who (end)
`317` | `whois` | whois (idle)
`318` | `whois` | whois (end)
`319` | `whois` | whois (channels)
`320` | `whois` | whois (identified user)
`321` | `list` | list (start)
`322` | `list` | list (channel)
`323` | `list` | list (end)
`326` | `whois` | whois (has oper privs)
`327` | `whois` | whois (host)
`328` |  | channel URL
`329` |  | channel creation date
`330` | `whois` | whois (logged in as)
`331` |  | no topic for channel
`332` |  | topic of channel
`333` |  | infos about topic
`335` | `whois` | whois (is a bot on)
`338` | `whois` | whois (host)
`341` |  | inviting
`343` | `whois` | whois (is opered as)
`344` | `reop` | channel reop
`345` | `reop` | channel reop (end)
`346` | `invitelist` | invite list
`347` | `invitelist` | invite list (end)
`348` | `exceptionlist` | exception list
`349` | `exceptionlist` | exception list (end)
`351` |  | server version
`352` | `who` | who
`353` | `names` | list of users on channel
`366` | `names` | end of /names list
`367` | `banlist` | ban list
`368` | `banlist` | end of ban list
`369` | `whowas` | whowas (end)
`378` | `whois` | whois (connecting from)
`379` | `whois` | whois (using modes)
`401` | `whois` | no such nick/channel
`402` | `whois` | no such server
`432` |  | erroneous nickname
`433` |  | nickname already in use
`438` |  | not authorized to change nickname
`671` | `whois` | whois (secure connection)
`728` | `quietlist` | quiet list
`729` | `quietlist` | end of quiet list
`732` | `monitor` | list of monitored nicks
`733` | `monitor` | list of monitored nicks (end)
`901` |  | you are now logged in

Other numeric commands can be customized as well.

Message can be prefixed by server name to be specific to an irc server (for example: `freenode.whois`).

Some examples:

- Display result of `/whois` on private buffer:

    /set irc.msgbuffer.whois private

- Restore default buffer for whois (server buffer):

    /unset irc.msgbuffer.whois

- Display invitation on current buffer, only for "freenode" server:

    /set irc.msgbuffer.freenode.invite current

- Display message "303" (ison) on WeeChat "core" buffer:

    /set irc.msgbuffer.303 weechat

### 4.7. Logger plugin

The Logger plugin lets you save content of buffers to files, with options about what and how it is saved.

#### 4.7.1. Options (logger.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set logger.look.*` | Look and feel.
`color` | `/set logger.color.*` | Colors.
`file` | `/set logger.file.*` | Options for log files.
`level` | `/set logger.level.*` | Log level by buffer (options can be added/removed in section).
`mask` | `/set logger.mask.*` | Filename mask by buffer (options can be added/removed in section).

Options:

- logger.color.backlog_end

  - description: color for line ending the backlog

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- logger.color.backlog_line

  - description: color for backlog lines

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- logger.file.auto_log

  - description: automatically save content of buffers to files (unless a buffer disables log)

  - type: boolean

  - values: on, off

  - default value: `on`

- logger.file.flush_delay

  - description: number of seconds between flush of log files (0 = write in log files immediately for each line printed)

  - type: integer

  - values: 0 .. 3600

  - default value: `120`

- logger.file.info_lines

  - description: write information line in log file when log starts or ends for a buffer

  - type: boolean

  - values: on, off

  - default value: `off`

- logger.file.mask

  - description: default file name mask for log files (format is "directory/to/file" or "file", without first "/" because "path" option is used to build complete path to file); local buffer variables are permitted (you should use only variables that are defined on all buffers, so for example you should NOT use $server nor $channel); date specifiers are permitted (see man strftime)

  - type: string

  - values: any string

  - default value: `"$plugin.$name.weechatlog"`

- logger.file.name_lower_case

  - description: use only lower case for log filenames

  - type: boolean

  - values: on, off

  - default value: `on`

- logger.file.nick_prefix

  - description: text to write before nick in prefix of message, example: "<"

  - type: string

  - values: any string

  - default value: `""`

- logger.file.nick_suffix

  - description: text to write after nick in prefix of message, example: ">"

  - type: string

  - values: any string

  - default value: `""`

- logger.file.path

  - description: path for WeeChat log files; "%h" at beginning of string is replaced by WeeChat home ("~/.weechat" by default); date specifiers are permitted (see man strftime) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"%h/logs/"`

- logger.file.replacement_char

  - description: replacement char for special chars in filename built with mask (like directory delimiter)

  - type: string

  - values: any string

  - default value: `"_"`

- logger.file.time_format

  - description: timestamp used in log files (see man strftime for date/time specifiers)

  - type: string

  - values: any string

  - default value: `"%Y-%m-%d %H:%M:%S"`

- logger.look.backlog

  - description: maximum number of lines to display from log file when creating new buffer (0 = no backlog)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `20`

#### 4.7.2. Commands

- `logger`: logger plugin configuration

    /logger  list
             set <level>
             flush
             disable

       list: show logging status for opened buffers
        set: set logging level on current buffer
      level: level for messages to be logged (0 = logging disabled, 1 = a few messages (most important) .. 9 = all messages)
      flush: write all log files now
    disable: disable logging on current buffer (set level to 0)

    Options "logger.level.*" and "logger.mask.*" can be used to set level or mask for a buffer, or buffers beginning with name.

    Log levels used by IRC plugin:
      1: user message, notice, private
      2: nick change
      3: server message
      4: join/part/quit
      9: all other messages

    Examples:
      set level to 5 for current buffer:
        /logger set 5
      disable logging for current buffer:
        /logger disable
      set level to 3 for all IRC buffers:
        /set logger.level.irc 3
      disable logging for main WeeChat buffer:
        /set logger.level.core.weechat 0
      use a directory per IRC server and a file per channel inside:
        /set logger.mask.irc "$server/$channel.weechatlog"

#### 4.7.3. Log levels

Logging is made with a level for each buffer. Default level is 9 (log all messages displayed on buffer). You can change level for one buffer, or a group of buffers.

Possible levels are 0 to 9. Zero means "do not log anything" and 9 means "log all messages".

Plugins are using different levels for messages displayed. IRC plugin uses following levels:

- level 1: message from user (on channel or private)

- level 2: nick change (you or someone else)

- level 3: any server message (except join/part/quit)

- level 4: server message join/part/quit

So if you set level 3 for an IRC channel, WeeChat will log all messages, but not join/part/quit.

Some examples:

- Set level 3 for IRC channel #weechat:

    /set logger.level.irc.freenode.#weechat 3

- Set level 3 for freenode server buffer:

    /set logger.level.irc.server.freenode 3

- Set level 3 for all channels on server freenode:

    /set logger.level.irc.freenode 3

- Set level 2 for all IRC buffers:

    /set logger.level.irc 2

#### 4.7.4. Filenames masks

It is possible to define a filename mask for each buffer, and use local buffer variables to build filename. To see local variables for current buffer:

    /buffer localvar

For example, on buffer "irc.freenode.#weechat", WeeChat will search a mask with option name, in this order:

    logger.mask.irc.freenode.#weechat
    logger.mask.irc.freenode
    logger.mask.irc
    logger.file.mask

That means you can have masks specific for some IRC servers ("logger.mask.irc.freenode") or for a plugin ("logger.mask.irc").

##### Log files by date

To have log files by date, you can use date/time specifiers in mask (see `man strftime` for formats), for example:

    /set logger.file.mask "%Y/%m/$plugin.$name.weechatlog"

You’ll have following files:

    ~/.weechat/
        |--- logs/
            |--- 2010/
                |--- 11/
                |       irc.server.freenode.weechatlog
                |       irc.freenode.#weechat.weechatlog
            |--- 2010/
                |--- 12/
                |       irc.server.freenode.weechatlog
                |       irc.freenode.#weechat.weechatlog

##### IRC log files by server and channel

If you want one directory by IRC server and one file by channel inside:

    /set logger.mask.irc "irc/$server/$channel.weechatlog"

You’ll have following files:

    ~/.weechat/
        |--- logs/
            |--- irc/
                |--- freenode/
                |       freenode.weechatlog
                |       #weechat.weechatlog
                |       #mychan.weechatlog
                |--- oftc/
                |       oftc.weechatlog
                |       #chan1.weechatlog
                |       #chan2.weechatlog

### 4.8. Relay plugin

The Relay plugin is used to relay data via network, using different protocols:

- irc: IRC proxy: used to share connections to IRC servers with one or many other IRC clients

- weechat: protocol used by remote interfaces to display and interact with WeeChat (for example QWeeChat or weechat-android)

#### 4.8.1. Options (relay.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set relay.look.*` | Look and feel.
`color` | `/set relay.color.*` | Colors.
`network` | `/set relay.network.*` | Network options.
`irc` | `/set relay.irc.*` | Options specific to irc protocol (irc proxy).
`port` | `/relay add /set relay.port.*` | Ports used for relay (irc and weechat protocols) (options can be added/removed in section).

Options:

- relay.color.client

  - description: text color for client description

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- relay.color.status_active

  - description: text color for "connected" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightblue`

- relay.color.status_auth_failed

  - description: text color for "authentication failed" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- relay.color.status_connecting

  - description: text color for "connecting" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- relay.color.status_disconnected

  - description: text color for "disconnected" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- relay.color.status_waiting_auth

  - description: text color for "waiting authentication" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- relay.color.text

  - description: text color in relay buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- relay.color.text_bg

  - description: background color in relay buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- relay.color.text_selected

  - description: text color of selected line in relay buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- relay.irc.backlog_max_minutes

  - description: maximum number of minutes in backlog per IRC channel (0 = unlimited, examples: 1440 = one day, 10080 = one week, 43200 = one month, 525600 = one year)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `1440`

- relay.irc.backlog_max_number

  - description: maximum number of lines in backlog per IRC channel (0 = unlimited)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `256`

- relay.irc.backlog_since_last_disconnect

  - description: display backlog starting from last client disconnect

  - type: boolean

  - values: on, off

  - default value: `on`

- relay.irc.backlog_since_last_message

  - description: display backlog starting from your last message

  - type: boolean

  - values: on, off

  - default value: `off`

- relay.irc.backlog_tags

  - description: comma-separated list of messages tags which are displayed in backlog per IRC channel (supported tags: "irc_join", "irc_part", "irc_quit", "irc_nick", "irc_privmsg"), "*" = all supported tags

  - type: string

  - values: any string

  - default value: `"irc_privmsg"`

- relay.irc.backlog_time_format

  - description: format for time in backlog messages (see man strftime for format) (not used if server capability "server-time" was enabled by client, because time is sent as irc tag); empty string = disable time in backlog messages

  - type: string

  - values: any string

  - default value: `"[%H:%M] "`

- relay.look.auto_open_buffer

  - description: auto open relay buffer when a new client is connecting

  - type: boolean

  - values: on, off

  - default value: `on`

- relay.look.raw_messages

  - description: number of raw messages to save in memory when raw data buffer is closed (messages will be displayed when opening raw data buffer)

  - type: integer

  - values: 0 .. 65535

  - default value: `256`

- relay.network.allow_empty_password

  - description: allow empty password in relay (it should be enabled only for tests or local network)

  - type: boolean

  - values: on, off

  - default value: `off`

- relay.network.allowed_ips

  - description: POSIX extended regular expression with IPs allowed to use relay (case insensitive, use "(?-i)" at beginning to make it case sensitive), example: "^(123.45.67.89|192.160.*)$"

  - type: string

  - values: any string

  - default value: `""`

- relay.network.bind_address

  - description: address for bind (if empty, connection is possible on all interfaces, use "127.0.0.1" to allow connections from local machine only)

  - type: string

  - values: any string

  - default value: `""`

- relay.network.clients_purge_delay

  - description: delay for purging disconnected clients (in minutes, 0 = purge clients immediately, -1 = never purge)

  - type: integer

  - values: -1 .. 43200

  - default value: `0`

- relay.network.compression_level

  - description: compression level for packets sent to client with WeeChat protocol (0 = disable compression, 1 = low compression ... 9 = best compression)

  - type: integer

  - values: 0 .. 9

  - default value: `6`

- relay.network.ipv6

  - description: listen on IPv6 socket by default (in addition to IPv4 which is default); protocols IPv4 and IPv6 can be forced (individually or together) in the protocol name (see /help relay)

  - type: boolean

  - values: on, off

  - default value: `on`

- relay.network.max_clients

  - description: maximum number of clients connecting to a port (0 = no limit)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `5`

- relay.network.password

  - description: password required by clients to access this relay (empty value means no password required, see option relay.network.allow_empty_password) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `""`

- relay.network.ssl_cert_key

  - description: file with SSL certificate and private key (for serving clients with SSL)

  - type: string

  - values: any string

  - default value: `"%h/ssl/relay.pem"`

- relay.network.ssl_priorities

  - description: string with priorities for gnutls (for syntax, see documentation of function gnutls_priority_init in gnutls manual, common strings are: "PERFORMANCE", "NORMAL", "SECURE128", "SECURE256", "EXPORT", "NONE")

  - type: string

  - values: any string

  - default value: `"NORMAL:-VERS-SSL3.0"`

- relay.network.websocket_allowed_origins

  - description: POSIX extended regular expression with origins allowed in websockets (case insensitive, use "(?-i)" at beginning to make it case sensitive), example: "^http://(www\.)?example\.(com|org)"

  - type: string

  - values: any string

  - default value: `""`

#### 4.8.2. Commands

- `relay`: relay control

    /relay  list|listfull|listrelay
            add <name> <port>
            del|stop|restart <name>
            raw
            sslcertkey

             list: list relay clients (only active relays)
         listfull: list relay clients (verbose, all relays)
        listrelay: list relays (name and port)
              add: add a relay (listen on a port)
              del: remove a relay (clients remain connected)
             stop: close the server socket (clients remain connected)
          restart: close the server socket and listen again on port (clients remain connected)
             name: relay name (see format below)
             port: port used for relay
              raw: open buffer with raw Relay data
       sslcertkey: set SSL certificate/key using path in option relay.network.ssl_cert_key

    Relay name is: [ipv4.][ipv6.][ssl.]<protocol.name>
             ipv4: force use of IPv4
             ipv6: force use of IPv6
              ssl: enable SSL
    protocol.name: protocol and name to relay:
                     - protocol "irc": name is the server to share (optional, if not given, the server name must be sent by client in command "PASS", with format: "PASS server:password")
                     - protocol "weechat" (name is not used)

    The "irc" protocol allows any IRC client (including WeeChat itself) to connect on the port.
    The "weechat" protocol allows a remote interface to connect on the port, see the list here: https://weechat.org/download/

    Without argument, this command opens buffer with list of relay clients.

    Examples:
      irc proxy, for server "freenode":
        /relay add irc.freenode 8000
      irc proxy, for server "freenode", with SSL:
        /relay add ssl.irc.freenode 8001
      irc proxy, for all servers (client will choose), with SSL:
        /relay add ssl.irc 8002
      weechat protocol:
        /relay add weechat 9000
      weechat protocol with SSL:
        /relay add ssl.weechat 9001
      weechat protocol with SSL, using only IPv4:
        /relay add ipv4.ssl.weechat 9001
      weechat protocol with SSL, using only IPv6:
        /relay add ipv6.ssl.weechat 9001
      weechat protocol with SSL, using IPv4 + IPv6:
        /relay add ipv4.ipv6.ssl.weechat 9001

#### 4.8.3. Password

It is highly recommended to set a password for relay, with command:

    /set relay.network.password "mypassword"

This password is used for irc and weechat protocols.

#### 4.8.4. SSL

You can use SSL by creating a certificate and private key, and by using prefix "ssl." in the name of protocol.

The default file for certificate/key is ~/.weechat/ssl/relay.pem (option relay.network.ssl_cert_key).

You can create a certificate and private key with following commands:

    $ mkdir -p ~/.weechat/ssl
    $ cd ~/.weechat/ssl
    $ openssl req -nodes -newkey rsa:2048 -keyout relay.pem -x509 -days 365 -out relay.pem

If WeeChat is already running, you can reload the certificate and private key with command:

    /relay sslcertkey

#### 4.8.5. IRC proxy

The Relay plugin can act as an IRC proxy: it will simulate an IRC server, and you can connect to WeeChat with any other IRC client (including WeeChat itself).

You can define one port by IRC server, or one generic port for all servers.

When using one port for all servers, the client must send the internal name of server in the IRC "PASS" command, with this format:

    PASS server:password

Example: IRC proxy with SSL for any server (client will choose):

    /relay add ssl.irc 8000

Example: IRC proxy without SSL only for server "freenode":

    /relay add irc.freenode 8000

Now you can connect on port 8000 with any IRC client using server password "mypassword" (or "freenode:mypassword" if no server was specified in the relay).

#### 4.8.6. WeeChat protocol

The Relay plugin can send data to remote interface using WeeChat protocol.

You can connect with a remote interface, see the list on download page: https://weechat.org/download

| WeeChat itself can NOT connect to another WeeChat with this protocol.

For example:

    /relay add weechat 9000

Now you can connect on port 9000 with a remote interface using password "mypassword".

#### 4.8.7. WebSocket

WebSocket protocol (RFC 6455) is supported in Relay plugin for all protocols.

The WebSocket handshake is automatically detected and socket becomes ready for WebSocket if required headers are found in handshake and if origin is allowed (see option relay.network.websocket_allowed_origins).

A WebSocket can be opened in a HTML5 with a single line of JavaScript:

    websocket = new WebSocket("ws://server.com:9000/weechat");

The port (9000 in example) is the port defined in Relay plugin. The URI must always end with "/weechat" (for irc and weechat protocols).

### 4.9. Scripts plugins

WeeChat provides 7 scripting plugins: Python, Perl, Ruby, Lua, Tcl, Guile (scheme) and Javascript. These plugins can load, execute and unload scripts for these languages.

Another plugin called "script" is a scripts manager and is used to load/unload scripts of any language, and install/remove scripts of WeeChat scripts repository, which are visible at this URL: https://weechat.org/scripts

For more information about how to write scripts, or WeeChat API for scripts, please read WeeChat Scripting Guide.

#### 4.9.1. Script options (script.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set script.look.*` | Look and feel.
`color` | `/set script.color.*` | Colors.
`scripts` | `/set script.scripts.*` | Options for download of scripts.

Options:

- script.color.status_autoloaded

  - description: color for status "autoloaded" ("a")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- script.color.status_held

  - description: color for status "held" ("H")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.status_installed

  - description: color for status "installed" ("i")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- script.color.status_obsolete

  - description: color for status "obsolete" ("N")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- script.color.status_popular

  - description: color for status "popular" ("*")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- script.color.status_running

  - description: color for status "running" ("r")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- script.color.status_unknown

  - description: color for status "unknown" ("?")

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- script.color.text

  - description: text color in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_bg

  - description: background color in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_bg_selected

  - description: background color for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `red`

- script.color.text_date

  - description: text color of dates in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_date_selected

  - description: text color of dates for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.text_delimiters

  - description: text color of delimiters in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_description

  - description: text color of description in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_description_selected

  - description: text color of description for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.text_extension

  - description: text color of extension in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_extension_selected

  - description: text color of extension for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.text_name

  - description: text color of script name in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- script.color.text_name_selected

  - description: text color of script name for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- script.color.text_selected

  - description: text color for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.text_tags

  - description: text color of tags in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `brown`

- script.color.text_tags_selected

  - description: text color of tags for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- script.color.text_version

  - description: text color of version in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `magenta`

- script.color.text_version_loaded

  - description: text color of version loaded in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- script.color.text_version_loaded_selected

  - description: text color of version loaded for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- script.color.text_version_selected

  - description: text color of version for selected line in script buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- script.look.columns

  - description: format of columns displayed in script buffer: following column identifiers are replaced by their value: %a=author, %d=description, %D=date added, %e=extension, %l=language, %L=license, %n=name with extension, %N=name, %r=requirements, %s=status, %t=tags, %u=date updated, %v=version, %V=version loaded, %w=min_weechat, %W=max_weechat)

  - type: string

  - values: any string

  - default value: `"%s %n %V %v %u | %d | %t"`

- script.look.diff_color

  - description: colorize output of diff

  - type: boolean

  - values: on, off

  - default value: `on`

- script.look.diff_command

  - description: command used to show differences between script installed and the new version in repository ("auto" = auto detect diff command (git or diff), empty value = disable diff, other string = name of command, for example "diff")

  - type: string

  - values: any string

  - default value: `"auto"`

- script.look.display_source

  - description: display source code of script on buffer with detail on a script (script is downloaded in a temporary file when detail on script is displayed)

  - type: boolean

  - values: on, off

  - default value: `on`

- script.look.quiet_actions

  - description: quiet actions on script buffer: do not display messages on core buffer when scripts are installed/removed/loaded/unloaded (only errors are displayed)

  - type: boolean

  - values: on, off

  - default value: `on`

- script.look.sort

  - description: default sort keys for scripts: comma-separated list of identifiers: a=author, A=autoloaded, d=date added, e=extension, i=installed, l=language, n=name, o=obsolete, p=popularity, r=running, u=date updated; char "-" can be used before identifier to reverse order; example: "i,u": installed scripts first, sorted by update date

  - type: string

  - values: any string

  - default value: `"p,n"`

- script.look.translate_description

  - description: translate description of scripts (if translation is available in your language, otherwise English version is used)

  - type: boolean

  - values: on, off

  - default value: `on`

- script.look.use_keys

  - description: use keys alt+X in script buffer to do actions on scripts (alt+i = install, alt+r = remove, ...); if disabled, only the input is allowed: i, r, ...

  - type: boolean

  - values: on, off

  - default value: `on`

- script.scripts.autoload

  - description: autoload scripts installed (make a link in "autoload" directory to script in parent directory)

  - type: boolean

  - values: on, off

  - default value: `on`

- script.scripts.cache_expire

  - description: local cache expiration time, in minutes (-1 = never expires, 0 = always expire)

  - type: integer

  - values: -1 .. 525600

  - default value: `1440`

- script.scripts.download_timeout

  - description: timeout (in seconds) for download of scripts and list of scripts

  - type: integer

  - values: 1 .. 3600

  - default value: `30`

- script.scripts.hold

  - description: scripts to "hold": comma-separated list of scripts which will never been upgraded and can not be removed, for example: "buffers.pl,iset.pl"

  - type: string

  - values: any string

  - default value: `""`

- script.scripts.path

  - description: local cache directory for scripts; "%h" at beginning of string is replaced by WeeChat home ("~/.weechat" by default) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"%h/script"`

- script.scripts.url

  - description: URL for file with list of scripts; by default HTTPS is forced, see option script.scripts.url_force_https

  - type: string

  - values: any string

  - default value: `"http://weechat.org/files/plugins.xml.gz"`

- script.scripts.url_force_https

  - description: force use of HTTPS for downloads (index and scripts); you should disable this option only if you have problems with the downloads

  - type: boolean

  - values: on, off

  - default value: `on`

#### 4.9.2. Script commands

- `script`: WeeChat scripts manager

    /script  list [-o|-i]
             search <text>
             show <script>
             load|unload|reload <script> [<script>...]
             autoload|noautoload|toggleautoload <script> [<script>...]
             install|remove|installremove|hold [-q] <script> [<script>...]
             upgrade
             update

              list: list loaded scripts (all languages)
                -o: send list of loaded scripts to buffer
                -i: copy list of loaded scripts in command line (for sending to buffer)
            search: search scripts by tags, language (python, perl, ...), filename extension (py, pl, ...) or text; result is displayed on scripts buffer
              show: show detailed info about a script
              load: load script(s)
            unload: unload script(s)
            reload: reload script(s)
          autoload: autoload the script
        noautoload: do not autoload the script
    toggleautoload: toggle autoload
           install: install/upgrade script(s)
            remove: remove script(s)
     installremove: install or remove script(s), depending on current state
              hold: hold/unhold script(s) (a script held will not be upgraded any more and cannot be removed)
                -q: quiet mode: do not display messages
           upgrade: upgrade all installed scripts which are obsolete (new version available)
            update: update local scripts cache

    Without argument, this command opens a buffer with list of scripts.

    On script buffer, the possible status for each script are:
      * i a H r N
      | | | | | |
      | | | | | obsolete (new version available)
      | | | | running (loaded)
      | | | held
      | | autoloaded
      | installed
      popular script

    Keys on script buffer:
      alt+i  install script
      alt+r  remove script
      alt+l  load script
      alt+L  reload script
      alt+u  unload script
      alt+A  autoload script
      alt+h  (un)hold script
      alt+v  view script

    Input allowed on script buffer:
      i/r/l/L/u/h  action on script (same as keys above)
      q            close buffer
      $            refresh buffer
      s:x,y        sort buffer using keys x and y (see /help script.look.sort)
      s:           reset sort (use default sort)
      word(s)      filter scripts: search word(s) in scripts (description, tags, ...)
      *            remove filter

    Mouse actions on script buffer:
      wheel         scroll list
      left button   select script
      right button  install/remove script

    Examples:
      /script search url
      /script install iset.pl buffers.pl
      /script remove iset.pl
      /script hold urlserver.py
      /script reload urlserver
      /script upgrade

#### 4.9.3. Python commands

- `python`: list/load/unload scripts

    /python  list|listfull [<name>]
             load [-q] <filename>
             autoload
             reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.4. Perl commands

- `perl`: list/load/unload scripts

    /perl  list|listfull [<name>]
           load [-q] <filename>
           autoload
           reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.5. Ruby commands

- `ruby`: list/load/unload scripts

    /ruby  list|listfull [<name>]
           load [-q] <filename>
           autoload
           reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.6. Lua commands

- `lua`: list/load/unload scripts

    /lua  list|listfull [<name>]
          load [-q] <filename>
          autoload
          reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.7. Tcl commands

- `tcl`: list/load/unload scripts

    /tcl  list|listfull [<name>]
          load [-q] <filename>
          autoload
          reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.8. Guile commands

- `guile`: list/load/unload scripts

    /guile  list|listfull [<name>]
            load [-q] <filename>
            autoload
            reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

#### 4.9.9. Javascript commands

- `javascript`: list/load/unload scripts

    /javascript  list|listfull [<name>]
                 load [-q] <filename>
                 autoload
                 reload|unload [-q] [<name>]

        list: list loaded scripts
    listfull: list loaded scripts (verbose)
        load: load a script
    autoload: load all scripts in "autoload" directory
      reload: reload a script (if no name given, unload all scripts, then load all scripts in "autoload" directory)
      unload: unload a script (if no name given, unload all scripts)
    filename: script (file) to load
        name: a script name (name used in call to "register" function)
          -q: quiet mode: do not display messages

    Without argument, this command lists all loaded scripts.

### 4.10. Trigger plugin

Trigger is the Swiss Army knife for WeeChat: it can hook many things (signal, modifier, print, …​), change the content of data, and execute one or more commands. A condition can be used to prevent the trigger to run in some circumstances.

Using triggers require you to know how the signals, modifiers, …​ are working. So you might consider reading the Hooks chapter in the WeeChat Plugin API Reference.

#### 4.10.1. Options (trigger.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set trigger.look.*` | Look and feel.
`color` | `/set trigger.color.*` | Colors.
`trigger` | `/trigger add /trigger set /set trigger.trigger.*` | Trigger options.

Options:

- trigger.color.flag_command

  - description: text color for command flag (in /trigger list)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- trigger.color.flag_conditions

  - description: text color for conditions flag (in /trigger list)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- trigger.color.flag_post_action

  - description: text color for post action flag (in /trigger list)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightblue`

- trigger.color.flag_regex

  - description: text color for regex flag (in /trigger list)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- trigger.color.flag_return_code

  - description: text color for return code flag (in /trigger list)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightmagenta`

- trigger.color.regex

  - description: text color for regular expressions

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- trigger.color.replace

  - description: text color for replacement text (for regular expressions)

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `cyan`

- trigger.color.trigger

  - description: text color for trigger name

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `green`

- trigger.color.trigger_disabled

  - description: text color for disabled trigger name

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `red`

- trigger.look.enabled

  - description: enable trigger support

  - type: boolean

  - values: on, off

  - default value: `on`

- trigger.look.monitor_strip_colors

  - description: strip colors in hashtable values displayed on monitor buffer

  - type: boolean

  - values: on, off

  - default value: `off`

#### 4.10.2. Commands

- `trigger`: manage triggers, the Swiss Army knife for WeeChat

    /trigger  list|listfull|listdefault
              add|addoff|addreplace <name> <hook> ["<arguments>" ["<conditions>" ["<regex>" ["<command>" ["<return_code>" ["<post_action>"]]]]]]
              addinput [<hook>]
              input|output|recreate <name>
              set <name> <option> <value>
              rename|copy <name> <new_name>
              enable|disable|toggle [<name>|-all [<name>...]]
              restart <name>|-all [<name>...]
              show <name>
              del <name>|-all [<name>...]
              restore <name> [<name>...]
              default -yes
              monitor [<filter>]

           list: list triggers (without argument, this list is displayed)
       listfull: list triggers with detailed info for each trigger
    listdefault: list default triggers
            add: add a trigger
         addoff: add a trigger (disabled)
     addreplace: add or replace an existing trigger
           name: name of trigger
           hook: signal, hsignal, modifier, print, command, command_run, timer, config, focus
      arguments: arguments for the hook, depending on hook (separated by semicolons):
                 signal: name(s) of signal (required)
                 hsignal: name(s) of hsignal (required)
                 modifier: name(s) of modifier (required)
                 print: buffer, tags, message, strip colors
                 command: command (required), description, arguments, description of arguments, completion
                 command_run: command(s) (required)
                 timer: interval (required), align on second, max calls
                 config: name(s) of option (required)
                 focus: name(s) of area (required)
     conditions: evaluated conditions for the trigger
          regex: one or more regular expressions to replace strings in variables
        command: command to execute (many commands can be separated by ";"
    return_code: return code in callback (ok (default), ok_eat, error)
    post_action: action to take after execution (none (default), disable, delete)
       addinput: set input with default arguments to create a trigger
          input: set input with the command used to create the trigger
         output: send the command to create the trigger on the buffer
       recreate: same as "input", with option "addreplace" instead of "add"
            set: set an option in a trigger
         option: name of option: name, hook, arguments, conditions, regex, command, return_code
                 (for help on option, you can type: /help trigger.trigger.<name>.<option>)
          value: new value for the option
         rename: rename a trigger
           copy: copy a trigger
         enable: enable trigger(s) (without arguments: enable triggers globally)
        disable: disable trigger(s) (without arguments: disable triggers globally)
         toggle: toggle trigger(s) (without arguments: toggle triggers globally)
        restart: restart trigger(s) (recreate the hooks)
           show: show detailed info on a trigger (with some stats)
            del: delete a trigger
           -all: do action on all triggers
        restore: restore trigger(s) with the default values (works only for default triggers)
        default: delete all triggers and restore default ones
        monitor: open the trigger monitor buffer, with optional filter:
         filter: filter hooks/triggers to display (a hook must start with "@", for example "@signal"), many filters can be separated by commas; wildcard "*" is allowed in each trigger name

    When a trigger callback is called, following actions are performed, in this order:
      1. check conditions; if false, exit
      2. replace text using POSIX extended regular expression(s) (if defined in trigger)
      3. execute command(s) (if defined in trigger)
      4. exit with a return code (except for modifiers and focus)
      5. perform post action

    Examples (you can also look at default triggers with /trigger listdefault):
      add text attributes *bold*, _underline_ and /italic/ (only in user messages):
        /trigger add effects modifier weechat_print "${tg_tag_nick}" "==\*(\S+)\*==*${color:bold}${re:1}${color:-bold}*== ==_(\S+)_==_${color:underline}${re:1}${color:-underline}_== ==/(\S+)/==/${color:italic}${re:1}${color:-italic}/"
      hide nicklist bar on small terminals:
        /trigger add resize_small signal signal_sigwinch "${info:term_width} < 100" "" "/bar hide nicklist"
        /trigger add resize_big signal signal_sigwinch "${info:term_width} >= 100" "" "/bar show nicklist"
      silently save config each hour:
        /trigger add cfgsave timer 3600000;0;0 "" "" "/mute /save"
      open trigger monitor and show only modifiers and triggers whose name starts with "resize":
        /trigger monitor @modifier,resize*

#### 4.10.3. Anatomy of a trigger

A trigger has the following options (names are `trigger.trigger.<name>.<option>`):

Option | Values | Description
--- | --- | ---
`enabled` | `on`, `off` | When option is `off`, the trigger is disabled and actions are not executed any more.
`hook` | `signal`, `hsignal`, `modifier`, `print`, `command`, `command_run`, `timer`, `config`, `focus` | The hook used in trigger. For more information, see WeeChat Plugin API Reference, chapter Hooks.
`arguments` | string | The arguments for the hook, it depends on the hook type used.
`conditions` | string | Conditions to execute the trigger; they are evaluated (see command /eval).
`regex` | string | One or more POSIX extended regular expressions, to change data received in the hook callback (and some stuff added by trigger plugin), see regular expression.
`command` | string | Command to execute (many commands can be separated by semicolons); it is evaluated (see command /eval).
`return_code` | `ok`, `ok_eat`, `error` | The return code of callback (default is `ok`, which should be used in almost all triggers, the other values are rarely used).
`post_action` | `none`, `disable`, `delete` | Action to take on the trigger after execution (default is `none` which should be used in almost all triggers, the other values are rarely used).

For example, the default beep trigger has following options:

    trigger.trigger.beep.enabled = on
    trigger.trigger.beep.hook = print
    trigger.trigger.beep.arguments = ""
    trigger.trigger.beep.conditions = "${tg_highlight} || ${tg_msg_pv}"
    trigger.trigger.beep.regex = ""
    trigger.trigger.beep.command = "/print -beep"
    trigger.trigger.beep.return_code = ok
    trigger.trigger.beep.post_action = none

#### 4.10.4. Execution

When a trigger callback is called, following actions are executed, in this order, if triggers are globally enabled and if the trigger itself is enabled:

1. check trigger conditions: if false, exit

2. replace text in trigger using regular expression(s)

3. execute command(s)

4. exit with a return code (except for hooks modifier and focus)

5. perform post action (if different from `none`).

#### 4.10.5. Hook arguments

The arguments depend on the hook used. They are separated by semicolons.

Hook | Arguments | Examples
--- | --- | ---
signal | 1. signal name (priority allowed) (required) 2. signal name (priority allowed) 3. …​ | `*,irc_in_privmsg` `*,irc_in_privmsg;*,irc_in_notice` `signal_sigwinch`
hsignal | 1. signal name (priority allowed) (required) 2. signal name (priority allowed) 3. …​ | `nicklist_nick_added`
modifier | 1. modifier name (priority allowed) (required) 2. modifier name (priority allowed) 3. …​ | `weechat_print` `5000|input_text_display;5000|history_add`
print | 1. buffer name 2. tags 3. message 4. strip colors (0/1) | `irc.freenode.*` `irc.freenode.#weechat` `irc.freenode.#weechat;irc_notice` `*;;;1`
command | 1. command name (priority allowed) (required) 2. description 3. arguments 4. description of arguments 5. completion | `test` `5000|test`
command_run | 1. command (priority allowed) (required) 2. command (priority allowed) 3. …​ | `/cmd arguments`
timer | 1. interval in milliseconds (required) 2. alignment on second (default: 0) 3. max number of calls (default: 0, which means "no end") | `3600000` `60000;0;5`
config | 1. option name (priority allowed) (required) 2. option name (priority allowed) 3. …​ | `weechat.look.*`
focus | 1. area name (priority allowed) (required) 2. area name (priority allowed) 3. …​ | `buffer_nicklist`

#### 4.10.6. Conditions

The conditions are used to continue processing in trigger, or stop everything.

They are evaluated, and data available in callback can be used (see data in callbacks and command /eval).

Example: the default beep trigger uses this condition to make a beep only on highlight or private message:

    ${tg_highlight} || ${tg_msg_pv}

#### 4.10.7. Regular expression

The regular expression is used to change variables in callback hashtable.

The format is: "/regex/replace" or "/regex/replace/var" (where var is a variable of the hashtable).
If var is not specified, the default variable is used, it depends on hook type:

Hook | Default variable
--- | ---
signal | `tg_signal_data`
hsignal |
modifier | `tg_string`
print | `tg_message`
command | `tg_argv_eol1`
command_run | `tg_command`
timer | `tg_remaining_calls`
config | `tg_value`
focus |

Many regular expressions can be separated by a space, for example: "/regex1/replace1/var1 /regex2/replace2/var2".

The char "/" can be replaced by any char (one or more identical chars).

Matching groups can be used in "replace":

- `${re:0}` to `${re:99}`: `${re:0}` is the whole match, `${re:1}` to `${re:99}` are groups captured

- `${re:}+`: the last match (with highest number)

- `${hide:c,${re:N}}`: match "N" with all chars replaced by "c" (example: `${hide:*,${re:2}}` is the group #2 with all chars replaced by `*`).

Example: use bold for words between "*":

    /\*(\S+)\*/*${color:bold}${re:1}${color:-bold}*/

Example: default trigger server_pass uses this regular expression to hide password in commands `/server` and `/connect` (chars in passwords are replaced by `*`):

    ==^(/(server|connect) .*-(sasl_)?password=)(\S+)(.*)==${re:1}${hide:*,${re:4}}${re:5}

| In this example, the delimiter used is "==" because there is a "/" in the regular expression.

#### 4.10.8. Command

The command is executed after replacement of text with the regular expression. Many commands can be separated by semicolons.

It is evaluated (see command /eval) and text replaced with a regular expression can be used in the command.

Example: default beep trigger uses this command to make a beep (BEL):

    /print -beep

#### 4.10.9. Data in callbacks

Data received in callbacks are stored in hashtables (pointers and strings) and can be used in following options:

- conditions

- regex

- command

The content of hashtables depend on the hook type.

A convenient way to see data in a trigger is to open trigger monitor buffer, using the command:

    /trigger monitor

##### Signal

The "signal" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`tg_signal` | string | Name of signal
`tg_signal_data` | string | Data sent with the signal

If the signal contains an IRC message, the message is parsed and following data is added in hashtable:

Variable | Type | Description
--- | --- | ---
`server` | string | Name of server (example: "freenode").
`tags` | string | Tags in message (rarely used).
`message_without_tags` | string | Message without tags.
`nick` | string | Nick.
`host` | string | Hostname.
`command` | string | IRC command (example: "PRIVMSG", "NOTICE", …​).
`channel` | string | IRC channel.
`arguments` | string | Arguments of command (includes value of channel).
`text` | string | Text (for example user message).
`pos_command` | string | The index of command in message ("-1" if command was not found).
`pos_arguments` | string | The index of arguments in message ("-1" if arguments was not found).
`pos_channel` | string | The index of channel in message ("-1" if channel was not found).
`pos_text` | string | The index of text in message ("-1" if text was not found).

When the data is a pointer, the variable `tg_signal_data` can be used like this to read a hdata property (in this example this is a pointer on a buffer):

    ${buffer[${tg_signal_data}].full_name}

##### Hsignal

The "hsignal" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`tg_signal` | string | Name of signal

The hashtable contains all keys/values from hashtable received (type: string/string).

##### Modifier

The "modifier" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`tg_modifier` | string | Name of modifier.
`tg_modifier_data` | string | Data sent with modifier.
`tg_string` | string | The string that can be modified.
`tg_string_nocolor` | string | The string without color codes.

For the weechat_print modifier, variables using message tags are added (see hook print below), and following variables:

Variable | Type | Description
--- | --- | ---
`buffer` | pointer | Buffer where message is printed.
`tg_plugin` | string | Plugin of buffer where message is printed.
`tg_buffer` | string | Full name of buffer where message is printed.
`tg_prefix` | string | Prefix of message printed.
`tg_prefix_nocolor` | string | Prefix without color codes.
`tg_message` | string | Message printed.
`tg_message_nocolor` | string | Message without color codes.

If the modifier contains an IRC message, the message is parsed and extra data is added in hashtable (see hook signal).

##### Print

The "print" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`buffer` | pointer | Buffer.
`tg_date` | string | Message date/time (format: `YYYY-MM-DD hh:mm:ss`).
`tg_displayed` | string | "1" if displayed, "0" if line filtered.
`tg_highlight` | string | "1" if highlight, otherwise "0".
`tg_prefix` | string | Prefix.
`tg_prefix_nocolor` | string | Prefix without color codes.
`tg_message` | string | Message.
`tg_message_nocolor` | string | Message without color codes.

Variables set using tags in message (they are set in modifier weechat_print too):

Variable | Type | Description
--- | --- | ---
`tg_tags` | string | Tags of message (with comma added at beginning/end of string).
`tg_tags_count` | string | Number of tags in message.
`tg_tag_nick` | string | Nick (from tag "nick_xxx").
`tg_tag_prefix_nick` | string | Color of nick in prefix (from tag "prefix_nick_ccc").
`tg_tag_host` | string | User name and host, format: username@host (from tag "host_xxx").
`tg_tag_notify` | string | Notify level (none, message, private, highlight).
`tg_notify` | string | Notify level, if different from none.
`tg_msg_pv` | string | "1" for a private message, otherwise "0".

##### Command

The "command" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`buffer` | pointer | Buffer.
`tg_argvN` | string | Argument #N.
`tg_argv_eolN` | string | From argument #N until end of arguments.

##### Command_run

The "command_run" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`buffer` | pointer | Buffer.
`tg_command` | string | Command executed.

##### Timer

The "timer" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`tg_remaining_calls` | string | Number of remaining calls.
`tg_date` | string | Current date/time (format: `YYYY-MM-DD hh:mm:ss`).

##### Config

The "config" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`tg_option` | string | Option.
`tg_value` | string | Value.

##### Focus

The "focus" callback sets following variables in hashtable:

Variable | Type | Description
--- | --- | ---
`window` | pointer | Window.
`buffer` | pointer | Buffer.

The hashtable contains all keys/values from hashtable received (type: string/string).

#### 4.10.10. Examples

##### Color for URLs

Display URLs in green:

    /trigger add url_color modifier weechat_print "${tg_notify}" "==\S+://\S+==${color:green}${re:0}${color:reset}=="

| The simple regex used to detect URL may not catch well all URLs, but it is faster than a complex regex.

##### Auto pong on ping queries

When someone sends a "ping" in a private buffer, this trigger will auto-reply with `pong`:

    /trigger add pong print "" "${type} == private && ${tg_message} == ping" "" "pong"

##### Responsive layout

Following triggers can be used to customize things displayed when the size of terminal is changed:

    /trigger add resize_small signal signal_sigwinch "${info:term_width} < 100" "" "/bar hide nicklist"
    /trigger add resize_big signal signal_sigwinch "${info:term_width} >= 100" "" "/bar show nicklist"

The triggers catch the signal "signal_sigwinch", which is sent by WeeChat when signal SIGWINCH is received (when terminal size is changed).

The condition with `${info:term_width}` checks the width of terminal (you can also use `${info:term_height}` if needed).

In the example, when the terminal becomes small, the nicklist is hidden. And the bar is restored when the width is greater or equal to 100 chars.

##### Automatic save of configuration

You can automatically save configuration files (`*.conf`), for example each hour:

    /trigger add cfgsave timer 3600000;0;0 "" "" "/mute /save"

Arguments for the timer hook are:

- 3600000: 3600 * 1000 milliseconds, the callback is called each hour

- 0: alignment on second (not aligned here)

- 0: max number of calls (0 = no end for the timer)

The command `/mute /save` will silently save configuration files (nothing displayed on core buffer).

### 4.11. Xfer plugin

Xfer plugin brings:

- direct chat (between two hosts, without server): for example "DCC Chat" via IRC plugin

- file transfer, for example "DCC" via IRC plugin

#### 4.11.1. Options (xfer.conf)

Sections:

Section | Control command | Description
--- | --- | ---
`look` | `/set xfer.look.*` | Look and feel.
`color` | `/set xfer.color.*` | Colors.
`network` | `/set xfer.network.*` | Network options.
`file` | `/set xfer.file.*` | Options for files sent/received.

Options:

- xfer.color.status_aborted

  - description: text color for "aborted" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- xfer.color.status_active

  - description: text color for "active" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightblue`

- xfer.color.status_connecting

  - description: text color for "connecting" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `yellow`

- xfer.color.status_done

  - description: text color for "done" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightgreen`

- xfer.color.status_failed

  - description: text color for "failed" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightred`

- xfer.color.status_waiting

  - description: text color for "waiting" status

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `lightcyan`

- xfer.color.text

  - description: text color in xfer buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- xfer.color.text_bg

  - description: background color in xfer buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `default`

- xfer.color.text_selected

  - description: text color of selected line in xfer buffer

  - type: color

  - values: a WeeChat color name (default, black, (dark)gray, white, (light)red, (light)green, brown, yellow, (light)blue, (light)magenta, (light)cyan), a terminal color number or an alias; attributes are allowed before color (for text color only, not background): "*" for bold, "!" for reverse, "/" for italic, "_" for underline

  - default value: `white`

- xfer.file.auto_accept_chats

  - description: automatically accept chat requests (use carefully!)

  - type: boolean

  - values: on, off

  - default value: `off`

- xfer.file.auto_accept_files

  - description: automatically accept incoming files (use carefully!)

  - type: boolean

  - values: on, off

  - default value: `off`

- xfer.file.auto_accept_nicks

  - description: comma-separated list of nicks for which the incoming files and chats are automatically accepted; format is "server.nick" (for a specific server) or "nick" (for all servers); example: "freenode.FlashCode,andrew"

  - type: string

  - values: any string

  - default value: `""`

- xfer.file.auto_check_crc32

  - description: automatically check CRC32 file checksum if it is found in the filename (8 hexadecimal chars)

  - type: boolean

  - values: on, off

  - default value: `off`

- xfer.file.auto_rename

  - description: rename incoming files if already exists (add ".1", ".2", ...)

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.file.auto_resume

  - description: automatically resume file transfer if connection with remote host is lost

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.file.convert_spaces

  - description: convert spaces to underscores when sending and receiving files

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.file.download_path

  - description: path for writing incoming files: "%h" at beginning of string is replaced by WeeChat home ("~/.weechat" by default) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"%h/xfer"`

- xfer.file.upload_path

  - description: path for reading files when sending (when no path is specified by user): "%h" at beginning of string is replaced by WeeChat home ("~/.weechat" by default) (note: content is evaluated, see /help eval)

  - type: string

  - values: any string

  - default value: `"~"`

- xfer.file.use_nick_in_filename

  - description: use remote nick as prefix in local filename when receiving a file

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.look.auto_open_buffer

  - description: auto open xfer buffer when a new xfer is added to list

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.look.progress_bar_size

  - description: size of progress bar, in chars (if 0, progress bar is disabled)

  - type: integer

  - values: 0 .. 256

  - default value: `20`

- xfer.look.pv_tags

  - description: comma separated list of tags used in private messages, for example: "notify_message", "notify_private" or "notify_highlight"

  - type: string

  - values: any string

  - default value: `"notify_private"`

- xfer.network.blocksize

  - description: block size for sending packets, in bytes

  - type: integer

  - values: 1024 .. 102400

  - default value: `65536`

- xfer.network.fast_send

  - description: does not wait for ACK when sending file

  - type: boolean

  - values: on, off

  - default value: `on`

- xfer.network.own_ip

  - description: IP or DNS address used for sending files/chats (if empty, local interface IP is used)

  - type: string

  - values: any string

  - default value: `""`

- xfer.network.port_range

  - description: restricts outgoing files/chats to use only ports in the given range (useful for NAT) (syntax: a single port, ie. 5000 or a port range, ie. 5000-5015, empty value means any port, it's recommended to use ports greater than 1024, because only root can use ports below 1024)

  - type: string

  - values: any string

  - default value: `""`

- xfer.network.speed_limit

  - description: speed limit for sending files, in kilo-bytes by second (0 means no limit)

  - type: integer

  - values: 0 .. 2147483647

  - default value: `0`

- xfer.network.timeout

  - description: timeout for xfer request (in seconds)

  - type: integer

  - values: 5 .. 2147483647

  - default value: `300`

#### 4.11.2. Commands

- `me`: send a CTCP action to remote host

    /me  <message>

    message: message to send

- `xfer`: xfer control

    /xfer  [list|listfull]

        list: list xfer
    listfull: list xfer (verbose)

    Without argument, this command opens buffer with xfer list.

## 5. Support

Before asking for support, be sure you’ve read documentation and FAQ provided with WeeChat.

For support with IRC, on server chat.freenode.net:

- official channels (with developers):

  - #weechat (English)

  - #weechat-fr (French)

- non-official channels:

  - #weechat-de (German)

For other ways of support, see: https://weechat.org/dev/support